<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'activateTelephonyScratchCardsRequestImpl' => '\\StructType\\ActivateTelephonyScratchCardsRequestImpl',
            'authenticatedIwsRequestImpl' => '\\StructType\\AuthenticatedIwsRequestImpl',
            'activateTelephonyScratchCardsResponseImpl' => '\\StructType\\ActivateTelephonyScratchCardsResponseImpl',
            'iwsResponseImpl' => '\\StructType\\IwsResponseImpl',
            'activateTelephonyScratchCardsImpl' => '\\StructType\\ActivateTelephonyScratchCardsImpl',
            'activateResponseImpl' => '\\StructType\\ActivateResponseImpl',
            'getModelsRequestImpl' => '\\StructType\\GetModelsRequestImpl',
            'getModelsResponseImpl' => '\\StructType\\GetModelsResponseImpl',
            'models' => '\\StructType\\Models',
            'simplifiedModelImpl' => '\\StructType\\SimplifiedModelImpl',
            'getPrepaidAccountDetailRequestImpl' => '\\StructType\\GetPrepaidAccountDetailRequestImpl',
            'getPrepaidAccountDetailResponseImpl' => '\\StructType\\GetPrepaidAccountDetailResponseImpl',
            'prepaidAccountDetailImpl' => '\\StructType\\PrepaidAccountDetailImpl',
            'getEmailNotificationRequestImpl' => '\\StructType\\GetEmailNotificationRequestImpl',
            'getEmailNotificationResponseImpl' => '\\StructType\\GetEmailNotificationResponseImpl',
            'notifications' => '\\StructType\\Notifications',
            'actionNotificationImpl' => '\\StructType\\ActionNotificationImpl',
            'sbdMOQueueReportRequestImpl' => '\\StructType\\SbdMOQueueReportRequestImpl',
            'sbdMOQueueReportResponseImpl' => '\\StructType\\SbdMOQueueReportResponseImpl',
            'resources' => '\\StructType\\Resources',
            'moipQueueReportEntryImpl' => '\\StructType\\MoipQueueReportEntryImpl',
            'sbdDeletePendingDownloadsRequestImpl' => '\\StructType\\SbdDeletePendingDownloadsRequestImpl',
            'messageIds' => '\\StructType\\MessageIds',
            'sbdDeletePendingDownloadsResponseImpl' => '\\StructType\\SbdDeletePendingDownloadsResponseImpl',
            'results' => '\\StructType\\Results',
            'sbdDeleteDownloadResultEntryImpl' => '\\StructType\\SbdDeleteDownloadResultEntryImpl',
            'getRechargeHistoryRequestImpl' => '\\StructType\\GetRechargeHistoryRequestImpl',
            'getRechargeHistoryResponseImpl' => '\\StructType\\GetRechargeHistoryResponseImpl',
            'rechargeHistoryDetails' => '\\StructType\\RechargeHistoryDetails',
            'rechargeHistoryEntryImpl' => '\\StructType\\RechargeHistoryEntryImpl',
            'validateDeviceStringRequestImpl' => '\\StructType\\ValidateDeviceStringRequestImpl',
            'validateDeviceStringResponseImpl' => '\\StructType\\ValidateDeviceStringResponseImpl',
            'validSimDeviceDataImpl' => '\\StructType\\ValidSimDeviceDataImpl',
            'validDeviceDataImpl' => '\\StructType\\ValidDeviceDataImpl',
            'deviceSimImpl' => '\\StructType\\DeviceSimImpl',
            'deviceImpl' => '\\StructType\\DeviceImpl',
            'validImeiDeviceDataImpl' => '\\StructType\\ValidImeiDeviceDataImpl',
            'imeiProfileImpl' => '\\StructType\\ImeiProfileImpl',
            'verticalImpl' => '\\StructType\\VerticalImpl',
            'validMsisdnDeviceDataImpl' => '\\StructType\\ValidMsisdnDeviceDataImpl',
            'deviceNumberImpl' => '\\StructType\\DeviceNumberImpl',
            'validMsisdnbDeviceDataImpl' => '\\StructType\\ValidMsisdnbDeviceDataImpl',
            'validMsisdncDeviceDataImpl' => '\\StructType\\ValidMsisdncDeviceDataImpl',
            'validIsdnaDeviceDataImpl' => '\\StructType\\ValidIsdnaDeviceDataImpl',
            'validCapcodeDeviceDataImpl' => '\\StructType\\ValidCapcodeDeviceDataImpl',
            'deviceCapcodeImpl' => '\\StructType\\DeviceCapcodeImpl',
            'validIpDeviceDataImpl' => '\\StructType\\ValidIpDeviceDataImpl',
            'deviceIpImpl' => '\\StructType\\DeviceIpImpl',
            'deviceApnImpl' => '\\StructType\\DeviceApnImpl',
            'validIcaoDataImpl' => '\\StructType\\ValidIcaoDataImpl',
            'validTailNumDataImpl' => '\\StructType\\ValidTailNumDataImpl',
            'submarketImpl' => '\\StructType\\SubmarketImpl',
            'servicePlans' => '\\StructType\\ServicePlans',
            'absServicePlanImpl' => '\\StructType\\AbsServicePlanImpl',
            'createSubscriberOrgRequestImpl' => '\\StructType\\CreateSubscriberOrgRequestImpl',
            'subscriberOrganizationImpl' => '\\StructType\\SubscriberOrganizationImpl',
            'subscriberOrgsResponseImpl' => '\\StructType\\SubscriberOrgsResponseImpl',
            'subscriberOrganizations' => '\\StructType\\SubscriberOrganizations',
            'getRolesRequestImpl' => '\\StructType\\GetRolesRequestImpl',
            'getRolesResponseImpl' => '\\StructType\\GetRolesResponseImpl',
            'roles' => '\\StructType\\Roles',
            'getPrepaidAccountSummaryRequestImpl' => '\\StructType\\GetPrepaidAccountSummaryRequestImpl',
            'getPrepaidAccountSummaryResponseImpl' => '\\StructType\\GetPrepaidAccountSummaryResponseImpl',
            'prepaidAccountSummaryDetails' => '\\StructType\\PrepaidAccountSummaryDetails',
            'refundPrepaidVoucherRequestImpl' => '\\StructType\\RefundPrepaidVoucherRequestImpl',
            'refundPrepaidVoucherResponseImpl' => '\\StructType\\RefundPrepaidVoucherResponseImpl',
            'subscribeBurstServiceRequestImpl' => '\\StructType\\SubscribeBurstServiceRequestImpl',
            'subscribeBurstServiceResponseImpl' => '\\StructType\\SubscribeBurstServiceResponseImpl',
            'burstSubscriptionResponseImpl' => '\\StructType\\BurstSubscriptionResponseImpl',
            'serialNumbers' => '\\StructType\\SerialNumbers',
            'getAirlinesRequestImpl' => '\\StructType\\GetAirlinesRequestImpl',
            'getAirlinesResponseImpl' => '\\StructType\\GetAirlinesResponseImpl',
            'airlines' => '\\StructType\\Airlines',
            'airlinesEntryImpl' => '\\StructType\\AirlinesEntryImpl',
            'restrictedSimSwapRequestImpl' => '\\StructType\\RestrictedSimSwapRequestImpl',
            'restrictedDeviceSwapImpl' => '\\StructType\\RestrictedDeviceSwapImpl',
            'restrictedSimSwapResponseImpl' => '\\StructType\\RestrictedSimSwapResponseImpl',
            'telephonySubscriberAccountImpl' => '\\StructType\\TelephonySubscriberAccountImpl',
            'telephonySubscriberAccountBaseImpl' => '\\StructType\\TelephonySubscriberAccountBaseImpl',
            'telephonyBulkDetails' => '\\StructType\\TelephonyBulkDetails',
            'absSubscriberAccountImpl' => '\\StructType\\AbsSubscriberAccountImpl',
            'prePaidPlanImpl' => '\\StructType\\PrePaidPlanImpl',
            'prepaidVoucherImpl' => '\\StructType\\PrepaidVoucherImpl',
            'crewPlanImpl' => '\\StructType\\CrewPlanImpl',
            'telephonyPlanImpl' => '\\StructType\\TelephonyPlanImpl',
            'servicePlanOptions' => '\\StructType\\ServicePlanOptions',
            'telephonyPlanBaseImpl' => '\\StructType\\TelephonyPlanBaseImpl',
            'absTransientPlanImpl' => '\\StructType\\AbsTransientPlanImpl',
            'telephonyBulkDetailImpl' => '\\StructType\\TelephonyBulkDetailImpl',
            'telephonySubscriberAccountMetadataImpl' => '\\StructType\\TelephonySubscriberAccountMetadataImpl',
            'absSubscriberAccountMetadataImpl' => '\\StructType\\AbsSubscriberAccountMetadataImpl',
            'twoStageImpl' => '\\StructType\\TwoStageImpl',
            'userAuthenticateRequestImpl' => '\\StructType\\UserAuthenticateRequestImpl',
            'accountUpdateRequestImpl' => '\\StructType\\AccountUpdateRequestImpl',
            'openPortSubscriberAccountImpl' => '\\StructType\\OpenPortSubscriberAccountImpl',
            'phoneLines' => '\\StructType\\PhoneLines',
            'openPortPlanImpl' => '\\StructType\\OpenPortPlanImpl',
            'absPlanImpl' => '\\StructType\\AbsPlanImpl',
            'openPortSubscriberAccountMetadataImpl' => '\\StructType\\OpenPortSubscriberAccountMetadataImpl',
            'openPortDeviceNumberImpl' => '\\StructType\\OpenPortDeviceNumberImpl',
            'programmableButtons' => '\\StructType\\ProgrammableButtons',
            'pagingSubscriberAccountImpl' => '\\StructType\\PagingSubscriberAccountImpl',
            'mdas' => '\\StructType\\Mdas',
            'pagingPlanImpl' => '\\StructType\\PagingPlanImpl',
            'pagingPlanBaseImpl' => '\\StructType\\PagingPlanBaseImpl',
            'pagingSubscriberAccountMetadataImpl' => '\\StructType\\PagingSubscriberAccountMetadataImpl',
            'atsSubscriberAccountImpl' => '\\StructType\\AtsSubscriberAccountImpl',
            'burstDeviceSubscriberAccountImpl' => '\\StructType\\BurstDeviceSubscriberAccountImpl',
            'subscriptions' => '\\StructType\\Subscriptions',
            'burstDevicePlanImpl' => '\\StructType\\BurstDevicePlanImpl',
            'burstDeviceSubscriberAccountMetadataImpl' => '\\StructType\\BurstDeviceSubscriberAccountMetadataImpl',
            'burstSubscriptionImpl' => '\\StructType\\BurstSubscriptionImpl',
            'sbdSubscriberAccountImpl' => '\\StructType\\SbdSubscriberAccountImpl',
            'sbdBulkDetails' => '\\StructType\\SbdBulkDetails',
            'deliveryDetails' => '\\StructType\\DeliveryDetails',
            'mtFilters' => '\\StructType\\MtFilters',
            'sbdPlanImpl' => '\\StructType\\SbdPlanImpl',
            'sbdSubscriberAccountMetadataImpl' => '\\StructType\\SbdSubscriberAccountMetadataImpl',
            'sbdBulkDetailImpl' => '\\StructType\\SbdBulkDetailImpl',
            'deliveryDestinationImpl' => '\\StructType\\DeliveryDestinationImpl',
            'mtFilterImpl' => '\\StructType\\MtFilterImpl',
            'm2MSubscriberAccountImpl' => '\\StructType\\M2MSubscriberAccountImpl',
            'm2mBulkDetails' => '\\StructType\\M2mBulkDetails',
            'm2MPlanImpl' => '\\StructType\\M2MPlanImpl',
            'm2MSubscriberAccountMetadataImpl' => '\\StructType\\M2MSubscriberAccountMetadataImpl',
            'm2MBulkDetailImpl' => '\\StructType\\M2MBulkDetailImpl',
            'pttDeviceSubscriberAccountImpl' => '\\StructType\\PttDeviceSubscriberAccountImpl',
            'pttDeviceBulkDetails' => '\\StructType\\PttDeviceBulkDetails',
            'pttDevicePlanImpl' => '\\StructType\\PttDevicePlanImpl',
            'pttDeviceBulkDetailImpl' => '\\StructType\\PttDeviceBulkDetailImpl',
            'pttDeviceSubscriberAccountMetadataImpl' => '\\StructType\\PttDeviceSubscriberAccountMetadataImpl',
            'pttTalkGroupSubscriberAccountImpl' => '\\StructType\\PttTalkGroupSubscriberAccountImpl',
            'pttTalkGroupPlanImpl' => '\\StructType\\PttTalkGroupPlanImpl',
            'pttTalkGroupSubscriberAccountMetadataImpl' => '\\StructType\\PttTalkGroupSubscriberAccountMetadataImpl',
            'certusSubscriberAccountImpl' => '\\StructType\\CertusSubscriberAccountImpl',
            'certusPlanImpl' => '\\StructType\\CertusPlanImpl',
            'atsSafetyInfoImpl' => '\\StructType\\AtsSafetyInfoImpl',
            'maritimeSafetyInfoImpl' => '\\StructType\\MaritimeSafetyInfoImpl',
            'certusSubscriberAccountMetadataImpl' => '\\StructType\\CertusSubscriberAccountMetadataImpl',
            'certusVoiceImpl' => '\\StructType\\CertusVoiceImpl',
            'voiceLines' => '\\StructType\\VoiceLines',
            'absMemberServiceImpl' => '\\StructType\\AbsMemberServiceImpl',
            'certusDeviceNumberImpl' => '\\StructType\\CertusDeviceNumberImpl',
            'localNumImpl' => '\\StructType\\LocalNumImpl',
            'certusStreamingImpl' => '\\StructType\\CertusStreamingImpl',
            'certusSbdImpl' => '\\StructType\\CertusSbdImpl',
            'certusBurstImpl' => '\\StructType\\CertusBurstImpl',
            'accountUpdateResponseImpl' => '\\StructType\\AccountUpdateResponseImpl',
            'getVerticalsRequestImpl' => '\\StructType\\GetVerticalsRequestImpl',
            'getVerticalsResponseImpl' => '\\StructType\\GetVerticalsResponseImpl',
            'verticals' => '\\StructType\\Verticals',
            'getSubscriberAccountRequestImpl' => '\\StructType\\GetSubscriberAccountRequestImpl',
            'getSubscriberAccountResponseImpl' => '\\StructType\\GetSubscriberAccountResponseImpl',
            'burstServiceSubscriberAccountImpl' => '\\StructType\\BurstServiceSubscriberAccountImpl',
            'subscribers' => '\\StructType\\Subscribers',
            'burstServiceSubAccountPlanImpl' => '\\StructType\\BurstServiceSubAccountPlanImpl',
            'burstSubscriberImpl' => '\\StructType\\BurstSubscriberImpl',
            'getEvoucherInventoryRequestImpl' => '\\StructType\\GetEvoucherInventoryRequestImpl',
            'getEvoucherInventoryResponseImpl' => '\\StructType\\GetEvoucherInventoryResponseImpl',
            'evoucherInventoryDetails' => '\\StructType\\EvoucherInventoryDetails',
            'evoucherInventoryEntryImpl' => '\\StructType\\EvoucherInventoryEntryImpl',
            'getLocalNumberRegionsRequestImpl' => '\\StructType\\GetLocalNumberRegionsRequestImpl',
            'getLocalNumberRegionsResponseImpl' => '\\StructType\\GetLocalNumberRegionsResponseImpl',
            'localNumberCountries' => '\\StructType\\LocalNumberCountries',
            'localNumberCountryImpl' => '\\StructType\\LocalNumberCountryImpl',
            'getScratchCardBatchesRequestImpl' => '\\StructType\\GetScratchCardBatchesRequestImpl',
            'getScratchCardBatchesResponseImpl' => '\\StructType\\GetScratchCardBatchesResponseImpl',
            'scratchCardBatches' => '\\StructType\\ScratchCardBatches',
            'scratchCardBatchesEntryImpl' => '\\StructType\\ScratchCardBatchesEntryImpl',
            'resetUserPasswordRequestImpl' => '\\StructType\\ResetUserPasswordRequestImpl',
            'resetUserPasswordResponseImpl' => '\\StructType\\ResetUserPasswordResponseImpl',
            'updatePTTSubOrgStatusRequestImpl' => '\\StructType\\UpdatePTTSubOrgStatusRequestImpl',
            'updatePTTSubOrgStatusResponseImpl' => '\\StructType\\UpdatePTTSubOrgStatusResponseImpl',
            'resetTelephonyVMPinRequestImpl' => '\\StructType\\ResetTelephonyVMPinRequestImpl',
            'getCallSummaryReportRequestImpl' => '\\StructType\\GetCallSummaryReportRequestImpl',
            'getCallSummaryReportResponseImpl' => '\\StructType\\GetCallSummaryReportResponseImpl',
            'calls' => '\\StructType\\Calls',
            'callSummaryReportImpl' => '\\StructType\\CallSummaryReportImpl',
            'getPrepaidCallHistoryRequestImpl' => '\\StructType\\GetPrepaidCallHistoryRequestImpl',
            'getPrepaidCallHistoryResponseImpl' => '\\StructType\\GetPrepaidCallHistoryResponseImpl',
            'prepaidCallHistoryDetails' => '\\StructType\\PrepaidCallHistoryDetails',
            'prepaidCallHistoryEntryImpl' => '\\StructType\\PrepaidCallHistoryEntryImpl',
            'loadIMEIRequestImpl' => '\\StructType\\LoadIMEIRequestImpl',
            'devices' => '\\StructType\\Devices',
            'loadIMEIResponseImpl' => '\\StructType\\LoadIMEIResponseImpl',
            'details' => '\\StructType\\Details',
            'loadIMeiErrorDatailImpl' => '\\StructType\\LoadIMeiErrorDatailImpl',
            'getDataSpeedsRequestImpl' => '\\StructType\\GetDataSpeedsRequestImpl',
            'absBundleMetadataRequestImpl' => '\\StructType\\AbsBundleMetadataRequestImpl',
            'getBundlesResponseImpl' => '\\StructType\\GetBundlesResponseImpl',
            'bundles' => '\\StructType\\Bundles',
            'bulkBundleInfoImpl' => '\\StructType\\BulkBundleInfoImpl',
            'bundleInfoImpl' => '\\StructType\\BundleInfoImpl',
            'datBundleInfoImpl' => '\\StructType\\DatBundleInfoImpl',
            'accountPoolingBundleInfoImpl' => '\\StructType\\AccountPoolingBundleInfoImpl',
            'updateEmailNotificationRequestImpl' => '\\StructType\\UpdateEmailNotificationRequestImpl',
            'rechargePrepaidAccountRequestImpl' => '\\StructType\\RechargePrepaidAccountRequestImpl',
            'rechargePrepaidAccountResponseImpl' => '\\StructType\\RechargePrepaidAccountResponseImpl',
            'getVoucherDenominationsRequestImpl' => '\\StructType\\GetVoucherDenominationsRequestImpl',
            'getVoucherDenominationsResponseImpl' => '\\StructType\\GetVoucherDenominationsResponseImpl',
            'voucherDenominations' => '\\StructType\\VoucherDenominations',
            'voucherDenominationImpl' => '\\StructType\\VoucherDenominationImpl',
            'getPrepaidPlansRequestImpl' => '\\StructType\\GetPrepaidPlansRequestImpl',
            'getPrepaidPlansResponseImpl' => '\\StructType\\GetPrepaidPlansResponseImpl',
            'submarkets' => '\\StructType\\Submarkets',
            'submarketPrepaidPlansImpl' => '\\StructType\\SubmarketPrepaidPlansImpl',
            'prepaid' => '\\StructType\\Prepaid',
            'crew' => '\\StructType\\Crew',
            'getDeviceUsageReportRequestImpl' => '\\StructType\\GetDeviceUsageReportRequestImpl',
            'absReportRequestImpl' => '\\StructType\\AbsReportRequestImpl',
            'scratchCardSearchCriteriaImpl' => '\\StructType\\ScratchCardSearchCriteriaImpl',
            'absDeviceSearchCriteriaImpl' => '\\StructType\\AbsDeviceSearchCriteriaImpl',
            'sbdSearchCriteriaImpl' => '\\StructType\\SbdSearchCriteriaImpl',
            'getDeviceUsageReportResponseImpl' => '\\StructType\\GetDeviceUsageReportResponseImpl',
            'scratchCardDetailsImpl' => '\\StructType\\ScratchCardDetailsImpl',
            'activities' => '\\StructType\\Activities',
            'deviceDetailsImpl' => '\\StructType\\DeviceDetailsImpl',
            'voucherActivityImpl' => '\\StructType\\VoucherActivityImpl',
            'sbdDetailsImpl' => '\\StructType\\SbdDetailsImpl',
            'sbdActivityReportEntryImpl' => '\\StructType\\SbdActivityReportEntryImpl',
            'sbdmtActivityImpl' => '\\StructType\\SbdmtActivityImpl',
            'sbdActivityImpl' => '\\StructType\\SbdActivityImpl',
            'sbdmoActivityImpl' => '\\StructType\\SbdmoActivityImpl',
            'getSubscriberBaseReportRequestImpl' => '\\StructType\\GetSubscriberBaseReportRequestImpl',
            'getSubscriberBaseReportResponseImpl' => '\\StructType\\GetSubscriberBaseReportResponseImpl',
            'subscriberBaseReportImpl' => '\\StructType\\SubscriberBaseReportImpl',
            'getDataBundlesRequestImpl' => '\\StructType\\GetDataBundlesRequestImpl',
            'getDevicesRequestImpl' => '\\StructType\\GetDevicesRequestImpl',
            'deviceIpSearchParametersImpl' => '\\StructType\\DeviceIpSearchParametersImpl',
            'deviceNumSearchParametersImpl' => '\\StructType\\DeviceNumSearchParametersImpl',
            'getDevicesResponseImpl' => '\\StructType\\GetDevicesResponseImpl',
            'getDemoAndTrialBundlesRequestImpl' => '\\StructType\\GetDemoAndTrialBundlesRequestImpl',
            'getBurstDeviceBundlesRequestImpl' => '\\StructType\\GetBurstDeviceBundlesRequestImpl',
            'createUserProfileRequestImpl' => '\\StructType\\CreateUserProfileRequestImpl',
            'userImpl' => '\\StructType\\UserImpl',
            'allAccessInfo' => '\\StructType\\AllAccessInfo',
            'userAccessInfoImpl' => '\\StructType\\UserAccessInfoImpl',
            'contactInfoImpl' => '\\StructType\\ContactInfoImpl',
            'createUserProfileResponseImpl' => '\\StructType\\CreateUserProfileResponseImpl',
            'accountStatusChangeRequestImpl' => '\\StructType\\AccountStatusChangeRequestImpl',
            'accountSearchRequestImpl' => '\\StructType\\AccountSearchRequestImpl',
            'accountSearchResponseImpl' => '\\StructType\\AccountSearchResponseImpl',
            'accountSearchReportImpl' => '\\StructType\\AccountSearchReportImpl',
            'updateUserProfileRequestImpl' => '\\StructType\\UpdateUserProfileRequestImpl',
            'updateUserProfileResponseImpl' => '\\StructType\\UpdateUserProfileResponseImpl',
            'getTransactionHistoryReportRequestImpl' => '\\StructType\\GetTransactionHistoryReportRequestImpl',
            'getTransactionHistoryReportResponseImpl' => '\\StructType\\GetTransactionHistoryReportResponseImpl',
            'transactions' => '\\StructType\\Transactions',
            'transactionHistoryReportImpl' => '\\StructType\\TransactionHistoryReportImpl',
            'accountTransitionReportRequestImpl' => '\\StructType\\AccountTransitionReportRequestImpl',
            'accountTransitionReportResponseImpl' => '\\StructType\\AccountTransitionReportResponseImpl',
            'demoPlanReportImpl' => '\\StructType\\DemoPlanReportImpl',
            'searchSPProfileRequestImpl' => '\\StructType\\SearchSPProfileRequestImpl',
            'searchSPProfileResponseImpl' => '\\StructType\\SearchSPProfileResponseImpl',
            'serviceProviderImpl' => '\\StructType\\ServiceProviderImpl',
            'configList' => '\\StructType\\ConfigList',
            'spServiceConfigurationInfoImpl' => '\\StructType\\SpServiceConfigurationInfoImpl',
            'demoAndTrialCounts' => '\\StructType\\DemoAndTrialCounts',
            'datCountImpl' => '\\StructType\\DatCountImpl',
            'deactivateTelephonyScratchCardRequestImpl' => '\\StructType\\DeactivateTelephonyScratchCardRequestImpl',
            'deactivateTelephonyScratchCardResponseImpl' => '\\StructType\\DeactivateTelephonyScratchCardResponseImpl',
            'deactivateTelephonyScratchCardImpl' => '\\StructType\\DeactivateTelephonyScratchCardImpl',
            'activateSubscriberRequestImpl' => '\\StructType\\ActivateSubscriberRequestImpl',
            'activateSubscriberResponseImpl' => '\\StructType\\ActivateSubscriberResponseImpl',
            'getRealTimeCallDataReportRequestImpl' => '\\StructType\\GetRealTimeCallDataReportRequestImpl',
            'callDataSearchCriteriaImpl' => '\\StructType\\CallDataSearchCriteriaImpl',
            'getRealTimeCallDataReportResponseImpl' => '\\StructType\\GetRealTimeCallDataReportResponseImpl',
            'dataList' => '\\StructType\\DataList',
            'callDataEntryImpl' => '\\StructType\\CallDataEntryImpl',
            'getBurstBroadcastCoverageAreasRequestImpl' => '\\StructType\\GetBurstBroadcastCoverageAreasRequestImpl',
            'getBurstBroadcastCoverageAreasResponseImpl' => '\\StructType\\GetBurstBroadcastCoverageAreasResponseImpl',
            'bcaList' => '\\StructType\\BcaList',
            'getSBDBundlesRequestImpl' => '\\StructType\\GetSBDBundlesRequestImpl',
            'accountUpdateDevicesRequestImpl' => '\\StructType\\AccountUpdateDevicesRequestImpl',
            'deviceSwapImpl' => '\\StructType\\DeviceSwapImpl',
            'localCountryImpl' => '\\StructType\\LocalCountryImpl',
            'subscriberOrgDetailReqImpl' => '\\StructType\\SubscriberOrgDetailReqImpl',
            'subscriberOrgDetailRespImpl' => '\\StructType\\SubscriberOrgDetailRespImpl',
            'pttDevices' => '\\StructType\\PttDevices',
            'pttTalkgroups' => '\\StructType\\PttTalkgroups',
            'pttDeviceDetailImpl' => '\\StructType\\PttDeviceDetailImpl',
            'pttTalkgroupDetailImpl' => '\\StructType\\PttTalkgroupDetailImpl',
            'revokeRoleRequestImpl' => '\\StructType\\RevokeRoleRequestImpl',
            'getLanguagesRequestImpl' => '\\StructType\\GetLanguagesRequestImpl',
            'getManufacturersRequestImpl' => '\\StructType\\GetManufacturersRequestImpl',
            'getManufacturersResponseImpl' => '\\StructType\\GetManufacturersResponseImpl',
            'manufacturers' => '\\StructType\\Manufacturers',
            'manufacturerImpl' => '\\StructType\\ManufacturerImpl',
            'getBulkActionReportRequestImpl' => '\\StructType\\GetBulkActionReportRequestImpl',
            'searchAccountResponseImpl' => '\\StructType\\SearchAccountResponseImpl',
            'subscriberAccountSearchResultsImpl' => '\\StructType\\SubscriberAccountSearchResultsImpl',
            'subscriberAccounts' => '\\StructType\\SubscriberAccounts',
            'subscriberAccountEntryImpl' => '\\StructType\\SubscriberAccountEntryImpl',
            'atsInfoEntryImpl' => '\\StructType\\AtsInfoEntryImpl',
            'sbdImeiSearchRequestImpl' => '\\StructType\\SbdImeiSearchRequestImpl',
            'sbdImeiSearchResponseImpl' => '\\StructType\\SbdImeiSearchResponseImpl',
            'imeiDetails' => '\\StructType\\ImeiDetails',
            'imeiDetailImpl' => '\\StructType\\ImeiDetailImpl',
            'getCommitmentPeriodsRequestImpl' => '\\StructType\\GetCommitmentPeriodsRequestImpl',
            'getBundleRequestImpl' => '\\StructType\\GetBundleRequestImpl',
            'getBundleResponseImpl' => '\\StructType\\GetBundleResponseImpl',
            'bulkAccountUpdateRequestImpl' => '\\StructType\\BulkAccountUpdateRequestImpl',
            'sbdBulkPlanUpdateImpl' => '\\StructType\\SbdBulkPlanUpdateImpl',
            'sbdBulkPlanImpl' => '\\StructType\\SbdBulkPlanImpl',
            'm2MBulkPlanUpdateImpl' => '\\StructType\\M2MBulkPlanUpdateImpl',
            'm2MBulkPlanImpl' => '\\StructType\\M2MBulkPlanImpl',
            'telephonyBulkPlanUpdateImpl' => '\\StructType\\TelephonyBulkPlanUpdateImpl',
            'telephonyBulkBaseImpl' => '\\StructType\\TelephonyBulkBaseImpl',
            'telephonyBulkPlanImpl' => '\\StructType\\TelephonyBulkPlanImpl',
            'pttDeviceBulkPlanUpdateImpl' => '\\StructType\\PttDeviceBulkPlanUpdateImpl',
            'pttDeviceBulkBaseImpl' => '\\StructType\\PttDeviceBulkBaseImpl',
            'pttDeviceBulkPlanImpl' => '\\StructType\\PttDeviceBulkPlanImpl',
            'bulkAccountUpdateResponseImpl' => '\\StructType\\BulkAccountUpdateResponseImpl',
            'deletePrepaidAccountRequestImpl' => '\\StructType\\DeletePrepaidAccountRequestImpl',
            'deletePrepaidAccountResponseImpl' => '\\StructType\\DeletePrepaidAccountResponseImpl',
            'deletePrepaidAccountImpl' => '\\StructType\\DeletePrepaidAccountImpl',
            'associateSimToImeiRequestImpl' => '\\StructType\\AssociateSimToImeiRequestImpl',
            'deviceImeiImpl' => '\\StructType\\DeviceImeiImpl',
            'getRudicsGroupsRequestImpl' => '\\StructType\\GetRudicsGroupsRequestImpl',
            'absConfigurationMetadataRequestImpl' => '\\StructType\\AbsConfigurationMetadataRequestImpl',
            'rudicsGroupSearchParametersImpl' => '\\StructType\\RudicsGroupSearchParametersImpl',
            'getRudicsGroupsResponseImpl' => '\\StructType\\GetRudicsGroupsResponseImpl',
            'rudicsGroups' => '\\StructType\\RudicsGroups',
            'rudicsGroupImpl' => '\\StructType\\RudicsGroupImpl',
            'deviceTransferOwnerRequestImpl' => '\\StructType\\DeviceTransferOwnerRequestImpl',
            'BulkDetails' => '\\StructType\\BulkDetails',
            'deviceTransferOwnerResponseImpl' => '\\StructType\\DeviceTransferOwnerResponseImpl',
            'getSystemStatusResponseImpl' => '\\StructType\\GetSystemStatusResponseImpl',
            'systemStatusImpl' => '\\StructType\\SystemStatusImpl',
            'outageScheduleItems' => '\\StructType\\OutageScheduleItems',
            'outageScheduleItemImpl' => '\\StructType\\OutageScheduleItemImpl',
            'affectedElements' => '\\StructType\\AffectedElements',
            'getM2MBundlesRequestImpl' => '\\StructType\\GetM2MBundlesRequestImpl',
            'getModelRequestImpl' => '\\StructType\\GetModelRequestImpl',
            'getModelResponseImpl' => '\\StructType\\GetModelResponseImpl',
            'modelImpl' => '\\StructType\\ModelImpl',
            'getResourceInventoryReportRequestImpl' => '\\StructType\\GetResourceInventoryReportRequestImpl',
            'getResourceInventoryReportResponseImpl' => '\\StructType\\GetResourceInventoryReportResponseImpl',
            'resourceInventoryReportImpl' => '\\StructType\\ResourceInventoryReportImpl',
            'getVCSBundlesRequestImpl' => '\\StructType\\GetVCSBundlesRequestImpl',
            'getServicePlanRequestImpl' => '\\StructType\\GetServicePlanRequestImpl',
            'getServicePlanResponseImpl' => '\\StructType\\GetServicePlanResponseImpl',
            'servicePlanImpl' => '\\StructType\\ServicePlanImpl',
            'serviceCategories' => '\\StructType\\ServiceCategories',
            'permittedServices' => '\\StructType\\PermittedServices',
            'requiredGroups' => '\\StructType\\RequiredGroups',
            'optionalGroups' => '\\StructType\\OptionalGroups',
            'requiredGroupImpl' => '\\StructType\\RequiredGroupImpl',
            'optionalGroupImpl' => '\\StructType\\OptionalGroupImpl',
            'servicePlanOptionImpl' => '\\StructType\\ServicePlanOptionImpl',
            'getSubscriberOrgsRequestImpl' => '\\StructType\\GetSubscriberOrgsRequestImpl',
            'getAccountPoolingGroupsRequestImpl' => '\\StructType\\GetAccountPoolingGroupsRequestImpl',
            'getAccountPoolingGroupsResponseImpl' => '\\StructType\\GetAccountPoolingGroupsResponseImpl',
            'accountPoolingGroups' => '\\StructType\\AccountPoolingGroups',
            'accountPoolingGroupNoMembersImpl' => '\\StructType\\AccountPoolingGroupNoMembersImpl',
            'getServicePlansRequestImpl' => '\\StructType\\GetServicePlansRequestImpl',
            'getServicePlansResponseImpl' => '\\StructType\\GetServicePlansResponseImpl',
            'activateScratchCardRequestImpl' => '\\StructType\\ActivateScratchCardRequestImpl',
            'activateScratchCardResponseImpl' => '\\StructType\\ActivateScratchCardResponseImpl',
            'scratchCardActivationResponseImpl' => '\\StructType\\ScratchCardActivationResponseImpl',
            'getVoiceBundlesRequestImpl' => '\\StructType\\GetVoiceBundlesRequestImpl',
            'getProgrammableButtonsRequestImpl' => '\\StructType\\GetProgrammableButtonsRequestImpl',
            'getProgrammableButtonsResponseImpl' => '\\StructType\\GetProgrammableButtonsResponseImpl',
            'programmableButtonImpl' => '\\StructType\\ProgrammableButtonImpl',
            'sendMessageToDeviceRequestImpl' => '\\StructType\\SendMessageToDeviceRequestImpl',
            'sendMessageToDeviceResponseImpl' => '\\StructType\\SendMessageToDeviceResponseImpl',
            'sendMessageResultImpl' => '\\StructType\\SendMessageResultImpl',
            'searchScratchCardActivationStatusRequestImpl' => '\\StructType\\SearchScratchCardActivationStatusRequestImpl',
            'searchScratchCardActivationStatusResponseImpl' => '\\StructType\\SearchScratchCardActivationStatusResponseImpl',
            'activationList' => '\\StructType\\ActivationList',
            'scratchCardActivationStatusImpl' => '\\StructType\\ScratchCardActivationStatusImpl',
            'searchVoucherInventoryRequestImpl' => '\\StructType\\SearchVoucherInventoryRequestImpl',
            'searchVoucherInventoryResponseImpl' => '\\StructType\\SearchVoucherInventoryResponseImpl',
            'orders' => '\\StructType\\Orders',
            'voucherOrderImpl' => '\\StructType\\VoucherOrderImpl',
            'lineItems' => '\\StructType\\LineItems',
            'batches' => '\\StructType\\Batches',
            'voucherLineItemImpl' => '\\StructType\\VoucherLineItemImpl',
            'assignedSerialRanges' => '\\StructType\\AssignedSerialRanges',
            'serialRangeImpl' => '\\StructType\\SerialRangeImpl',
            'getScratchCardsRequestImpl' => '\\StructType\\GetScratchCardsRequestImpl',
            'getScratchCardsResponseImpl' => '\\StructType\\GetScratchCardsResponseImpl',
            'scratchCards' => '\\StructType\\ScratchCards',
            'scratchCardsDetailEntryImpl' => '\\StructType\\ScratchCardsDetailEntryImpl',
            'getLanguageChoicesRequestImpl' => '\\StructType\\GetLanguageChoicesRequestImpl',
            'getLanguageChoicesResponseImpl' => '\\StructType\\GetLanguageChoicesResponseImpl',
            'languageChoices' => '\\StructType\\LanguageChoices',
            'languageChoiceImpl' => '\\StructType\\LanguageChoiceImpl',
            'getPromoBundlesRequestImpl' => '\\StructType\\GetPromoBundlesRequestImpl',
            'm2MImeiSearchRequestImpl' => '\\StructType\\M2MImeiSearchRequestImpl',
            'm2MImeiSearchResponseImpl' => '\\StructType\\M2MImeiSearchResponseImpl',
            'm2MImeiDetailImpl' => '\\StructType\\M2MImeiDetailImpl',
            'findUserProfilesRequestImpl' => '\\StructType\\FindUserProfilesRequestImpl',
            'findUserProfilesResponseImpl' => '\\StructType\\FindUserProfilesResponseImpl',
            'changeUserProfileStatusRequestImpl' => '\\StructType\\ChangeUserProfileStatusRequestImpl',
            'getSubmarketsRequestImpl' => '\\StructType\\GetSubmarketsRequestImpl',
            'submarketSearchParametersImpl' => '\\StructType\\SubmarketSearchParametersImpl',
            'getSubmarketsResponseImpl' => '\\StructType\\GetSubmarketsResponseImpl',
            'subMarkets' => '\\StructType\\SubMarkets_1',
            'getDemoAndTrialCountsRequestImpl' => '\\StructType\\GetDemoAndTrialCountsRequestImpl',
            'getDemoAndTrialCountsResponseImpl' => '\\StructType\\GetDemoAndTrialCountsResponseImpl',
            'availableDemoAndTrialCountsImpl' => '\\StructType\\AvailableDemoAndTrialCountsImpl',
            'deliveryDestinationSearchAndReplaceRequestImpl' => '\\StructType\\DeliveryDestinationSearchAndReplaceRequestImpl',
            'deliveryDestinationSearchAndReplaceResponseImpl' => '\\StructType\\DeliveryDestinationSearchAndReplaceResponseImpl',
            'sbdDestinationSearchReplaceEntryImpl' => '\\StructType\\SbdDestinationSearchReplaceEntryImpl',
            'getProvisioningFailureReportRequestImpl' => '\\StructType\\GetProvisioningFailureReportRequestImpl',
            'getProvisioningFailureReportResponseImpl' => '\\StructType\\GetProvisioningFailureReportResponseImpl',
            'failureList' => '\\StructType\\FailureList',
            'provisioningFailureEntryImpl' => '\\StructType\\ProvisioningFailureEntryImpl',
            'updateSubscriberOrgRequestImpl' => '\\StructType\\UpdateSubscriberOrgRequestImpl',
            'sbdMOQueuePurgeRequestImpl' => '\\StructType\\SbdMOQueuePurgeRequestImpl',
            'sbdMOQueuePurgeResponseImpl' => '\\StructType\\SbdMOQueuePurgeResponseImpl',
            'userUnlockRequestImpl' => '\\StructType\\UserUnlockRequestImpl',
            'getAccountPoolingGroupRequestImpl' => '\\StructType\\GetAccountPoolingGroupRequestImpl',
            'getAccountPoolingGroupResponseImpl' => '\\StructType\\GetAccountPoolingGroupResponseImpl',
            'accountPoolingGroupImpl' => '\\StructType\\AccountPoolingGroupImpl',
            'memberAccounts' => '\\StructType\\MemberAccounts',
            'searchSimLockRequestImpl' => '\\StructType\\SearchSimLockRequestImpl',
            'searchSimLockResponseImpl' => '\\StructType\\SearchSimLockResponseImpl',
            'simLockResultImpl' => '\\StructType\\SimLockResultImpl',
            'unsubscribeBurstServiceRequestImpl' => '\\StructType\\UnsubscribeBurstServiceRequestImpl',
            'getBurstSubscriptionNamesRequestImpl' => '\\StructType\\GetBurstSubscriptionNamesRequestImpl',
            'getBurstSubscriptionNamesResponseImpl' => '\\StructType\\GetBurstSubscriptionNamesResponseImpl',
            'bulkActionSearchRequestImpl' => '\\StructType\\BulkActionSearchRequestImpl',
            'bulkActionSearchResponseImpl' => '\\StructType\\BulkActionSearchResponseImpl',
            'bulkActionSearchResultsImpl' => '\\StructType\\BulkActionSearchResultsImpl',
            'bulkActions' => '\\StructType\\BulkActions',
            'bulkActionEntryImpl' => '\\StructType\\BulkActionEntryImpl',
            'grantRoleRequestImpl' => '\\StructType\\GrantRoleRequestImpl',
            'IWSException' => '\\StructType\\IWSException',
            'AuthorizationException' => '\\StructType\\AuthorizationException',
        );
    }
}
