<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for absBundleMetadataRequestImpl StructType
 * @subpackage Structs
 */
abstract class AbsBundleMetadataRequestImpl extends AuthenticatedIwsRequestImpl
{
    /**
     * The openPortPlan
     * @var \StructType\OpenPortPlanImpl
     */
    public $openPortPlan;
    /**
     * The burstDevicePlan
     * @var \StructType\BurstDevicePlanImpl
     */
    public $burstDevicePlan;
    /**
     * The sbdPlan
     * @var \StructType\SbdPlanImpl
     */
    public $sbdPlan;
    /**
     * The m2mPlan
     * @var \StructType\M2MPlanImpl
     */
    public $m2mPlan;
    /**
     * The fromBundleId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $fromBundleId;
    /**
     * The forActivate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $forActivate;
    /**
     * Constructor method for absBundleMetadataRequestImpl
     * @uses AbsBundleMetadataRequestImpl::setOpenPortPlan()
     * @uses AbsBundleMetadataRequestImpl::setBurstDevicePlan()
     * @uses AbsBundleMetadataRequestImpl::setSbdPlan()
     * @uses AbsBundleMetadataRequestImpl::setM2mPlan()
     * @uses AbsBundleMetadataRequestImpl::setFromBundleId()
     * @uses AbsBundleMetadataRequestImpl::setForActivate()
     * @param \StructType\OpenPortPlanImpl $openPortPlan
     * @param \StructType\BurstDevicePlanImpl $burstDevicePlan
     * @param \StructType\SbdPlanImpl $sbdPlan
     * @param \StructType\M2MPlanImpl $m2mPlan
     * @param string $fromBundleId
     * @param bool $forActivate
     */
    public function __construct(\StructType\OpenPortPlanImpl $openPortPlan = null, \StructType\BurstDevicePlanImpl $burstDevicePlan = null, \StructType\SbdPlanImpl $sbdPlan = null, \StructType\M2MPlanImpl $m2mPlan = null, $fromBundleId = null, $forActivate = null)
    {
        $this
            ->setOpenPortPlan($openPortPlan)
            ->setBurstDevicePlan($burstDevicePlan)
            ->setSbdPlan($sbdPlan)
            ->setM2mPlan($m2mPlan)
            ->setFromBundleId($fromBundleId)
            ->setForActivate($forActivate);
    }
    /**
     * Get openPortPlan value
     * @return \StructType\OpenPortPlanImpl|null
     */
    public function getOpenPortPlan()
    {
        return $this->openPortPlan;
    }
    /**
     * Set openPortPlan value
     * @param \StructType\OpenPortPlanImpl $openPortPlan
     * @return \StructType\AbsBundleMetadataRequestImpl
     */
    public function setOpenPortPlan(\StructType\OpenPortPlanImpl $openPortPlan = null)
    {
        $this->openPortPlan = $openPortPlan;
        return $this;
    }
    /**
     * Get burstDevicePlan value
     * @return \StructType\BurstDevicePlanImpl|null
     */
    public function getBurstDevicePlan()
    {
        return $this->burstDevicePlan;
    }
    /**
     * Set burstDevicePlan value
     * @param \StructType\BurstDevicePlanImpl $burstDevicePlan
     * @return \StructType\AbsBundleMetadataRequestImpl
     */
    public function setBurstDevicePlan(\StructType\BurstDevicePlanImpl $burstDevicePlan = null)
    {
        $this->burstDevicePlan = $burstDevicePlan;
        return $this;
    }
    /**
     * Get sbdPlan value
     * @return \StructType\SbdPlanImpl|null
     */
    public function getSbdPlan()
    {
        return $this->sbdPlan;
    }
    /**
     * Set sbdPlan value
     * @param \StructType\SbdPlanImpl $sbdPlan
     * @return \StructType\AbsBundleMetadataRequestImpl
     */
    public function setSbdPlan(\StructType\SbdPlanImpl $sbdPlan = null)
    {
        $this->sbdPlan = $sbdPlan;
        return $this;
    }
    /**
     * Get m2mPlan value
     * @return \StructType\M2MPlanImpl|null
     */
    public function getM2mPlan()
    {
        return $this->m2mPlan;
    }
    /**
     * Set m2mPlan value
     * @param \StructType\M2MPlanImpl $m2mPlan
     * @return \StructType\AbsBundleMetadataRequestImpl
     */
    public function setM2mPlan(\StructType\M2MPlanImpl $m2mPlan = null)
    {
        $this->m2mPlan = $m2mPlan;
        return $this;
    }
    /**
     * Get fromBundleId value
     * @return string|null
     */
    public function getFromBundleId()
    {
        return $this->fromBundleId;
    }
    /**
     * Set fromBundleId value
     * @param string $fromBundleId
     * @return \StructType\AbsBundleMetadataRequestImpl
     */
    public function setFromBundleId($fromBundleId = null)
    {
        // validation for constraint: string
        if (!is_null($fromBundleId) && !is_string($fromBundleId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fromBundleId)), __LINE__);
        }
        $this->fromBundleId = $fromBundleId;
        return $this;
    }
    /**
     * Get forActivate value
     * @return bool|null
     */
    public function getForActivate()
    {
        return $this->forActivate;
    }
    /**
     * Set forActivate value
     * @param bool $forActivate
     * @return \StructType\AbsBundleMetadataRequestImpl
     */
    public function setForActivate($forActivate = null)
    {
        $this->forActivate = $forActivate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AbsBundleMetadataRequestImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
