<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for accountPoolingGroupNoMembersImpl StructType
 * @subpackage Structs
 */
class AccountPoolingGroupNoMembersImpl extends AbstractStructBase
{
    /**
     * The spAccountNum
     * @var string
     */
    public $spAccountNum;
    /**
     * The spAccountName
     * @var string
     */
    public $spAccountName;
    /**
     * The id
     * @var string
     */
    public $id;
    /**
     * The status
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $status;
    /**
     * The name
     * @var string
     */
    public $name;
    /**
     * The serviceType
     * @var string
     */
    public $serviceType;
    /**
     * The planInfo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $planInfo;
    /**
     * Constructor method for accountPoolingGroupNoMembersImpl
     * @uses AccountPoolingGroupNoMembersImpl::setSpAccountNum()
     * @uses AccountPoolingGroupNoMembersImpl::setSpAccountName()
     * @uses AccountPoolingGroupNoMembersImpl::setId()
     * @uses AccountPoolingGroupNoMembersImpl::setStatus()
     * @uses AccountPoolingGroupNoMembersImpl::setName()
     * @uses AccountPoolingGroupNoMembersImpl::setServiceType()
     * @uses AccountPoolingGroupNoMembersImpl::setPlanInfo()
     * @param string $spAccountNum
     * @param string $spAccountName
     * @param string $id
     * @param string $status
     * @param string $name
     * @param string $serviceType
     * @param string $planInfo
     */
    public function __construct($spAccountNum = null, $spAccountName = null, $id = null, $status = null, $name = null, $serviceType = null, $planInfo = null)
    {
        $this
            ->setSpAccountNum($spAccountNum)
            ->setSpAccountName($spAccountName)
            ->setId($id)
            ->setStatus($status)
            ->setName($name)
            ->setServiceType($serviceType)
            ->setPlanInfo($planInfo);
    }
    /**
     * Get spAccountNum value
     * @return string|null
     */
    public function getSpAccountNum()
    {
        return $this->spAccountNum;
    }
    /**
     * Set spAccountNum value
     * @param string $spAccountNum
     * @return \StructType\AccountPoolingGroupNoMembersImpl
     */
    public function setSpAccountNum($spAccountNum = null)
    {
        // validation for constraint: string
        if (!is_null($spAccountNum) && !is_string($spAccountNum)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($spAccountNum)), __LINE__);
        }
        $this->spAccountNum = $spAccountNum;
        return $this;
    }
    /**
     * Get spAccountName value
     * @return string|null
     */
    public function getSpAccountName()
    {
        return $this->spAccountName;
    }
    /**
     * Set spAccountName value
     * @param string $spAccountName
     * @return \StructType\AccountPoolingGroupNoMembersImpl
     */
    public function setSpAccountName($spAccountName = null)
    {
        // validation for constraint: string
        if (!is_null($spAccountName) && !is_string($spAccountName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($spAccountName)), __LINE__);
        }
        $this->spAccountName = $spAccountName;
        return $this;
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\AccountPoolingGroupNoMembersImpl
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @uses \EnumType\StatusEnum::valueIsValid()
     * @uses \EnumType\StatusEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $status
     * @return \StructType\AccountPoolingGroupNoMembersImpl
     */
    public function setStatus($status = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\StatusEnum::valueIsValid($status)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $status, implode(', ', \EnumType\StatusEnum::getValidValues())), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\AccountPoolingGroupNoMembersImpl
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get serviceType value
     * @return string|null
     */
    public function getServiceType()
    {
        return $this->serviceType;
    }
    /**
     * Set serviceType value
     * @uses \EnumType\ServiceTypeEnum::valueIsValid()
     * @uses \EnumType\ServiceTypeEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $serviceType
     * @return \StructType\AccountPoolingGroupNoMembersImpl
     */
    public function setServiceType($serviceType = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\ServiceTypeEnum::valueIsValid($serviceType)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $serviceType, implode(', ', \EnumType\ServiceTypeEnum::getValidValues())), __LINE__);
        }
        $this->serviceType = $serviceType;
        return $this;
    }
    /**
     * Get planInfo value
     * @return string|null
     */
    public function getPlanInfo()
    {
        return $this->planInfo;
    }
    /**
     * Set planInfo value
     * @param string $planInfo
     * @return \StructType\AccountPoolingGroupNoMembersImpl
     */
    public function setPlanInfo($planInfo = null)
    {
        // validation for constraint: string
        if (!is_null($planInfo) && !is_string($planInfo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($planInfo)), __LINE__);
        }
        $this->planInfo = $planInfo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AccountPoolingGroupNoMembersImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
