<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for accountPoolingGroups StructType
 * @subpackage Structs
 */
class AccountPoolingGroups extends AbstractStructBase
{
    /**
     * The accountPoolingGroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AccountPoolingGroupNoMembersImpl[]
     */
    public $accountPoolingGroup;
    /**
     * Constructor method for accountPoolingGroups
     * @uses AccountPoolingGroups::setAccountPoolingGroup()
     * @param \StructType\AccountPoolingGroupNoMembersImpl[] $accountPoolingGroup
     */
    public function __construct(array $accountPoolingGroup = array())
    {
        $this
            ->setAccountPoolingGroup($accountPoolingGroup);
    }
    /**
     * Get accountPoolingGroup value
     * @return \StructType\AccountPoolingGroupNoMembersImpl[]|null
     */
    public function getAccountPoolingGroup()
    {
        return $this->accountPoolingGroup;
    }
    /**
     * Set accountPoolingGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\AccountPoolingGroupNoMembersImpl[] $accountPoolingGroup
     * @return \StructType\AccountPoolingGroups
     */
    public function setAccountPoolingGroup(array $accountPoolingGroup = array())
    {
        foreach ($accountPoolingGroup as $accountPoolingGroupsAccountPoolingGroupItem) {
            // validation for constraint: itemType
            if (!$accountPoolingGroupsAccountPoolingGroupItem instanceof \StructType\AccountPoolingGroupNoMembersImpl) {
                throw new \InvalidArgumentException(sprintf('The accountPoolingGroup property can only contain items of \StructType\AccountPoolingGroupNoMembersImpl, "%s" given', is_object($accountPoolingGroupsAccountPoolingGroupItem) ? get_class($accountPoolingGroupsAccountPoolingGroupItem) : gettype($accountPoolingGroupsAccountPoolingGroupItem)), __LINE__);
            }
        }
        $this->accountPoolingGroup = $accountPoolingGroup;
        return $this;
    }
    /**
     * Add item to accountPoolingGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\AccountPoolingGroupNoMembersImpl $item
     * @return \StructType\AccountPoolingGroups
     */
    public function addToAccountPoolingGroup(\StructType\AccountPoolingGroupNoMembersImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AccountPoolingGroupNoMembersImpl) {
            throw new \InvalidArgumentException(sprintf('The accountPoolingGroup property can only contain items of \StructType\AccountPoolingGroupNoMembersImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->accountPoolingGroup[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AccountPoolingGroups
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
