<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for accountUpdateDevicesRequestImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:accountUpdateDevicesRequestImpl
 * @subpackage Structs
 */
class AccountUpdateDevicesRequestImpl extends AuthenticatedIwsRequestImpl
{
    /**
     * The subscriberAccountNumber
     * @var string
     */
    public $subscriberAccountNumber;
    /**
     * The devices
     * @var \StructType\Devices
     */
    public $devices;
    /**
     * Constructor method for accountUpdateDevicesRequestImpl
     * @uses AccountUpdateDevicesRequestImpl::setSubscriberAccountNumber()
     * @uses AccountUpdateDevicesRequestImpl::setDevices()
     * @param string $subscriberAccountNumber
     * @param \StructType\Devices $devices
     */
    public function __construct($subscriberAccountNumber = null, \StructType\Devices $devices = null)
    {
        $this
            ->setSubscriberAccountNumber($subscriberAccountNumber)
            ->setDevices($devices);
    }
    /**
     * Get subscriberAccountNumber value
     * @return string|null
     */
    public function getSubscriberAccountNumber()
    {
        return $this->subscriberAccountNumber;
    }
    /**
     * Set subscriberAccountNumber value
     * @param string $subscriberAccountNumber
     * @return \StructType\AccountUpdateDevicesRequestImpl
     */
    public function setSubscriberAccountNumber($subscriberAccountNumber = null)
    {
        // validation for constraint: string
        if (!is_null($subscriberAccountNumber) && !is_string($subscriberAccountNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($subscriberAccountNumber)), __LINE__);
        }
        $this->subscriberAccountNumber = $subscriberAccountNumber;
        return $this;
    }
    /**
     * Get devices value
     * @return \StructType\Devices|null
     */
    public function getDevices()
    {
        return $this->devices;
    }
    /**
     * Set devices value
     * @param \StructType\Devices $devices
     * @return \StructType\AccountUpdateDevicesRequestImpl
     */
    public function setDevices(\StructType\Devices $devices = null)
    {
        $this->devices = $devices;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AccountUpdateDevicesRequestImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
