<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for activateResponseImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:activateResponseImpl
 * @subpackage Structs
 */
class ActivateResponseImpl extends AbstractStructBase
{
    /**
     * The success
     * @var bool
     */
    public $success;
    /**
     * The message
     * @var string
     */
    public $message;
    /**
     * Constructor method for activateResponseImpl
     * @uses ActivateResponseImpl::setSuccess()
     * @uses ActivateResponseImpl::setMessage()
     * @param bool $success
     * @param string $message
     */
    public function __construct($success = null, $message = null)
    {
        $this
            ->setSuccess($success)
            ->setMessage($message);
    }
    /**
     * Get success value
     * @return bool|null
     */
    public function getSuccess()
    {
        return $this->success;
    }
    /**
     * Set success value
     * @param bool $success
     * @return \StructType\ActivateResponseImpl
     */
    public function setSuccess($success = null)
    {
        $this->success = $success;
        return $this;
    }
    /**
     * Get message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->message;
    }
    /**
     * Set message value
     * @param string $message
     * @return \StructType\ActivateResponseImpl
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($message)), __LINE__);
        }
        $this->message = $message;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ActivateResponseImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
