<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for activateTelephonyScratchCardsRequestImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:activateTelephonyScratchCardsRequestImpl
 * @subpackage Structs
 */
class ActivateTelephonyScratchCardsRequestImpl extends AuthenticatedIwsRequestImpl
{
    /**
     * The startSerial
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $startSerial;
    /**
     * The endSerial
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $endSerial;
    /**
     * The batchNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $batchNumber;
    /**
     * Constructor method for activateTelephonyScratchCardsRequestImpl
     * @uses ActivateTelephonyScratchCardsRequestImpl::setStartSerial()
     * @uses ActivateTelephonyScratchCardsRequestImpl::setEndSerial()
     * @uses ActivateTelephonyScratchCardsRequestImpl::setBatchNumber()
     * @param string $startSerial
     * @param string $endSerial
     * @param string $batchNumber
     */
    public function __construct($startSerial = null, $endSerial = null, $batchNumber = null)
    {
        $this
            ->setStartSerial($startSerial)
            ->setEndSerial($endSerial)
            ->setBatchNumber($batchNumber);
    }
    /**
     * Get startSerial value
     * @return string|null
     */
    public function getStartSerial()
    {
        return $this->startSerial;
    }
    /**
     * Set startSerial value
     * @param string $startSerial
     * @return \StructType\ActivateTelephonyScratchCardsRequestImpl
     */
    public function setStartSerial($startSerial = null)
    {
        // validation for constraint: string
        if (!is_null($startSerial) && !is_string($startSerial)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($startSerial)), __LINE__);
        }
        $this->startSerial = $startSerial;
        return $this;
    }
    /**
     * Get endSerial value
     * @return string|null
     */
    public function getEndSerial()
    {
        return $this->endSerial;
    }
    /**
     * Set endSerial value
     * @param string $endSerial
     * @return \StructType\ActivateTelephonyScratchCardsRequestImpl
     */
    public function setEndSerial($endSerial = null)
    {
        // validation for constraint: string
        if (!is_null($endSerial) && !is_string($endSerial)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($endSerial)), __LINE__);
        }
        $this->endSerial = $endSerial;
        return $this;
    }
    /**
     * Get batchNumber value
     * @return string|null
     */
    public function getBatchNumber()
    {
        return $this->batchNumber;
    }
    /**
     * Set batchNumber value
     * @param string $batchNumber
     * @return \StructType\ActivateTelephonyScratchCardsRequestImpl
     */
    public function setBatchNumber($batchNumber = null)
    {
        // validation for constraint: string
        if (!is_null($batchNumber) && !is_string($batchNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($batchNumber)), __LINE__);
        }
        $this->batchNumber = $batchNumber;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ActivateTelephonyScratchCardsRequestImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
