<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for affectedElements StructType
 * @subpackage Structs
 */
class AffectedElements extends AbstractStructBase
{
    /**
     * The affectedElement
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $affectedElement;
    /**
     * Constructor method for affectedElements
     * @uses AffectedElements::setAffectedElement()
     * @param string[] $affectedElement
     */
    public function __construct(array $affectedElement = array())
    {
        $this
            ->setAffectedElement($affectedElement);
    }
    /**
     * Get affectedElement value
     * @return string[]|null
     */
    public function getAffectedElement()
    {
        return $this->affectedElement;
    }
    /**
     * Set affectedElement value
     * @throws \InvalidArgumentException
     * @param string[] $affectedElement
     * @return \StructType\AffectedElements
     */
    public function setAffectedElement(array $affectedElement = array())
    {
        foreach ($affectedElement as $affectedElementsAffectedElementItem) {
            // validation for constraint: itemType
            if (!is_string($affectedElementsAffectedElementItem)) {
                throw new \InvalidArgumentException(sprintf('The affectedElement property can only contain items of string, "%s" given', is_object($affectedElementsAffectedElementItem) ? get_class($affectedElementsAffectedElementItem) : gettype($affectedElementsAffectedElementItem)), __LINE__);
            }
        }
        $this->affectedElement = $affectedElement;
        return $this;
    }
    /**
     * Add item to affectedElement value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\AffectedElements
     */
    public function addToAffectedElement($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The affectedElement property can only contain items of string, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->affectedElement[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AffectedElements
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
