<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for assignedSerialRanges StructType
 * @subpackage Structs
 */
class AssignedSerialRanges extends AbstractStructBase
{
    /**
     * The assignedSerialRange
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SerialRangeImpl[]
     */
    public $assignedSerialRange;
    /**
     * Constructor method for assignedSerialRanges
     * @uses AssignedSerialRanges::setAssignedSerialRange()
     * @param \StructType\SerialRangeImpl[] $assignedSerialRange
     */
    public function __construct(array $assignedSerialRange = array())
    {
        $this
            ->setAssignedSerialRange($assignedSerialRange);
    }
    /**
     * Get assignedSerialRange value
     * @return \StructType\SerialRangeImpl[]|null
     */
    public function getAssignedSerialRange()
    {
        return $this->assignedSerialRange;
    }
    /**
     * Set assignedSerialRange value
     * @throws \InvalidArgumentException
     * @param \StructType\SerialRangeImpl[] $assignedSerialRange
     * @return \StructType\AssignedSerialRanges
     */
    public function setAssignedSerialRange(array $assignedSerialRange = array())
    {
        foreach ($assignedSerialRange as $assignedSerialRangesAssignedSerialRangeItem) {
            // validation for constraint: itemType
            if (!$assignedSerialRangesAssignedSerialRangeItem instanceof \StructType\SerialRangeImpl) {
                throw new \InvalidArgumentException(sprintf('The assignedSerialRange property can only contain items of \StructType\SerialRangeImpl, "%s" given', is_object($assignedSerialRangesAssignedSerialRangeItem) ? get_class($assignedSerialRangesAssignedSerialRangeItem) : gettype($assignedSerialRangesAssignedSerialRangeItem)), __LINE__);
            }
        }
        $this->assignedSerialRange = $assignedSerialRange;
        return $this;
    }
    /**
     * Add item to assignedSerialRange value
     * @throws \InvalidArgumentException
     * @param \StructType\SerialRangeImpl $item
     * @return \StructType\AssignedSerialRanges
     */
    public function addToAssignedSerialRange(\StructType\SerialRangeImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SerialRangeImpl) {
            throw new \InvalidArgumentException(sprintf('The assignedSerialRange property can only contain items of \StructType\SerialRangeImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->assignedSerialRange[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AssignedSerialRanges
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
