<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for atsSafetyInfoImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:atsSafetyInfoImpl
 * @subpackage Structs
 */
class AtsSafetyInfoImpl extends AbstractStructBase
{
    /**
     * The icao
     * @var string
     */
    public $icao;
    /**
     * The regTailNumber
     * @var string
     */
    public $regTailNumber;
    /**
     * The airline
     * @var string
     */
    public $airline;
    /**
     * Constructor method for atsSafetyInfoImpl
     * @uses AtsSafetyInfoImpl::setIcao()
     * @uses AtsSafetyInfoImpl::setRegTailNumber()
     * @uses AtsSafetyInfoImpl::setAirline()
     * @param string $icao
     * @param string $regTailNumber
     * @param string $airline
     */
    public function __construct($icao = null, $regTailNumber = null, $airline = null)
    {
        $this
            ->setIcao($icao)
            ->setRegTailNumber($regTailNumber)
            ->setAirline($airline);
    }
    /**
     * Get icao value
     * @return string|null
     */
    public function getIcao()
    {
        return $this->icao;
    }
    /**
     * Set icao value
     * @param string $icao
     * @return \StructType\AtsSafetyInfoImpl
     */
    public function setIcao($icao = null)
    {
        // validation for constraint: string
        if (!is_null($icao) && !is_string($icao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($icao)), __LINE__);
        }
        $this->icao = $icao;
        return $this;
    }
    /**
     * Get regTailNumber value
     * @return string|null
     */
    public function getRegTailNumber()
    {
        return $this->regTailNumber;
    }
    /**
     * Set regTailNumber value
     * @param string $regTailNumber
     * @return \StructType\AtsSafetyInfoImpl
     */
    public function setRegTailNumber($regTailNumber = null)
    {
        // validation for constraint: string
        if (!is_null($regTailNumber) && !is_string($regTailNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($regTailNumber)), __LINE__);
        }
        $this->regTailNumber = $regTailNumber;
        return $this;
    }
    /**
     * Get airline value
     * @return string|null
     */
    public function getAirline()
    {
        return $this->airline;
    }
    /**
     * Set airline value
     * @param string $airline
     * @return \StructType\AtsSafetyInfoImpl
     */
    public function setAirline($airline = null)
    {
        // validation for constraint: string
        if (!is_null($airline) && !is_string($airline)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($airline)), __LINE__);
        }
        $this->airline = $airline;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AtsSafetyInfoImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
