<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for atsSubscriberAccountImpl StructType
 * @subpackage Structs
 */
class AtsSubscriberAccountImpl extends AbsSubscriberAccountImpl
{
    /**
     * The icao
     * @var string
     */
    public $icao;
    /**
     * The regTailNumber
     * @var string
     */
    public $regTailNumber;
    /**
     * The airline
     * @var string
     */
    public $airline;
    /**
     * The activateSecondary
     * @var bool
     */
    public $activateSecondary;
    /**
     * The telephonySubscriberAccountPrimary
     * @var \StructType\TelephonySubscriberAccountImpl
     */
    public $telephonySubscriberAccountPrimary;
    /**
     * The telephonySubscriberAccountSecondary
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TelephonySubscriberAccountImpl
     */
    public $telephonySubscriberAccountSecondary;
    /**
     * Constructor method for atsSubscriberAccountImpl
     * @uses AtsSubscriberAccountImpl::setIcao()
     * @uses AtsSubscriberAccountImpl::setRegTailNumber()
     * @uses AtsSubscriberAccountImpl::setAirline()
     * @uses AtsSubscriberAccountImpl::setActivateSecondary()
     * @uses AtsSubscriberAccountImpl::setTelephonySubscriberAccountPrimary()
     * @uses AtsSubscriberAccountImpl::setTelephonySubscriberAccountSecondary()
     * @param string $icao
     * @param string $regTailNumber
     * @param string $airline
     * @param bool $activateSecondary
     * @param \StructType\TelephonySubscriberAccountImpl $telephonySubscriberAccountPrimary
     * @param \StructType\TelephonySubscriberAccountImpl $telephonySubscriberAccountSecondary
     */
    public function __construct($icao = null, $regTailNumber = null, $airline = null, $activateSecondary = null, \StructType\TelephonySubscriberAccountImpl $telephonySubscriberAccountPrimary = null, \StructType\TelephonySubscriberAccountImpl $telephonySubscriberAccountSecondary = null)
    {
        $this
            ->setIcao($icao)
            ->setRegTailNumber($regTailNumber)
            ->setAirline($airline)
            ->setActivateSecondary($activateSecondary)
            ->setTelephonySubscriberAccountPrimary($telephonySubscriberAccountPrimary)
            ->setTelephonySubscriberAccountSecondary($telephonySubscriberAccountSecondary);
    }
    /**
     * Get icao value
     * @return string|null
     */
    public function getIcao()
    {
        return $this->icao;
    }
    /**
     * Set icao value
     * @param string $icao
     * @return \StructType\AtsSubscriberAccountImpl
     */
    public function setIcao($icao = null)
    {
        // validation for constraint: string
        if (!is_null($icao) && !is_string($icao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($icao)), __LINE__);
        }
        $this->icao = $icao;
        return $this;
    }
    /**
     * Get regTailNumber value
     * @return string|null
     */
    public function getRegTailNumber()
    {
        return $this->regTailNumber;
    }
    /**
     * Set regTailNumber value
     * @param string $regTailNumber
     * @return \StructType\AtsSubscriberAccountImpl
     */
    public function setRegTailNumber($regTailNumber = null)
    {
        // validation for constraint: string
        if (!is_null($regTailNumber) && !is_string($regTailNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($regTailNumber)), __LINE__);
        }
        $this->regTailNumber = $regTailNumber;
        return $this;
    }
    /**
     * Get airline value
     * @return string|null
     */
    public function getAirline()
    {
        return $this->airline;
    }
    /**
     * Set airline value
     * @param string $airline
     * @return \StructType\AtsSubscriberAccountImpl
     */
    public function setAirline($airline = null)
    {
        // validation for constraint: string
        if (!is_null($airline) && !is_string($airline)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($airline)), __LINE__);
        }
        $this->airline = $airline;
        return $this;
    }
    /**
     * Get activateSecondary value
     * @return bool|null
     */
    public function getActivateSecondary()
    {
        return $this->activateSecondary;
    }
    /**
     * Set activateSecondary value
     * @param bool $activateSecondary
     * @return \StructType\AtsSubscriberAccountImpl
     */
    public function setActivateSecondary($activateSecondary = null)
    {
        $this->activateSecondary = $activateSecondary;
        return $this;
    }
    /**
     * Get telephonySubscriberAccountPrimary value
     * @return \StructType\TelephonySubscriberAccountImpl|null
     */
    public function getTelephonySubscriberAccountPrimary()
    {
        return $this->telephonySubscriberAccountPrimary;
    }
    /**
     * Set telephonySubscriberAccountPrimary value
     * @param \StructType\TelephonySubscriberAccountImpl $telephonySubscriberAccountPrimary
     * @return \StructType\AtsSubscriberAccountImpl
     */
    public function setTelephonySubscriberAccountPrimary(\StructType\TelephonySubscriberAccountImpl $telephonySubscriberAccountPrimary = null)
    {
        $this->telephonySubscriberAccountPrimary = $telephonySubscriberAccountPrimary;
        return $this;
    }
    /**
     * Get telephonySubscriberAccountSecondary value
     * @return \StructType\TelephonySubscriberAccountImpl|null
     */
    public function getTelephonySubscriberAccountSecondary()
    {
        return $this->telephonySubscriberAccountSecondary;
    }
    /**
     * Set telephonySubscriberAccountSecondary value
     * @param \StructType\TelephonySubscriberAccountImpl $telephonySubscriberAccountSecondary
     * @return \StructType\AtsSubscriberAccountImpl
     */
    public function setTelephonySubscriberAccountSecondary(\StructType\TelephonySubscriberAccountImpl $telephonySubscriberAccountSecondary = null)
    {
        $this->telephonySubscriberAccountSecondary = $telephonySubscriberAccountSecondary;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AtsSubscriberAccountImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
