<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for batches StructType
 * @subpackage Structs
 */
class Batches extends AbstractStructBase
{
    /**
     * The batch
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ScratchCardActivationStatusImpl[]
     */
    public $batch;
    /**
     * Constructor method for batches
     * @uses Batches::setBatch()
     * @param \StructType\ScratchCardActivationStatusImpl[] $batch
     */
    public function __construct(array $batch = array())
    {
        $this
            ->setBatch($batch);
    }
    /**
     * Get batch value
     * @return \StructType\ScratchCardActivationStatusImpl[]|null
     */
    public function getBatch()
    {
        return $this->batch;
    }
    /**
     * Set batch value
     * @throws \InvalidArgumentException
     * @param \StructType\ScratchCardActivationStatusImpl[] $batch
     * @return \StructType\Batches
     */
    public function setBatch(array $batch = array())
    {
        foreach ($batch as $batchesBatchItem) {
            // validation for constraint: itemType
            if (!$batchesBatchItem instanceof \StructType\ScratchCardActivationStatusImpl) {
                throw new \InvalidArgumentException(sprintf('The batch property can only contain items of \StructType\ScratchCardActivationStatusImpl, "%s" given', is_object($batchesBatchItem) ? get_class($batchesBatchItem) : gettype($batchesBatchItem)), __LINE__);
            }
        }
        $this->batch = $batch;
        return $this;
    }
    /**
     * Add item to batch value
     * @throws \InvalidArgumentException
     * @param \StructType\ScratchCardActivationStatusImpl $item
     * @return \StructType\Batches
     */
    public function addToBatch(\StructType\ScratchCardActivationStatusImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ScratchCardActivationStatusImpl) {
            throw new \InvalidArgumentException(sprintf('The batch property can only contain items of \StructType\ScratchCardActivationStatusImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->batch[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Batches
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
