<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for burstDeviceSubscriberAccountImpl StructType
 * @subpackage Structs
 */
class BurstDeviceSubscriberAccountImpl extends AbsSubscriberAccountImpl
{
    /**
     * The commitmentStart
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $commitmentStart;
    /**
     * The commitmentEnd
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $commitmentEnd;
    /**
     * The plan
     * @var \StructType\BurstDevicePlanImpl
     */
    public $plan;
    /**
     * The subscriberAccountMetadata
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BurstDeviceSubscriberAccountMetadataImpl
     */
    public $subscriberAccountMetadata;
    /**
     * The imei
     * @var string
     */
    public $imei;
    /**
     * The subscriptions
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Subscriptions
     */
    public $subscriptions;
    /**
     * Constructor method for burstDeviceSubscriberAccountImpl
     * @uses BurstDeviceSubscriberAccountImpl::setCommitmentStart()
     * @uses BurstDeviceSubscriberAccountImpl::setCommitmentEnd()
     * @uses BurstDeviceSubscriberAccountImpl::setPlan()
     * @uses BurstDeviceSubscriberAccountImpl::setSubscriberAccountMetadata()
     * @uses BurstDeviceSubscriberAccountImpl::setImei()
     * @uses BurstDeviceSubscriberAccountImpl::setSubscriptions()
     * @param string $commitmentStart
     * @param string $commitmentEnd
     * @param \StructType\BurstDevicePlanImpl $plan
     * @param \StructType\BurstDeviceSubscriberAccountMetadataImpl $subscriberAccountMetadata
     * @param string $imei
     * @param \StructType\Subscriptions $subscriptions
     */
    public function __construct($commitmentStart = null, $commitmentEnd = null, \StructType\BurstDevicePlanImpl $plan = null, \StructType\BurstDeviceSubscriberAccountMetadataImpl $subscriberAccountMetadata = null, $imei = null, \StructType\Subscriptions $subscriptions = null)
    {
        $this
            ->setCommitmentStart($commitmentStart)
            ->setCommitmentEnd($commitmentEnd)
            ->setPlan($plan)
            ->setSubscriberAccountMetadata($subscriberAccountMetadata)
            ->setImei($imei)
            ->setSubscriptions($subscriptions);
    }
    /**
     * Get commitmentStart value
     * @return string|null
     */
    public function getCommitmentStart()
    {
        return $this->commitmentStart;
    }
    /**
     * Set commitmentStart value
     * @param string $commitmentStart
     * @return \StructType\BurstDeviceSubscriberAccountImpl
     */
    public function setCommitmentStart($commitmentStart = null)
    {
        // validation for constraint: string
        if (!is_null($commitmentStart) && !is_string($commitmentStart)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($commitmentStart)), __LINE__);
        }
        $this->commitmentStart = $commitmentStart;
        return $this;
    }
    /**
     * Get commitmentEnd value
     * @return string|null
     */
    public function getCommitmentEnd()
    {
        return $this->commitmentEnd;
    }
    /**
     * Set commitmentEnd value
     * @param string $commitmentEnd
     * @return \StructType\BurstDeviceSubscriberAccountImpl
     */
    public function setCommitmentEnd($commitmentEnd = null)
    {
        // validation for constraint: string
        if (!is_null($commitmentEnd) && !is_string($commitmentEnd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($commitmentEnd)), __LINE__);
        }
        $this->commitmentEnd = $commitmentEnd;
        return $this;
    }
    /**
     * Get plan value
     * @return \StructType\BurstDevicePlanImpl|null
     */
    public function getPlan()
    {
        return $this->plan;
    }
    /**
     * Set plan value
     * @param \StructType\BurstDevicePlanImpl $plan
     * @return \StructType\BurstDeviceSubscriberAccountImpl
     */
    public function setPlan(\StructType\BurstDevicePlanImpl $plan = null)
    {
        $this->plan = $plan;
        return $this;
    }
    /**
     * Get subscriberAccountMetadata value
     * @return \StructType\BurstDeviceSubscriberAccountMetadataImpl|null
     */
    public function getSubscriberAccountMetadata()
    {
        return $this->subscriberAccountMetadata;
    }
    /**
     * Set subscriberAccountMetadata value
     * @param \StructType\BurstDeviceSubscriberAccountMetadataImpl $subscriberAccountMetadata
     * @return \StructType\BurstDeviceSubscriberAccountImpl
     */
    public function setSubscriberAccountMetadata(\StructType\BurstDeviceSubscriberAccountMetadataImpl $subscriberAccountMetadata = null)
    {
        $this->subscriberAccountMetadata = $subscriberAccountMetadata;
        return $this;
    }
    /**
     * Get imei value
     * @return string|null
     */
    public function getImei()
    {
        return $this->imei;
    }
    /**
     * Set imei value
     * @param string $imei
     * @return \StructType\BurstDeviceSubscriberAccountImpl
     */
    public function setImei($imei = null)
    {
        // validation for constraint: string
        if (!is_null($imei) && !is_string($imei)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($imei)), __LINE__);
        }
        $this->imei = $imei;
        return $this;
    }
    /**
     * Get subscriptions value
     * @return \StructType\Subscriptions|null
     */
    public function getSubscriptions()
    {
        return $this->subscriptions;
    }
    /**
     * Set subscriptions value
     * @param \StructType\Subscriptions $subscriptions
     * @return \StructType\BurstDeviceSubscriberAccountImpl
     */
    public function setSubscriptions(\StructType\Subscriptions $subscriptions = null)
    {
        $this->subscriptions = $subscriptions;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BurstDeviceSubscriberAccountImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
