<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for burstSubscriptionResponseImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:burstSubscriptionResponseImpl
 * @subpackage Structs
 */
class BurstSubscriptionResponseImpl extends AbstractStructBase
{
    /**
     * The purchaseOrder
     * @var string
     */
    public $purchaseOrder;
    /**
     * The requestId
     * @var string
     */
    public $requestId;
    /**
     * The serialNumbers
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SerialNumbers
     */
    public $serialNumbers;
    /**
     * Constructor method for burstSubscriptionResponseImpl
     * @uses BurstSubscriptionResponseImpl::setPurchaseOrder()
     * @uses BurstSubscriptionResponseImpl::setRequestId()
     * @uses BurstSubscriptionResponseImpl::setSerialNumbers()
     * @param string $purchaseOrder
     * @param string $requestId
     * @param \StructType\SerialNumbers $serialNumbers
     */
    public function __construct($purchaseOrder = null, $requestId = null, \StructType\SerialNumbers $serialNumbers = null)
    {
        $this
            ->setPurchaseOrder($purchaseOrder)
            ->setRequestId($requestId)
            ->setSerialNumbers($serialNumbers);
    }
    /**
     * Get purchaseOrder value
     * @return string|null
     */
    public function getPurchaseOrder()
    {
        return $this->purchaseOrder;
    }
    /**
     * Set purchaseOrder value
     * @param string $purchaseOrder
     * @return \StructType\BurstSubscriptionResponseImpl
     */
    public function setPurchaseOrder($purchaseOrder = null)
    {
        // validation for constraint: string
        if (!is_null($purchaseOrder) && !is_string($purchaseOrder)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($purchaseOrder)), __LINE__);
        }
        $this->purchaseOrder = $purchaseOrder;
        return $this;
    }
    /**
     * Get requestId value
     * @return string|null
     */
    public function getRequestId()
    {
        return $this->requestId;
    }
    /**
     * Set requestId value
     * @param string $requestId
     * @return \StructType\BurstSubscriptionResponseImpl
     */
    public function setRequestId($requestId = null)
    {
        // validation for constraint: string
        if (!is_null($requestId) && !is_string($requestId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($requestId)), __LINE__);
        }
        $this->requestId = $requestId;
        return $this;
    }
    /**
     * Get serialNumbers value
     * @return \StructType\SerialNumbers|null
     */
    public function getSerialNumbers()
    {
        return $this->serialNumbers;
    }
    /**
     * Set serialNumbers value
     * @param \StructType\SerialNumbers $serialNumbers
     * @return \StructType\BurstSubscriptionResponseImpl
     */
    public function setSerialNumbers(\StructType\SerialNumbers $serialNumbers = null)
    {
        $this->serialNumbers = $serialNumbers;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BurstSubscriptionResponseImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
