<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for certusSbdImpl StructType
 * @subpackage Structs
 */
class CertusSbdImpl extends AbsMemberServiceImpl
{
    /**
     * The lritFlagstate
     * @var string
     */
    public $lritFlagstate;
    /**
     * The ringAlertsFlag
     * Meta informations extracted from the WSDL
     * - default: false
     * @var bool
     */
    public $ringAlertsFlag;
    /**
     * The deliveryDetails
     * @var \StructType\DeliveryDetails
     */
    public $deliveryDetails;
    /**
     * The mtFilters
     * @var \StructType\MtFilters
     */
    public $mtFilters;
    /**
     * Constructor method for certusSbdImpl
     * @uses CertusSbdImpl::setLritFlagstate()
     * @uses CertusSbdImpl::setRingAlertsFlag()
     * @uses CertusSbdImpl::setDeliveryDetails()
     * @uses CertusSbdImpl::setMtFilters()
     * @param string $lritFlagstate
     * @param bool $ringAlertsFlag
     * @param \StructType\DeliveryDetails $deliveryDetails
     * @param \StructType\MtFilters $mtFilters
     */
    public function __construct($lritFlagstate = null, $ringAlertsFlag = false, \StructType\DeliveryDetails $deliveryDetails = null, \StructType\MtFilters $mtFilters = null)
    {
        $this
            ->setLritFlagstate($lritFlagstate)
            ->setRingAlertsFlag($ringAlertsFlag)
            ->setDeliveryDetails($deliveryDetails)
            ->setMtFilters($mtFilters);
    }
    /**
     * Get lritFlagstate value
     * @return string|null
     */
    public function getLritFlagstate()
    {
        return $this->lritFlagstate;
    }
    /**
     * Set lritFlagstate value
     * @param string $lritFlagstate
     * @return \StructType\CertusSbdImpl
     */
    public function setLritFlagstate($lritFlagstate = null)
    {
        // validation for constraint: string
        if (!is_null($lritFlagstate) && !is_string($lritFlagstate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lritFlagstate)), __LINE__);
        }
        $this->lritFlagstate = $lritFlagstate;
        return $this;
    }
    /**
     * Get ringAlertsFlag value
     * @return bool|null
     */
    public function getRingAlertsFlag()
    {
        return $this->ringAlertsFlag;
    }
    /**
     * Set ringAlertsFlag value
     * @param bool $ringAlertsFlag
     * @return \StructType\CertusSbdImpl
     */
    public function setRingAlertsFlag($ringAlertsFlag = false)
    {
        $this->ringAlertsFlag = $ringAlertsFlag;
        return $this;
    }
    /**
     * Get deliveryDetails value
     * @return \StructType\DeliveryDetails|null
     */
    public function getDeliveryDetails()
    {
        return $this->deliveryDetails;
    }
    /**
     * Set deliveryDetails value
     * @param \StructType\DeliveryDetails $deliveryDetails
     * @return \StructType\CertusSbdImpl
     */
    public function setDeliveryDetails(\StructType\DeliveryDetails $deliveryDetails = null)
    {
        $this->deliveryDetails = $deliveryDetails;
        return $this;
    }
    /**
     * Get mtFilters value
     * @return \StructType\MtFilters|null
     */
    public function getMtFilters()
    {
        return $this->mtFilters;
    }
    /**
     * Set mtFilters value
     * @param \StructType\MtFilters $mtFilters
     * @return \StructType\CertusSbdImpl
     */
    public function setMtFilters(\StructType\MtFilters $mtFilters = null)
    {
        $this->mtFilters = $mtFilters;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CertusSbdImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
