<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for certusSubscriberAccountImpl StructType
 * @subpackage Structs
 */
class CertusSubscriberAccountImpl extends AbsSubscriberAccountImpl
{
    /**
     * The commitmentStart
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $commitmentStart;
    /**
     * The commitmentEnd
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $commitmentEnd;
    /**
     * The plan
     * @var \StructType\CertusPlanImpl
     */
    public $plan;
    /**
     * The sim
     * @var \StructType\DeviceSimImpl
     */
    public $sim;
    /**
     * The imei
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $imei;
    /**
     * The ip
     * @var \StructType\DeviceIpImpl
     */
    public $ip;
    /**
     * The publicIp
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $publicIp;
    /**
     * The simImeiLock
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $simImeiLock;
    /**
     * The safetyEnabled
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $safetyEnabled;
    /**
     * The atsSafetyInfo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\AtsSafetyInfoImpl
     */
    public $atsSafetyInfo;
    /**
     * The maritimeSafetyInfo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MaritimeSafetyInfoImpl
     */
    public $maritimeSafetyInfo;
    /**
     * The scratchCardsRestricted
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $scratchCardsRestricted;
    /**
     * The subscriberAccountMetadata
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CertusSubscriberAccountMetadataImpl
     */
    public $subscriberAccountMetadata;
    /**
     * The voiceToggle
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $voiceToggle;
    /**
     * The voiceServiceDetail
     * @var \StructType\CertusVoiceImpl
     */
    public $voiceServiceDetail;
    /**
     * The streamingToggle
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $streamingToggle;
    /**
     * The streamingServiceDetail
     * @var \StructType\CertusStreamingImpl
     */
    public $streamingServiceDetail;
    /**
     * The sbdToggle
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $sbdToggle;
    /**
     * The sbdServiceDetail
     * @var \StructType\CertusSbdImpl
     */
    public $sbdServiceDetail;
    /**
     * The burstToggle
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $burstToggle;
    /**
     * The burstServiceDetail
     * @var \StructType\CertusBurstImpl
     */
    public $burstServiceDetail;
    /**
     * Constructor method for certusSubscriberAccountImpl
     * @uses CertusSubscriberAccountImpl::setCommitmentStart()
     * @uses CertusSubscriberAccountImpl::setCommitmentEnd()
     * @uses CertusSubscriberAccountImpl::setPlan()
     * @uses CertusSubscriberAccountImpl::setSim()
     * @uses CertusSubscriberAccountImpl::setImei()
     * @uses CertusSubscriberAccountImpl::setIp()
     * @uses CertusSubscriberAccountImpl::setPublicIp()
     * @uses CertusSubscriberAccountImpl::setSimImeiLock()
     * @uses CertusSubscriberAccountImpl::setSafetyEnabled()
     * @uses CertusSubscriberAccountImpl::setAtsSafetyInfo()
     * @uses CertusSubscriberAccountImpl::setMaritimeSafetyInfo()
     * @uses CertusSubscriberAccountImpl::setScratchCardsRestricted()
     * @uses CertusSubscriberAccountImpl::setSubscriberAccountMetadata()
     * @uses CertusSubscriberAccountImpl::setVoiceToggle()
     * @uses CertusSubscriberAccountImpl::setVoiceServiceDetail()
     * @uses CertusSubscriberAccountImpl::setStreamingToggle()
     * @uses CertusSubscriberAccountImpl::setStreamingServiceDetail()
     * @uses CertusSubscriberAccountImpl::setSbdToggle()
     * @uses CertusSubscriberAccountImpl::setSbdServiceDetail()
     * @uses CertusSubscriberAccountImpl::setBurstToggle()
     * @uses CertusSubscriberAccountImpl::setBurstServiceDetail()
     * @param string $commitmentStart
     * @param string $commitmentEnd
     * @param \StructType\CertusPlanImpl $plan
     * @param \StructType\DeviceSimImpl $sim
     * @param string $imei
     * @param \StructType\DeviceIpImpl $ip
     * @param string $publicIp
     * @param string $simImeiLock
     * @param string $safetyEnabled
     * @param \StructType\AtsSafetyInfoImpl $atsSafetyInfo
     * @param \StructType\MaritimeSafetyInfoImpl $maritimeSafetyInfo
     * @param string $scratchCardsRestricted
     * @param \StructType\CertusSubscriberAccountMetadataImpl $subscriberAccountMetadata
     * @param string $voiceToggle
     * @param \StructType\CertusVoiceImpl $voiceServiceDetail
     * @param string $streamingToggle
     * @param \StructType\CertusStreamingImpl $streamingServiceDetail
     * @param string $sbdToggle
     * @param \StructType\CertusSbdImpl $sbdServiceDetail
     * @param string $burstToggle
     * @param \StructType\CertusBurstImpl $burstServiceDetail
     */
    public function __construct($commitmentStart = null, $commitmentEnd = null, \StructType\CertusPlanImpl $plan = null, \StructType\DeviceSimImpl $sim = null, $imei = null, \StructType\DeviceIpImpl $ip = null, $publicIp = null, $simImeiLock = null, $safetyEnabled = null, \StructType\AtsSafetyInfoImpl $atsSafetyInfo = null, \StructType\MaritimeSafetyInfoImpl $maritimeSafetyInfo = null, $scratchCardsRestricted = null, \StructType\CertusSubscriberAccountMetadataImpl $subscriberAccountMetadata = null, $voiceToggle = null, \StructType\CertusVoiceImpl $voiceServiceDetail = null, $streamingToggle = null, \StructType\CertusStreamingImpl $streamingServiceDetail = null, $sbdToggle = null, \StructType\CertusSbdImpl $sbdServiceDetail = null, $burstToggle = null, \StructType\CertusBurstImpl $burstServiceDetail = null)
    {
        $this
            ->setCommitmentStart($commitmentStart)
            ->setCommitmentEnd($commitmentEnd)
            ->setPlan($plan)
            ->setSim($sim)
            ->setImei($imei)
            ->setIp($ip)
            ->setPublicIp($publicIp)
            ->setSimImeiLock($simImeiLock)
            ->setSafetyEnabled($safetyEnabled)
            ->setAtsSafetyInfo($atsSafetyInfo)
            ->setMaritimeSafetyInfo($maritimeSafetyInfo)
            ->setScratchCardsRestricted($scratchCardsRestricted)
            ->setSubscriberAccountMetadata($subscriberAccountMetadata)
            ->setVoiceToggle($voiceToggle)
            ->setVoiceServiceDetail($voiceServiceDetail)
            ->setStreamingToggle($streamingToggle)
            ->setStreamingServiceDetail($streamingServiceDetail)
            ->setSbdToggle($sbdToggle)
            ->setSbdServiceDetail($sbdServiceDetail)
            ->setBurstToggle($burstToggle)
            ->setBurstServiceDetail($burstServiceDetail);
    }
    /**
     * Get commitmentStart value
     * @return string|null
     */
    public function getCommitmentStart()
    {
        return $this->commitmentStart;
    }
    /**
     * Set commitmentStart value
     * @param string $commitmentStart
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setCommitmentStart($commitmentStart = null)
    {
        // validation for constraint: string
        if (!is_null($commitmentStart) && !is_string($commitmentStart)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($commitmentStart)), __LINE__);
        }
        $this->commitmentStart = $commitmentStart;
        return $this;
    }
    /**
     * Get commitmentEnd value
     * @return string|null
     */
    public function getCommitmentEnd()
    {
        return $this->commitmentEnd;
    }
    /**
     * Set commitmentEnd value
     * @param string $commitmentEnd
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setCommitmentEnd($commitmentEnd = null)
    {
        // validation for constraint: string
        if (!is_null($commitmentEnd) && !is_string($commitmentEnd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($commitmentEnd)), __LINE__);
        }
        $this->commitmentEnd = $commitmentEnd;
        return $this;
    }
    /**
     * Get plan value
     * @return \StructType\CertusPlanImpl|null
     */
    public function getPlan()
    {
        return $this->plan;
    }
    /**
     * Set plan value
     * @param \StructType\CertusPlanImpl $plan
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setPlan(\StructType\CertusPlanImpl $plan = null)
    {
        $this->plan = $plan;
        return $this;
    }
    /**
     * Get sim value
     * @return \StructType\DeviceSimImpl|null
     */
    public function getSim()
    {
        return $this->sim;
    }
    /**
     * Set sim value
     * @param \StructType\DeviceSimImpl $sim
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setSim(\StructType\DeviceSimImpl $sim = null)
    {
        $this->sim = $sim;
        return $this;
    }
    /**
     * Get imei value
     * @return string|null
     */
    public function getImei()
    {
        return $this->imei;
    }
    /**
     * Set imei value
     * @param string $imei
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setImei($imei = null)
    {
        // validation for constraint: string
        if (!is_null($imei) && !is_string($imei)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($imei)), __LINE__);
        }
        $this->imei = $imei;
        return $this;
    }
    /**
     * Get ip value
     * @return \StructType\DeviceIpImpl|null
     */
    public function getIp()
    {
        return $this->ip;
    }
    /**
     * Set ip value
     * @param \StructType\DeviceIpImpl $ip
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setIp(\StructType\DeviceIpImpl $ip = null)
    {
        $this->ip = $ip;
        return $this;
    }
    /**
     * Get publicIp value
     * @return string|null
     */
    public function getPublicIp()
    {
        return $this->publicIp;
    }
    /**
     * Set publicIp value
     * @param string $publicIp
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setPublicIp($publicIp = null)
    {
        // validation for constraint: string
        if (!is_null($publicIp) && !is_string($publicIp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($publicIp)), __LINE__);
        }
        $this->publicIp = $publicIp;
        return $this;
    }
    /**
     * Get simImeiLock value
     * @return string|null
     */
    public function getSimImeiLock()
    {
        return $this->simImeiLock;
    }
    /**
     * Set simImeiLock value
     * @param string $simImeiLock
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setSimImeiLock($simImeiLock = null)
    {
        // validation for constraint: string
        if (!is_null($simImeiLock) && !is_string($simImeiLock)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($simImeiLock)), __LINE__);
        }
        $this->simImeiLock = $simImeiLock;
        return $this;
    }
    /**
     * Get safetyEnabled value
     * @return string|null
     */
    public function getSafetyEnabled()
    {
        return $this->safetyEnabled;
    }
    /**
     * Set safetyEnabled value
     * @param string $safetyEnabled
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setSafetyEnabled($safetyEnabled = null)
    {
        // validation for constraint: string
        if (!is_null($safetyEnabled) && !is_string($safetyEnabled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($safetyEnabled)), __LINE__);
        }
        $this->safetyEnabled = $safetyEnabled;
        return $this;
    }
    /**
     * Get atsSafetyInfo value
     * @return \StructType\AtsSafetyInfoImpl|null
     */
    public function getAtsSafetyInfo()
    {
        return $this->atsSafetyInfo;
    }
    /**
     * Set atsSafetyInfo value
     * @param \StructType\AtsSafetyInfoImpl $atsSafetyInfo
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setAtsSafetyInfo(\StructType\AtsSafetyInfoImpl $atsSafetyInfo = null)
    {
        $this->atsSafetyInfo = $atsSafetyInfo;
        return $this;
    }
    /**
     * Get maritimeSafetyInfo value
     * @return \StructType\MaritimeSafetyInfoImpl|null
     */
    public function getMaritimeSafetyInfo()
    {
        return $this->maritimeSafetyInfo;
    }
    /**
     * Set maritimeSafetyInfo value
     * @param \StructType\MaritimeSafetyInfoImpl $maritimeSafetyInfo
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setMaritimeSafetyInfo(\StructType\MaritimeSafetyInfoImpl $maritimeSafetyInfo = null)
    {
        $this->maritimeSafetyInfo = $maritimeSafetyInfo;
        return $this;
    }
    /**
     * Get scratchCardsRestricted value
     * @return string|null
     */
    public function getScratchCardsRestricted()
    {
        return $this->scratchCardsRestricted;
    }
    /**
     * Set scratchCardsRestricted value
     * @param string $scratchCardsRestricted
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setScratchCardsRestricted($scratchCardsRestricted = null)
    {
        // validation for constraint: string
        if (!is_null($scratchCardsRestricted) && !is_string($scratchCardsRestricted)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($scratchCardsRestricted)), __LINE__);
        }
        $this->scratchCardsRestricted = $scratchCardsRestricted;
        return $this;
    }
    /**
     * Get subscriberAccountMetadata value
     * @return \StructType\CertusSubscriberAccountMetadataImpl|null
     */
    public function getSubscriberAccountMetadata()
    {
        return $this->subscriberAccountMetadata;
    }
    /**
     * Set subscriberAccountMetadata value
     * @param \StructType\CertusSubscriberAccountMetadataImpl $subscriberAccountMetadata
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setSubscriberAccountMetadata(\StructType\CertusSubscriberAccountMetadataImpl $subscriberAccountMetadata = null)
    {
        $this->subscriberAccountMetadata = $subscriberAccountMetadata;
        return $this;
    }
    /**
     * Get voiceToggle value
     * @return string|null
     */
    public function getVoiceToggle()
    {
        return $this->voiceToggle;
    }
    /**
     * Set voiceToggle value
     * @param string $voiceToggle
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setVoiceToggle($voiceToggle = null)
    {
        // validation for constraint: string
        if (!is_null($voiceToggle) && !is_string($voiceToggle)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($voiceToggle)), __LINE__);
        }
        $this->voiceToggle = $voiceToggle;
        return $this;
    }
    /**
     * Get voiceServiceDetail value
     * @return \StructType\CertusVoiceImpl|null
     */
    public function getVoiceServiceDetail()
    {
        return $this->voiceServiceDetail;
    }
    /**
     * Set voiceServiceDetail value
     * @param \StructType\CertusVoiceImpl $voiceServiceDetail
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setVoiceServiceDetail(\StructType\CertusVoiceImpl $voiceServiceDetail = null)
    {
        $this->voiceServiceDetail = $voiceServiceDetail;
        return $this;
    }
    /**
     * Get streamingToggle value
     * @return string|null
     */
    public function getStreamingToggle()
    {
        return $this->streamingToggle;
    }
    /**
     * Set streamingToggle value
     * @param string $streamingToggle
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setStreamingToggle($streamingToggle = null)
    {
        // validation for constraint: string
        if (!is_null($streamingToggle) && !is_string($streamingToggle)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($streamingToggle)), __LINE__);
        }
        $this->streamingToggle = $streamingToggle;
        return $this;
    }
    /**
     * Get streamingServiceDetail value
     * @return \StructType\CertusStreamingImpl|null
     */
    public function getStreamingServiceDetail()
    {
        return $this->streamingServiceDetail;
    }
    /**
     * Set streamingServiceDetail value
     * @param \StructType\CertusStreamingImpl $streamingServiceDetail
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setStreamingServiceDetail(\StructType\CertusStreamingImpl $streamingServiceDetail = null)
    {
        $this->streamingServiceDetail = $streamingServiceDetail;
        return $this;
    }
    /**
     * Get sbdToggle value
     * @return string|null
     */
    public function getSbdToggle()
    {
        return $this->sbdToggle;
    }
    /**
     * Set sbdToggle value
     * @param string $sbdToggle
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setSbdToggle($sbdToggle = null)
    {
        // validation for constraint: string
        if (!is_null($sbdToggle) && !is_string($sbdToggle)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sbdToggle)), __LINE__);
        }
        $this->sbdToggle = $sbdToggle;
        return $this;
    }
    /**
     * Get sbdServiceDetail value
     * @return \StructType\CertusSbdImpl|null
     */
    public function getSbdServiceDetail()
    {
        return $this->sbdServiceDetail;
    }
    /**
     * Set sbdServiceDetail value
     * @param \StructType\CertusSbdImpl $sbdServiceDetail
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setSbdServiceDetail(\StructType\CertusSbdImpl $sbdServiceDetail = null)
    {
        $this->sbdServiceDetail = $sbdServiceDetail;
        return $this;
    }
    /**
     * Get burstToggle value
     * @return string|null
     */
    public function getBurstToggle()
    {
        return $this->burstToggle;
    }
    /**
     * Set burstToggle value
     * @param string $burstToggle
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setBurstToggle($burstToggle = null)
    {
        // validation for constraint: string
        if (!is_null($burstToggle) && !is_string($burstToggle)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($burstToggle)), __LINE__);
        }
        $this->burstToggle = $burstToggle;
        return $this;
    }
    /**
     * Get burstServiceDetail value
     * @return \StructType\CertusBurstImpl|null
     */
    public function getBurstServiceDetail()
    {
        return $this->burstServiceDetail;
    }
    /**
     * Set burstServiceDetail value
     * @param \StructType\CertusBurstImpl $burstServiceDetail
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public function setBurstServiceDetail(\StructType\CertusBurstImpl $burstServiceDetail = null)
    {
        $this->burstServiceDetail = $burstServiceDetail;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CertusSubscriberAccountImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
