<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for deliveryDestinationSearchAndReplaceResponseImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:deliveryDestinationSearchAndReplaceResponseImpl
 * @subpackage Structs
 */
class DeliveryDestinationSearchAndReplaceResponseImpl extends IwsResponseImpl
{
    /**
     * The results
     * @var \StructType\Results
     */
    public $results;
    /**
     * The configuredResultLimit
     * @var int
     */
    public $configuredResultLimit;
    /**
     * The totalResultCount
     * @var int
     */
    public $totalResultCount;
    /**
     * Constructor method for deliveryDestinationSearchAndReplaceResponseImpl
     * @uses DeliveryDestinationSearchAndReplaceResponseImpl::setResults()
     * @uses DeliveryDestinationSearchAndReplaceResponseImpl::setConfiguredResultLimit()
     * @uses DeliveryDestinationSearchAndReplaceResponseImpl::setTotalResultCount()
     * @param \StructType\Results $results
     * @param int $configuredResultLimit
     * @param int $totalResultCount
     */
    public function __construct(\StructType\Results $results = null, $configuredResultLimit = null, $totalResultCount = null)
    {
        $this
            ->setResults($results)
            ->setConfiguredResultLimit($configuredResultLimit)
            ->setTotalResultCount($totalResultCount);
    }
    /**
     * Get results value
     * @return \StructType\Results|null
     */
    public function getResults()
    {
        return $this->results;
    }
    /**
     * Set results value
     * @param \StructType\Results $results
     * @return \StructType\DeliveryDestinationSearchAndReplaceResponseImpl
     */
    public function setResults(\StructType\Results $results = null)
    {
        $this->results = $results;
        return $this;
    }
    /**
     * Get configuredResultLimit value
     * @return int|null
     */
    public function getConfiguredResultLimit()
    {
        return $this->configuredResultLimit;
    }
    /**
     * Set configuredResultLimit value
     * @param int $configuredResultLimit
     * @return \StructType\DeliveryDestinationSearchAndReplaceResponseImpl
     */
    public function setConfiguredResultLimit($configuredResultLimit = null)
    {
        // validation for constraint: int
        if (!is_null($configuredResultLimit) && !is_numeric($configuredResultLimit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($configuredResultLimit)), __LINE__);
        }
        $this->configuredResultLimit = $configuredResultLimit;
        return $this;
    }
    /**
     * Get totalResultCount value
     * @return int|null
     */
    public function getTotalResultCount()
    {
        return $this->totalResultCount;
    }
    /**
     * Set totalResultCount value
     * @param int $totalResultCount
     * @return \StructType\DeliveryDestinationSearchAndReplaceResponseImpl
     */
    public function setTotalResultCount($totalResultCount = null)
    {
        // validation for constraint: int
        if (!is_null($totalResultCount) && !is_numeric($totalResultCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($totalResultCount)), __LINE__);
        }
        $this->totalResultCount = $totalResultCount;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DeliveryDestinationSearchAndReplaceResponseImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
