<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for deliveryDetails StructType
 * @subpackage Structs
 */
class DeliveryDetails extends AbstractStructBase
{
    /**
     * The deliveryDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\DeliveryDestinationImpl[]
     */
    public $deliveryDetail;
    /**
     * Constructor method for deliveryDetails
     * @uses DeliveryDetails::setDeliveryDetail()
     * @param \StructType\DeliveryDestinationImpl[] $deliveryDetail
     */
    public function __construct(array $deliveryDetail = array())
    {
        $this
            ->setDeliveryDetail($deliveryDetail);
    }
    /**
     * Get deliveryDetail value
     * @return \StructType\DeliveryDestinationImpl[]|null
     */
    public function getDeliveryDetail()
    {
        return $this->deliveryDetail;
    }
    /**
     * Set deliveryDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\DeliveryDestinationImpl[] $deliveryDetail
     * @return \StructType\DeliveryDetails
     */
    public function setDeliveryDetail(array $deliveryDetail = array())
    {
        foreach ($deliveryDetail as $deliveryDetailsDeliveryDetailItem) {
            // validation for constraint: itemType
            if (!$deliveryDetailsDeliveryDetailItem instanceof \StructType\DeliveryDestinationImpl) {
                throw new \InvalidArgumentException(sprintf('The deliveryDetail property can only contain items of \StructType\DeliveryDestinationImpl, "%s" given', is_object($deliveryDetailsDeliveryDetailItem) ? get_class($deliveryDetailsDeliveryDetailItem) : gettype($deliveryDetailsDeliveryDetailItem)), __LINE__);
            }
        }
        $this->deliveryDetail = $deliveryDetail;
        return $this;
    }
    /**
     * Add item to deliveryDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\DeliveryDestinationImpl $item
     * @return \StructType\DeliveryDetails
     */
    public function addToDeliveryDetail(\StructType\DeliveryDestinationImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DeliveryDestinationImpl) {
            throw new \InvalidArgumentException(sprintf('The deliveryDetail property can only contain items of \StructType\DeliveryDestinationImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->deliveryDetail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DeliveryDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
