<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for demoPlanReportImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:demoPlanReportImpl
 * @subpackage Structs
 */
class DemoPlanReportImpl extends AbstractStructBase
{
    /**
     * The spAcctNo
     * @var string
     */
    public $spAcctNo;
    /**
     * The spName
     * @var string
     */
    public $spName;
    /**
     * The serviceType
     * @var string
     */
    public $serviceType;
    /**
     * The accountNumber
     * @var string
     */
    public $accountNumber;
    /**
     * The accountStatus
     * @var string
     */
    public $accountStatus;
    /**
     * The deviceDetails
     * @var string
     */
    public $deviceDetails;
    /**
     * The activationDate
     * @var string
     */
    public $activationDate;
    /**
     * The subscriptionType
     * @var string
     */
    public $subscriptionType;
    /**
     * The transitionDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $transitionDate;
    /**
     * The closedDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $closedDate;
    /**
     * Constructor method for demoPlanReportImpl
     * @uses DemoPlanReportImpl::setSpAcctNo()
     * @uses DemoPlanReportImpl::setSpName()
     * @uses DemoPlanReportImpl::setServiceType()
     * @uses DemoPlanReportImpl::setAccountNumber()
     * @uses DemoPlanReportImpl::setAccountStatus()
     * @uses DemoPlanReportImpl::setDeviceDetails()
     * @uses DemoPlanReportImpl::setActivationDate()
     * @uses DemoPlanReportImpl::setSubscriptionType()
     * @uses DemoPlanReportImpl::setTransitionDate()
     * @uses DemoPlanReportImpl::setClosedDate()
     * @param string $spAcctNo
     * @param string $spName
     * @param string $serviceType
     * @param string $accountNumber
     * @param string $accountStatus
     * @param string $deviceDetails
     * @param string $activationDate
     * @param string $subscriptionType
     * @param string $transitionDate
     * @param string $closedDate
     */
    public function __construct($spAcctNo = null, $spName = null, $serviceType = null, $accountNumber = null, $accountStatus = null, $deviceDetails = null, $activationDate = null, $subscriptionType = null, $transitionDate = null, $closedDate = null)
    {
        $this
            ->setSpAcctNo($spAcctNo)
            ->setSpName($spName)
            ->setServiceType($serviceType)
            ->setAccountNumber($accountNumber)
            ->setAccountStatus($accountStatus)
            ->setDeviceDetails($deviceDetails)
            ->setActivationDate($activationDate)
            ->setSubscriptionType($subscriptionType)
            ->setTransitionDate($transitionDate)
            ->setClosedDate($closedDate);
    }
    /**
     * Get spAcctNo value
     * @return string|null
     */
    public function getSpAcctNo()
    {
        return $this->spAcctNo;
    }
    /**
     * Set spAcctNo value
     * @param string $spAcctNo
     * @return \StructType\DemoPlanReportImpl
     */
    public function setSpAcctNo($spAcctNo = null)
    {
        // validation for constraint: string
        if (!is_null($spAcctNo) && !is_string($spAcctNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($spAcctNo)), __LINE__);
        }
        $this->spAcctNo = $spAcctNo;
        return $this;
    }
    /**
     * Get spName value
     * @return string|null
     */
    public function getSpName()
    {
        return $this->spName;
    }
    /**
     * Set spName value
     * @param string $spName
     * @return \StructType\DemoPlanReportImpl
     */
    public function setSpName($spName = null)
    {
        // validation for constraint: string
        if (!is_null($spName) && !is_string($spName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($spName)), __LINE__);
        }
        $this->spName = $spName;
        return $this;
    }
    /**
     * Get serviceType value
     * @return string|null
     */
    public function getServiceType()
    {
        return $this->serviceType;
    }
    /**
     * Set serviceType value
     * @param string $serviceType
     * @return \StructType\DemoPlanReportImpl
     */
    public function setServiceType($serviceType = null)
    {
        // validation for constraint: string
        if (!is_null($serviceType) && !is_string($serviceType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($serviceType)), __LINE__);
        }
        $this->serviceType = $serviceType;
        return $this;
    }
    /**
     * Get accountNumber value
     * @return string|null
     */
    public function getAccountNumber()
    {
        return $this->accountNumber;
    }
    /**
     * Set accountNumber value
     * @param string $accountNumber
     * @return \StructType\DemoPlanReportImpl
     */
    public function setAccountNumber($accountNumber = null)
    {
        // validation for constraint: string
        if (!is_null($accountNumber) && !is_string($accountNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($accountNumber)), __LINE__);
        }
        $this->accountNumber = $accountNumber;
        return $this;
    }
    /**
     * Get accountStatus value
     * @return string|null
     */
    public function getAccountStatus()
    {
        return $this->accountStatus;
    }
    /**
     * Set accountStatus value
     * @param string $accountStatus
     * @return \StructType\DemoPlanReportImpl
     */
    public function setAccountStatus($accountStatus = null)
    {
        // validation for constraint: string
        if (!is_null($accountStatus) && !is_string($accountStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($accountStatus)), __LINE__);
        }
        $this->accountStatus = $accountStatus;
        return $this;
    }
    /**
     * Get deviceDetails value
     * @return string|null
     */
    public function getDeviceDetails()
    {
        return $this->deviceDetails;
    }
    /**
     * Set deviceDetails value
     * @param string $deviceDetails
     * @return \StructType\DemoPlanReportImpl
     */
    public function setDeviceDetails($deviceDetails = null)
    {
        // validation for constraint: string
        if (!is_null($deviceDetails) && !is_string($deviceDetails)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($deviceDetails)), __LINE__);
        }
        $this->deviceDetails = $deviceDetails;
        return $this;
    }
    /**
     * Get activationDate value
     * @return string|null
     */
    public function getActivationDate()
    {
        return $this->activationDate;
    }
    /**
     * Set activationDate value
     * @param string $activationDate
     * @return \StructType\DemoPlanReportImpl
     */
    public function setActivationDate($activationDate = null)
    {
        // validation for constraint: string
        if (!is_null($activationDate) && !is_string($activationDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($activationDate)), __LINE__);
        }
        $this->activationDate = $activationDate;
        return $this;
    }
    /**
     * Get subscriptionType value
     * @return string|null
     */
    public function getSubscriptionType()
    {
        return $this->subscriptionType;
    }
    /**
     * Set subscriptionType value
     * @param string $subscriptionType
     * @return \StructType\DemoPlanReportImpl
     */
    public function setSubscriptionType($subscriptionType = null)
    {
        // validation for constraint: string
        if (!is_null($subscriptionType) && !is_string($subscriptionType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($subscriptionType)), __LINE__);
        }
        $this->subscriptionType = $subscriptionType;
        return $this;
    }
    /**
     * Get transitionDate value
     * @return string|null
     */
    public function getTransitionDate()
    {
        return $this->transitionDate;
    }
    /**
     * Set transitionDate value
     * @param string $transitionDate
     * @return \StructType\DemoPlanReportImpl
     */
    public function setTransitionDate($transitionDate = null)
    {
        // validation for constraint: string
        if (!is_null($transitionDate) && !is_string($transitionDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($transitionDate)), __LINE__);
        }
        $this->transitionDate = $transitionDate;
        return $this;
    }
    /**
     * Get closedDate value
     * @return string|null
     */
    public function getClosedDate()
    {
        return $this->closedDate;
    }
    /**
     * Set closedDate value
     * @param string $closedDate
     * @return \StructType\DemoPlanReportImpl
     */
    public function setClosedDate($closedDate = null)
    {
        // validation for constraint: string
        if (!is_null($closedDate) && !is_string($closedDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($closedDate)), __LINE__);
        }
        $this->closedDate = $closedDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DemoPlanReportImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
