<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for deviceCapcodeImpl StructType
 * @subpackage Structs
 */
class DeviceCapcodeImpl extends DeviceImpl
{
    /**
     * The submarketId
     * @var string
     */
    public $submarketId;
    /**
     * The network
     * @var string
     */
    public $network;
    /**
     * Constructor method for deviceCapcodeImpl
     * @uses DeviceCapcodeImpl::setSubmarketId()
     * @uses DeviceCapcodeImpl::setNetwork()
     * @param string $submarketId
     * @param string $network
     */
    public function __construct($submarketId = null, $network = null)
    {
        $this
            ->setSubmarketId($submarketId)
            ->setNetwork($network);
    }
    /**
     * Get submarketId value
     * @return string|null
     */
    public function getSubmarketId()
    {
        return $this->submarketId;
    }
    /**
     * Set submarketId value
     * @param string $submarketId
     * @return \StructType\DeviceCapcodeImpl
     */
    public function setSubmarketId($submarketId = null)
    {
        // validation for constraint: string
        if (!is_null($submarketId) && !is_string($submarketId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($submarketId)), __LINE__);
        }
        $this->submarketId = $submarketId;
        return $this;
    }
    /**
     * Get network value
     * @return string|null
     */
    public function getNetwork()
    {
        return $this->network;
    }
    /**
     * Set network value
     * @param string $network
     * @return \StructType\DeviceCapcodeImpl
     */
    public function setNetwork($network = null)
    {
        // validation for constraint: string
        if (!is_null($network) && !is_string($network)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($network)), __LINE__);
        }
        $this->network = $network;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DeviceCapcodeImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
