<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for deviceImpl StructType
 * @subpackage Structs
 */
class DeviceImpl extends AbstractStructBase
{
    /**
     * The deviceNumber
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $deviceNumber;
    /**
     * The deviceId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $deviceId;
    /**
     * Constructor method for deviceImpl
     * @uses DeviceImpl::setDeviceNumber()
     * @uses DeviceImpl::setDeviceId()
     * @param string $deviceNumber
     * @param string $deviceId
     */
    public function __construct($deviceNumber = null, $deviceId = null)
    {
        $this
            ->setDeviceNumber($deviceNumber)
            ->setDeviceId($deviceId);
    }
    /**
     * Get deviceNumber value
     * @return string|null
     */
    public function getDeviceNumber()
    {
        return $this->deviceNumber;
    }
    /**
     * Set deviceNumber value
     * @param string $deviceNumber
     * @return \StructType\DeviceImpl
     */
    public function setDeviceNumber($deviceNumber = null)
    {
        // validation for constraint: string
        if (!is_null($deviceNumber) && !is_string($deviceNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($deviceNumber)), __LINE__);
        }
        $this->deviceNumber = $deviceNumber;
        return $this;
    }
    /**
     * Get deviceId value
     * @return string|null
     */
    public function getDeviceId()
    {
        return $this->deviceId;
    }
    /**
     * Set deviceId value
     * @param string $deviceId
     * @return \StructType\DeviceImpl
     */
    public function setDeviceId($deviceId = null)
    {
        // validation for constraint: string
        if (!is_null($deviceId) && !is_string($deviceId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($deviceId)), __LINE__);
        }
        $this->deviceId = $deviceId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DeviceImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
