<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for deviceSimImpl StructType
 * @subpackage Structs
 */
class DeviceSimImpl extends DeviceImpl
{
    /**
     * The imsi
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $imsi;
    /**
     * The submarketId
     * @var string
     */
    public $submarketId;
    /**
     * The submarketType
     * @var string
     */
    public $submarketType;
    /**
     * The network
     * @var string
     */
    public $network;
    /**
     * Constructor method for deviceSimImpl
     * @uses DeviceSimImpl::setImsi()
     * @uses DeviceSimImpl::setSubmarketId()
     * @uses DeviceSimImpl::setSubmarketType()
     * @uses DeviceSimImpl::setNetwork()
     * @param string $imsi
     * @param string $submarketId
     * @param string $submarketType
     * @param string $network
     */
    public function __construct($imsi = null, $submarketId = null, $submarketType = null, $network = null)
    {
        $this
            ->setImsi($imsi)
            ->setSubmarketId($submarketId)
            ->setSubmarketType($submarketType)
            ->setNetwork($network);
    }
    /**
     * Get imsi value
     * @return string|null
     */
    public function getImsi()
    {
        return $this->imsi;
    }
    /**
     * Set imsi value
     * @param string $imsi
     * @return \StructType\DeviceSimImpl
     */
    public function setImsi($imsi = null)
    {
        // validation for constraint: string
        if (!is_null($imsi) && !is_string($imsi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($imsi)), __LINE__);
        }
        $this->imsi = $imsi;
        return $this;
    }
    /**
     * Get submarketId value
     * @return string|null
     */
    public function getSubmarketId()
    {
        return $this->submarketId;
    }
    /**
     * Set submarketId value
     * @param string $submarketId
     * @return \StructType\DeviceSimImpl
     */
    public function setSubmarketId($submarketId = null)
    {
        // validation for constraint: string
        if (!is_null($submarketId) && !is_string($submarketId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($submarketId)), __LINE__);
        }
        $this->submarketId = $submarketId;
        return $this;
    }
    /**
     * Get submarketType value
     * @return string|null
     */
    public function getSubmarketType()
    {
        return $this->submarketType;
    }
    /**
     * Set submarketType value
     * @param string $submarketType
     * @return \StructType\DeviceSimImpl
     */
    public function setSubmarketType($submarketType = null)
    {
        // validation for constraint: string
        if (!is_null($submarketType) && !is_string($submarketType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($submarketType)), __LINE__);
        }
        $this->submarketType = $submarketType;
        return $this;
    }
    /**
     * Get network value
     * @return string|null
     */
    public function getNetwork()
    {
        return $this->network;
    }
    /**
     * Set network value
     * @param string $network
     * @return \StructType\DeviceSimImpl
     */
    public function setNetwork($network = null)
    {
        // validation for constraint: string
        if (!is_null($network) && !is_string($network)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($network)), __LINE__);
        }
        $this->network = $network;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DeviceSimImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
