<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for deviceSwapImpl StructType
 * @subpackage Structs
 */
class DeviceSwapImpl extends AbstractStructBase
{
    /**
     * The fromDevice
     * @var \StructType\DeviceImpl
     */
    public $fromDevice;
    /**
     * The toDevice
     * @var \StructType\DeviceImpl
     */
    public $toDevice;
    /**
     * The toVpnDevice
     * @var \StructType\DeviceIpImpl
     */
    public $toVpnDevice;
    /**
     * The toLocalCountry
     * @var \StructType\LocalCountryImpl
     */
    public $toLocalCountry;
    /**
     * Constructor method for deviceSwapImpl
     * @uses DeviceSwapImpl::setFromDevice()
     * @uses DeviceSwapImpl::setToDevice()
     * @uses DeviceSwapImpl::setToVpnDevice()
     * @uses DeviceSwapImpl::setToLocalCountry()
     * @param \StructType\DeviceImpl $fromDevice
     * @param \StructType\DeviceImpl $toDevice
     * @param \StructType\DeviceIpImpl $toVpnDevice
     * @param \StructType\LocalCountryImpl $toLocalCountry
     */
    public function __construct(\StructType\DeviceImpl $fromDevice = null, \StructType\DeviceImpl $toDevice = null, \StructType\DeviceIpImpl $toVpnDevice = null, \StructType\LocalCountryImpl $toLocalCountry = null)
    {
        $this
            ->setFromDevice($fromDevice)
            ->setToDevice($toDevice)
            ->setToVpnDevice($toVpnDevice)
            ->setToLocalCountry($toLocalCountry);
    }
    /**
     * Get fromDevice value
     * @return \StructType\DeviceImpl|null
     */
    public function getFromDevice()
    {
        return $this->fromDevice;
    }
    /**
     * Set fromDevice value
     * @param \StructType\DeviceImpl $fromDevice
     * @return \StructType\DeviceSwapImpl
     */
    public function setFromDevice(\StructType\DeviceImpl $fromDevice = null)
    {
        $this->fromDevice = $fromDevice;
        return $this;
    }
    /**
     * Get toDevice value
     * @return \StructType\DeviceImpl|null
     */
    public function getToDevice()
    {
        return $this->toDevice;
    }
    /**
     * Set toDevice value
     * @param \StructType\DeviceImpl $toDevice
     * @return \StructType\DeviceSwapImpl
     */
    public function setToDevice(\StructType\DeviceImpl $toDevice = null)
    {
        $this->toDevice = $toDevice;
        return $this;
    }
    /**
     * Get toVpnDevice value
     * @return \StructType\DeviceIpImpl|null
     */
    public function getToVpnDevice()
    {
        return $this->toVpnDevice;
    }
    /**
     * Set toVpnDevice value
     * @param \StructType\DeviceIpImpl $toVpnDevice
     * @return \StructType\DeviceSwapImpl
     */
    public function setToVpnDevice(\StructType\DeviceIpImpl $toVpnDevice = null)
    {
        $this->toVpnDevice = $toVpnDevice;
        return $this;
    }
    /**
     * Get toLocalCountry value
     * @return \StructType\LocalCountryImpl|null
     */
    public function getToLocalCountry()
    {
        return $this->toLocalCountry;
    }
    /**
     * Set toLocalCountry value
     * @param \StructType\LocalCountryImpl $toLocalCountry
     * @return \StructType\DeviceSwapImpl
     */
    public function setToLocalCountry(\StructType\LocalCountryImpl $toLocalCountry = null)
    {
        $this->toLocalCountry = $toLocalCountry;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DeviceSwapImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
