<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for evoucherInventoryEntryImpl StructType
 * @subpackage Structs
 */
class EvoucherInventoryEntryImpl extends AbstractStructBase
{
    /**
     * The voucherType
     * @var string
     */
    public $voucherType;
    /**
     * The unitDenomination
     * @var string
     */
    public $unitDenomination;
    /**
     * The minDenomination
     * @var string
     */
    public $minDenomination;
    /**
     * The quantityAvailable
     * @var string
     */
    public $quantityAvailable;
    /**
     * Constructor method for evoucherInventoryEntryImpl
     * @uses EvoucherInventoryEntryImpl::setVoucherType()
     * @uses EvoucherInventoryEntryImpl::setUnitDenomination()
     * @uses EvoucherInventoryEntryImpl::setMinDenomination()
     * @uses EvoucherInventoryEntryImpl::setQuantityAvailable()
     * @param string $voucherType
     * @param string $unitDenomination
     * @param string $minDenomination
     * @param string $quantityAvailable
     */
    public function __construct($voucherType = null, $unitDenomination = null, $minDenomination = null, $quantityAvailable = null)
    {
        $this
            ->setVoucherType($voucherType)
            ->setUnitDenomination($unitDenomination)
            ->setMinDenomination($minDenomination)
            ->setQuantityAvailable($quantityAvailable);
    }
    /**
     * Get voucherType value
     * @return string|null
     */
    public function getVoucherType()
    {
        return $this->voucherType;
    }
    /**
     * Set voucherType value
     * @param string $voucherType
     * @return \StructType\EvoucherInventoryEntryImpl
     */
    public function setVoucherType($voucherType = null)
    {
        // validation for constraint: string
        if (!is_null($voucherType) && !is_string($voucherType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($voucherType)), __LINE__);
        }
        $this->voucherType = $voucherType;
        return $this;
    }
    /**
     * Get unitDenomination value
     * @return string|null
     */
    public function getUnitDenomination()
    {
        return $this->unitDenomination;
    }
    /**
     * Set unitDenomination value
     * @param string $unitDenomination
     * @return \StructType\EvoucherInventoryEntryImpl
     */
    public function setUnitDenomination($unitDenomination = null)
    {
        // validation for constraint: string
        if (!is_null($unitDenomination) && !is_string($unitDenomination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($unitDenomination)), __LINE__);
        }
        $this->unitDenomination = $unitDenomination;
        return $this;
    }
    /**
     * Get minDenomination value
     * @return string|null
     */
    public function getMinDenomination()
    {
        return $this->minDenomination;
    }
    /**
     * Set minDenomination value
     * @param string $minDenomination
     * @return \StructType\EvoucherInventoryEntryImpl
     */
    public function setMinDenomination($minDenomination = null)
    {
        // validation for constraint: string
        if (!is_null($minDenomination) && !is_string($minDenomination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($minDenomination)), __LINE__);
        }
        $this->minDenomination = $minDenomination;
        return $this;
    }
    /**
     * Get quantityAvailable value
     * @return string|null
     */
    public function getQuantityAvailable()
    {
        return $this->quantityAvailable;
    }
    /**
     * Set quantityAvailable value
     * @param string $quantityAvailable
     * @return \StructType\EvoucherInventoryEntryImpl
     */
    public function setQuantityAvailable($quantityAvailable = null)
    {
        // validation for constraint: string
        if (!is_null($quantityAvailable) && !is_string($quantityAvailable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($quantityAvailable)), __LINE__);
        }
        $this->quantityAvailable = $quantityAvailable;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EvoucherInventoryEntryImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
