<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getBundleResponseImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:getBundleResponseImpl
 * @subpackage Structs
 */
class GetBundleResponseImpl extends IwsResponseImpl
{
    /**
     * The bulkBundle
     * @var \StructType\BulkBundleInfoImpl
     */
    public $bulkBundle;
    /**
     * The bundle
     * @var \StructType\BundleInfoImpl
     */
    public $bundle;
    /**
     * The datBundle
     * @var \StructType\DatBundleInfoImpl
     */
    public $datBundle;
    /**
     * Constructor method for getBundleResponseImpl
     * @uses GetBundleResponseImpl::setBulkBundle()
     * @uses GetBundleResponseImpl::setBundle()
     * @uses GetBundleResponseImpl::setDatBundle()
     * @param \StructType\BulkBundleInfoImpl $bulkBundle
     * @param \StructType\BundleInfoImpl $bundle
     * @param \StructType\DatBundleInfoImpl $datBundle
     */
    public function __construct(\StructType\BulkBundleInfoImpl $bulkBundle = null, \StructType\BundleInfoImpl $bundle = null, \StructType\DatBundleInfoImpl $datBundle = null)
    {
        $this
            ->setBulkBundle($bulkBundle)
            ->setBundle($bundle)
            ->setDatBundle($datBundle);
    }
    /**
     * Get bulkBundle value
     * @return \StructType\BulkBundleInfoImpl|null
     */
    public function getBulkBundle()
    {
        return $this->bulkBundle;
    }
    /**
     * Set bulkBundle value
     * @param \StructType\BulkBundleInfoImpl $bulkBundle
     * @return \StructType\GetBundleResponseImpl
     */
    public function setBulkBundle(\StructType\BulkBundleInfoImpl $bulkBundle = null)
    {
        $this->bulkBundle = $bulkBundle;
        return $this;
    }
    /**
     * Get bundle value
     * @return \StructType\BundleInfoImpl|null
     */
    public function getBundle()
    {
        return $this->bundle;
    }
    /**
     * Set bundle value
     * @param \StructType\BundleInfoImpl $bundle
     * @return \StructType\GetBundleResponseImpl
     */
    public function setBundle(\StructType\BundleInfoImpl $bundle = null)
    {
        $this->bundle = $bundle;
        return $this;
    }
    /**
     * Get datBundle value
     * @return \StructType\DatBundleInfoImpl|null
     */
    public function getDatBundle()
    {
        return $this->datBundle;
    }
    /**
     * Set datBundle value
     * @param \StructType\DatBundleInfoImpl $datBundle
     * @return \StructType\GetBundleResponseImpl
     */
    public function setDatBundle(\StructType\DatBundleInfoImpl $datBundle = null)
    {
        $this->datBundle = $datBundle;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetBundleResponseImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
