<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getEmailNotificationResponseImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:getEmailNotificationResponseImpl
 * @subpackage Structs
 */
class GetEmailNotificationResponseImpl extends IwsResponseImpl
{
    /**
     * The email
     * @var string
     */
    public $email;
    /**
     * The notifications
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Notifications
     */
    public $notifications;
    /**
     * Constructor method for getEmailNotificationResponseImpl
     * @uses GetEmailNotificationResponseImpl::setEmail()
     * @uses GetEmailNotificationResponseImpl::setNotifications()
     * @param string $email
     * @param \StructType\Notifications $notifications
     */
    public function __construct($email = null, \StructType\Notifications $notifications = null)
    {
        $this
            ->setEmail($email)
            ->setNotifications($notifications);
    }
    /**
     * Get email value
     * @return string|null
     */
    public function getEmail()
    {
        return $this->email;
    }
    /**
     * Set email value
     * @param string $email
     * @return \StructType\GetEmailNotificationResponseImpl
     */
    public function setEmail($email = null)
    {
        // validation for constraint: string
        if (!is_null($email) && !is_string($email)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($email)), __LINE__);
        }
        $this->email = $email;
        return $this;
    }
    /**
     * Get notifications value
     * @return \StructType\Notifications|null
     */
    public function getNotifications()
    {
        return $this->notifications;
    }
    /**
     * Set notifications value
     * @param \StructType\Notifications $notifications
     * @return \StructType\GetEmailNotificationResponseImpl
     */
    public function setNotifications(\StructType\Notifications $notifications = null)
    {
        $this->notifications = $notifications;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetEmailNotificationResponseImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
