<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getPrepaidCallHistoryRequestImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:getPrepaidCallHistoryRequestImpl
 * @subpackage Structs
 */
class GetPrepaidCallHistoryRequestImpl extends AuthenticatedIwsRequestImpl
{
    /**
     * The subscriberItem
     * @var string
     */
    public $subscriberItem;
    /**
     * The callDateStart
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $callDateStart;
    /**
     * The callDateEnd
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $callDateEnd;
    /**
     * The limit
     * @var int
     */
    public $limit;
    /**
     * The startRow
     * @var int
     */
    public $startRow;
    /**
     * Constructor method for getPrepaidCallHistoryRequestImpl
     * @uses GetPrepaidCallHistoryRequestImpl::setSubscriberItem()
     * @uses GetPrepaidCallHistoryRequestImpl::setCallDateStart()
     * @uses GetPrepaidCallHistoryRequestImpl::setCallDateEnd()
     * @uses GetPrepaidCallHistoryRequestImpl::setLimit()
     * @uses GetPrepaidCallHistoryRequestImpl::setStartRow()
     * @param string $subscriberItem
     * @param string $callDateStart
     * @param string $callDateEnd
     * @param int $limit
     * @param int $startRow
     */
    public function __construct($subscriberItem = null, $callDateStart = null, $callDateEnd = null, $limit = null, $startRow = null)
    {
        $this
            ->setSubscriberItem($subscriberItem)
            ->setCallDateStart($callDateStart)
            ->setCallDateEnd($callDateEnd)
            ->setLimit($limit)
            ->setStartRow($startRow);
    }
    /**
     * Get subscriberItem value
     * @return string|null
     */
    public function getSubscriberItem()
    {
        return $this->subscriberItem;
    }
    /**
     * Set subscriberItem value
     * @param string $subscriberItem
     * @return \StructType\GetPrepaidCallHistoryRequestImpl
     */
    public function setSubscriberItem($subscriberItem = null)
    {
        // validation for constraint: string
        if (!is_null($subscriberItem) && !is_string($subscriberItem)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($subscriberItem)), __LINE__);
        }
        $this->subscriberItem = $subscriberItem;
        return $this;
    }
    /**
     * Get callDateStart value
     * @return string|null
     */
    public function getCallDateStart()
    {
        return $this->callDateStart;
    }
    /**
     * Set callDateStart value
     * @param string $callDateStart
     * @return \StructType\GetPrepaidCallHistoryRequestImpl
     */
    public function setCallDateStart($callDateStart = null)
    {
        // validation for constraint: string
        if (!is_null($callDateStart) && !is_string($callDateStart)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($callDateStart)), __LINE__);
        }
        $this->callDateStart = $callDateStart;
        return $this;
    }
    /**
     * Get callDateEnd value
     * @return string|null
     */
    public function getCallDateEnd()
    {
        return $this->callDateEnd;
    }
    /**
     * Set callDateEnd value
     * @param string $callDateEnd
     * @return \StructType\GetPrepaidCallHistoryRequestImpl
     */
    public function setCallDateEnd($callDateEnd = null)
    {
        // validation for constraint: string
        if (!is_null($callDateEnd) && !is_string($callDateEnd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($callDateEnd)), __LINE__);
        }
        $this->callDateEnd = $callDateEnd;
        return $this;
    }
    /**
     * Get limit value
     * @return int|null
     */
    public function getLimit()
    {
        return $this->limit;
    }
    /**
     * Set limit value
     * @param int $limit
     * @return \StructType\GetPrepaidCallHistoryRequestImpl
     */
    public function setLimit($limit = null)
    {
        // validation for constraint: int
        if (!is_null($limit) && !is_numeric($limit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($limit)), __LINE__);
        }
        $this->limit = $limit;
        return $this;
    }
    /**
     * Get startRow value
     * @return int|null
     */
    public function getStartRow()
    {
        return $this->startRow;
    }
    /**
     * Set startRow value
     * @param int $startRow
     * @return \StructType\GetPrepaidCallHistoryRequestImpl
     */
    public function setStartRow($startRow = null)
    {
        // validation for constraint: int
        if (!is_null($startRow) && !is_numeric($startRow)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($startRow)), __LINE__);
        }
        $this->startRow = $startRow;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetPrepaidCallHistoryRequestImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
