<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getScratchCardBatchesResponseImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:getScratchCardBatchesResponseImpl
 * @subpackage Structs
 */
class GetScratchCardBatchesResponseImpl extends IwsResponseImpl
{
    /**
     * The totalNumberOfRecords
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $totalNumberOfRecords;
    /**
     * The scratchCardBatches
     * @var \StructType\ScratchCardBatches
     */
    public $scratchCardBatches;
    /**
     * Constructor method for getScratchCardBatchesResponseImpl
     * @uses GetScratchCardBatchesResponseImpl::setTotalNumberOfRecords()
     * @uses GetScratchCardBatchesResponseImpl::setScratchCardBatches()
     * @param int $totalNumberOfRecords
     * @param \StructType\ScratchCardBatches $scratchCardBatches
     */
    public function __construct($totalNumberOfRecords = null, \StructType\ScratchCardBatches $scratchCardBatches = null)
    {
        $this
            ->setTotalNumberOfRecords($totalNumberOfRecords)
            ->setScratchCardBatches($scratchCardBatches);
    }
    /**
     * Get totalNumberOfRecords value
     * @return int|null
     */
    public function getTotalNumberOfRecords()
    {
        return $this->totalNumberOfRecords;
    }
    /**
     * Set totalNumberOfRecords value
     * @param int $totalNumberOfRecords
     * @return \StructType\GetScratchCardBatchesResponseImpl
     */
    public function setTotalNumberOfRecords($totalNumberOfRecords = null)
    {
        // validation for constraint: int
        if (!is_null($totalNumberOfRecords) && !is_numeric($totalNumberOfRecords)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($totalNumberOfRecords)), __LINE__);
        }
        $this->totalNumberOfRecords = $totalNumberOfRecords;
        return $this;
    }
    /**
     * Get scratchCardBatches value
     * @return \StructType\ScratchCardBatches|null
     */
    public function getScratchCardBatches()
    {
        return $this->scratchCardBatches;
    }
    /**
     * Set scratchCardBatches value
     * @param \StructType\ScratchCardBatches $scratchCardBatches
     * @return \StructType\GetScratchCardBatchesResponseImpl
     */
    public function setScratchCardBatches(\StructType\ScratchCardBatches $scratchCardBatches = null)
    {
        $this->scratchCardBatches = $scratchCardBatches;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetScratchCardBatchesResponseImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
