<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for imeiDetailImpl StructType
 * @subpackage Structs
 */
class ImeiDetailImpl extends AbstractStructBase
{
    /**
     * The imei
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $imei;
    /**
     * The status
     * @var string
     */
    public $status;
    /**
     * The ringAlert
     * @var string
     */
    public $ringAlert;
    /**
     * The deliveryMethod
     * @var string
     */
    public $deliveryMethod;
    /**
     * The destination
     * @var string
     */
    public $destination;
    /**
     * The geoDataFlag
     * @var string
     */
    public $geoDataFlag;
    /**
     * The moAckFlag
     * @var string
     */
    public $moAckFlag;
    /**
     * Constructor method for imeiDetailImpl
     * @uses ImeiDetailImpl::setImei()
     * @uses ImeiDetailImpl::setStatus()
     * @uses ImeiDetailImpl::setRingAlert()
     * @uses ImeiDetailImpl::setDeliveryMethod()
     * @uses ImeiDetailImpl::setDestination()
     * @uses ImeiDetailImpl::setGeoDataFlag()
     * @uses ImeiDetailImpl::setMoAckFlag()
     * @param string $imei
     * @param string $status
     * @param string $ringAlert
     * @param string $deliveryMethod
     * @param string $destination
     * @param string $geoDataFlag
     * @param string $moAckFlag
     */
    public function __construct($imei = null, $status = null, $ringAlert = null, $deliveryMethod = null, $destination = null, $geoDataFlag = null, $moAckFlag = null)
    {
        $this
            ->setImei($imei)
            ->setStatus($status)
            ->setRingAlert($ringAlert)
            ->setDeliveryMethod($deliveryMethod)
            ->setDestination($destination)
            ->setGeoDataFlag($geoDataFlag)
            ->setMoAckFlag($moAckFlag);
    }
    /**
     * Get imei value
     * @return string|null
     */
    public function getImei()
    {
        return $this->imei;
    }
    /**
     * Set imei value
     * @param string $imei
     * @return \StructType\ImeiDetailImpl
     */
    public function setImei($imei = null)
    {
        // validation for constraint: string
        if (!is_null($imei) && !is_string($imei)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($imei)), __LINE__);
        }
        $this->imei = $imei;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\ImeiDetailImpl
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get ringAlert value
     * @return string|null
     */
    public function getRingAlert()
    {
        return $this->ringAlert;
    }
    /**
     * Set ringAlert value
     * @param string $ringAlert
     * @return \StructType\ImeiDetailImpl
     */
    public function setRingAlert($ringAlert = null)
    {
        // validation for constraint: string
        if (!is_null($ringAlert) && !is_string($ringAlert)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ringAlert)), __LINE__);
        }
        $this->ringAlert = $ringAlert;
        return $this;
    }
    /**
     * Get deliveryMethod value
     * @return string|null
     */
    public function getDeliveryMethod()
    {
        return $this->deliveryMethod;
    }
    /**
     * Set deliveryMethod value
     * @param string $deliveryMethod
     * @return \StructType\ImeiDetailImpl
     */
    public function setDeliveryMethod($deliveryMethod = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryMethod) && !is_string($deliveryMethod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($deliveryMethod)), __LINE__);
        }
        $this->deliveryMethod = $deliveryMethod;
        return $this;
    }
    /**
     * Get destination value
     * @return string|null
     */
    public function getDestination()
    {
        return $this->destination;
    }
    /**
     * Set destination value
     * @param string $destination
     * @return \StructType\ImeiDetailImpl
     */
    public function setDestination($destination = null)
    {
        // validation for constraint: string
        if (!is_null($destination) && !is_string($destination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($destination)), __LINE__);
        }
        $this->destination = $destination;
        return $this;
    }
    /**
     * Get geoDataFlag value
     * @return string|null
     */
    public function getGeoDataFlag()
    {
        return $this->geoDataFlag;
    }
    /**
     * Set geoDataFlag value
     * @param string $geoDataFlag
     * @return \StructType\ImeiDetailImpl
     */
    public function setGeoDataFlag($geoDataFlag = null)
    {
        // validation for constraint: string
        if (!is_null($geoDataFlag) && !is_string($geoDataFlag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($geoDataFlag)), __LINE__);
        }
        $this->geoDataFlag = $geoDataFlag;
        return $this;
    }
    /**
     * Get moAckFlag value
     * @return string|null
     */
    public function getMoAckFlag()
    {
        return $this->moAckFlag;
    }
    /**
     * Set moAckFlag value
     * @param string $moAckFlag
     * @return \StructType\ImeiDetailImpl
     */
    public function setMoAckFlag($moAckFlag = null)
    {
        // validation for constraint: string
        if (!is_null($moAckFlag) && !is_string($moAckFlag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($moAckFlag)), __LINE__);
        }
        $this->moAckFlag = $moAckFlag;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ImeiDetailImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
