<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for imeiDetails StructType
 * @subpackage Structs
 */
class ImeiDetails extends AbstractStructBase
{
    /**
     * The imeiDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\ImeiDetailImpl[]
     */
    public $imeiDetail;
    /**
     * Constructor method for imeiDetails
     * @uses ImeiDetails::setImeiDetail()
     * @param \StructType\ImeiDetailImpl[] $imeiDetail
     */
    public function __construct(array $imeiDetail = array())
    {
        $this
            ->setImeiDetail($imeiDetail);
    }
    /**
     * Get imeiDetail value
     * @return \StructType\ImeiDetailImpl[]|null
     */
    public function getImeiDetail()
    {
        return $this->imeiDetail;
    }
    /**
     * Set imeiDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\ImeiDetailImpl[] $imeiDetail
     * @return \StructType\ImeiDetails
     */
    public function setImeiDetail(array $imeiDetail = array())
    {
        foreach ($imeiDetail as $imeiDetailsImeiDetailItem) {
            // validation for constraint: itemType
            if (!$imeiDetailsImeiDetailItem instanceof \StructType\ImeiDetailImpl) {
                throw new \InvalidArgumentException(sprintf('The imeiDetail property can only contain items of \StructType\ImeiDetailImpl, "%s" given', is_object($imeiDetailsImeiDetailItem) ? get_class($imeiDetailsImeiDetailItem) : gettype($imeiDetailsImeiDetailItem)), __LINE__);
            }
        }
        $this->imeiDetail = $imeiDetail;
        return $this;
    }
    /**
     * Add item to imeiDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\ImeiDetailImpl $item
     * @return \StructType\ImeiDetails
     */
    public function addToImeiDetail(\StructType\ImeiDetailImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ImeiDetailImpl) {
            throw new \InvalidArgumentException(sprintf('The imeiDetail property can only contain items of \StructType\ImeiDetailImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->imeiDetail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ImeiDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
