<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for languageChoices StructType
 * @subpackage Structs
 */
class LanguageChoices extends AbstractStructBase
{
    /**
     * The languageChoice
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\LanguageChoiceImpl[]
     */
    public $languageChoice;
    /**
     * Constructor method for languageChoices
     * @uses LanguageChoices::setLanguageChoice()
     * @param \StructType\LanguageChoiceImpl[] $languageChoice
     */
    public function __construct(array $languageChoice = array())
    {
        $this
            ->setLanguageChoice($languageChoice);
    }
    /**
     * Get languageChoice value
     * @return \StructType\LanguageChoiceImpl[]|null
     */
    public function getLanguageChoice()
    {
        return $this->languageChoice;
    }
    /**
     * Set languageChoice value
     * @throws \InvalidArgumentException
     * @param \StructType\LanguageChoiceImpl[] $languageChoice
     * @return \StructType\LanguageChoices
     */
    public function setLanguageChoice(array $languageChoice = array())
    {
        foreach ($languageChoice as $languageChoicesLanguageChoiceItem) {
            // validation for constraint: itemType
            if (!$languageChoicesLanguageChoiceItem instanceof \StructType\LanguageChoiceImpl) {
                throw new \InvalidArgumentException(sprintf('The languageChoice property can only contain items of \StructType\LanguageChoiceImpl, "%s" given', is_object($languageChoicesLanguageChoiceItem) ? get_class($languageChoicesLanguageChoiceItem) : gettype($languageChoicesLanguageChoiceItem)), __LINE__);
            }
        }
        $this->languageChoice = $languageChoice;
        return $this;
    }
    /**
     * Add item to languageChoice value
     * @throws \InvalidArgumentException
     * @param \StructType\LanguageChoiceImpl $item
     * @return \StructType\LanguageChoices
     */
    public function addToLanguageChoice(\StructType\LanguageChoiceImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LanguageChoiceImpl) {
            throw new \InvalidArgumentException(sprintf('The languageChoice property can only contain items of \StructType\LanguageChoiceImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->languageChoice[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\LanguageChoices
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
