<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for loadIMEIResponseImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:loadIMEIResponseImpl
 * @subpackage Structs
 */
class LoadIMEIResponseImpl extends IwsResponseImpl
{
    /**
     * The result
     * @var string
     */
    public $result;
    /**
     * The success
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $success;
    /**
     * The failed
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $failed;
    /**
     * The details
     * @var \StructType\Details
     */
    public $details;
    /**
     * Constructor method for loadIMEIResponseImpl
     * @uses LoadIMEIResponseImpl::setResult()
     * @uses LoadIMEIResponseImpl::setSuccess()
     * @uses LoadIMEIResponseImpl::setFailed()
     * @uses LoadIMEIResponseImpl::setDetails()
     * @param string $result
     * @param int $success
     * @param int $failed
     * @param \StructType\Details $details
     */
    public function __construct($result = null, $success = null, $failed = null, \StructType\Details $details = null)
    {
        $this
            ->setResult($result)
            ->setSuccess($success)
            ->setFailed($failed)
            ->setDetails($details);
    }
    /**
     * Get result value
     * @return string|null
     */
    public function getResult()
    {
        return $this->result;
    }
    /**
     * Set result value
     * @param string $result
     * @return \StructType\LoadIMEIResponseImpl
     */
    public function setResult($result = null)
    {
        // validation for constraint: string
        if (!is_null($result) && !is_string($result)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($result)), __LINE__);
        }
        $this->result = $result;
        return $this;
    }
    /**
     * Get success value
     * @return int|null
     */
    public function getSuccess()
    {
        return $this->success;
    }
    /**
     * Set success value
     * @param int $success
     * @return \StructType\LoadIMEIResponseImpl
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: int
        if (!is_null($success) && !is_numeric($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($success)), __LINE__);
        }
        $this->success = $success;
        return $this;
    }
    /**
     * Get failed value
     * @return int|null
     */
    public function getFailed()
    {
        return $this->failed;
    }
    /**
     * Set failed value
     * @param int $failed
     * @return \StructType\LoadIMEIResponseImpl
     */
    public function setFailed($failed = null)
    {
        // validation for constraint: int
        if (!is_null($failed) && !is_numeric($failed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($failed)), __LINE__);
        }
        $this->failed = $failed;
        return $this;
    }
    /**
     * Get details value
     * @return \StructType\Details|null
     */
    public function getDetails()
    {
        return $this->details;
    }
    /**
     * Set details value
     * @param \StructType\Details $details
     * @return \StructType\LoadIMEIResponseImpl
     */
    public function setDetails(\StructType\Details $details = null)
    {
        $this->details = $details;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\LoadIMEIResponseImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
