<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for m2MBulkDetailImpl StructType
 * @subpackage Structs
 */
class M2MBulkDetailImpl extends AbstractStructBase
{
    /**
     * The sim
     * @var \StructType\DeviceSimImpl
     */
    public $sim;
    /**
     * The imei
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $imei;
    /**
     * Constructor method for m2MBulkDetailImpl
     * @uses M2MBulkDetailImpl::setSim()
     * @uses M2MBulkDetailImpl::setImei()
     * @param \StructType\DeviceSimImpl $sim
     * @param string $imei
     */
    public function __construct(\StructType\DeviceSimImpl $sim = null, $imei = null)
    {
        $this
            ->setSim($sim)
            ->setImei($imei);
    }
    /**
     * Get sim value
     * @return \StructType\DeviceSimImpl|null
     */
    public function getSim()
    {
        return $this->sim;
    }
    /**
     * Set sim value
     * @param \StructType\DeviceSimImpl $sim
     * @return \StructType\M2MBulkDetailImpl
     */
    public function setSim(\StructType\DeviceSimImpl $sim = null)
    {
        $this->sim = $sim;
        return $this;
    }
    /**
     * Get imei value
     * @return string|null
     */
    public function getImei()
    {
        return $this->imei;
    }
    /**
     * Set imei value
     * @param string $imei
     * @return \StructType\M2MBulkDetailImpl
     */
    public function setImei($imei = null)
    {
        // validation for constraint: string
        if (!is_null($imei) && !is_string($imei)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($imei)), __LINE__);
        }
        $this->imei = $imei;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\M2MBulkDetailImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
