<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for maritimeSafetyInfoImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:maritimeSafetyInfoImpl
 * @subpackage Structs
 */
class MaritimeSafetyInfoImpl extends AbstractStructBase
{
    /**
     * The mmsi
     * @var string
     */
    public $mmsi;
    /**
     * The vesselName
     * @var string
     */
    public $vesselName;
    /**
     * Constructor method for maritimeSafetyInfoImpl
     * @uses MaritimeSafetyInfoImpl::setMmsi()
     * @uses MaritimeSafetyInfoImpl::setVesselName()
     * @param string $mmsi
     * @param string $vesselName
     */
    public function __construct($mmsi = null, $vesselName = null)
    {
        $this
            ->setMmsi($mmsi)
            ->setVesselName($vesselName);
    }
    /**
     * Get mmsi value
     * @return string|null
     */
    public function getMmsi()
    {
        return $this->mmsi;
    }
    /**
     * Set mmsi value
     * @param string $mmsi
     * @return \StructType\MaritimeSafetyInfoImpl
     */
    public function setMmsi($mmsi = null)
    {
        // validation for constraint: string
        if (!is_null($mmsi) && !is_string($mmsi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mmsi)), __LINE__);
        }
        $this->mmsi = $mmsi;
        return $this;
    }
    /**
     * Get vesselName value
     * @return string|null
     */
    public function getVesselName()
    {
        return $this->vesselName;
    }
    /**
     * Set vesselName value
     * @param string $vesselName
     * @return \StructType\MaritimeSafetyInfoImpl
     */
    public function setVesselName($vesselName = null)
    {
        // validation for constraint: string
        if (!is_null($vesselName) && !is_string($vesselName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($vesselName)), __LINE__);
        }
        $this->vesselName = $vesselName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MaritimeSafetyInfoImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
