<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for mtFilters StructType
 * @subpackage Structs
 */
class MtFilters extends AbstractStructBase
{
    /**
     * The mtFilter
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\MtFilterImpl[]
     */
    public $mtFilter;
    /**
     * Constructor method for mtFilters
     * @uses MtFilters::setMtFilter()
     * @param \StructType\MtFilterImpl[] $mtFilter
     */
    public function __construct(array $mtFilter = array())
    {
        $this
            ->setMtFilter($mtFilter);
    }
    /**
     * Get mtFilter value
     * @return \StructType\MtFilterImpl[]|null
     */
    public function getMtFilter()
    {
        return $this->mtFilter;
    }
    /**
     * Set mtFilter value
     * @throws \InvalidArgumentException
     * @param \StructType\MtFilterImpl[] $mtFilter
     * @return \StructType\MtFilters
     */
    public function setMtFilter(array $mtFilter = array())
    {
        foreach ($mtFilter as $mtFiltersMtFilterItem) {
            // validation for constraint: itemType
            if (!$mtFiltersMtFilterItem instanceof \StructType\MtFilterImpl) {
                throw new \InvalidArgumentException(sprintf('The mtFilter property can only contain items of \StructType\MtFilterImpl, "%s" given', is_object($mtFiltersMtFilterItem) ? get_class($mtFiltersMtFilterItem) : gettype($mtFiltersMtFilterItem)), __LINE__);
            }
        }
        $this->mtFilter = $mtFilter;
        return $this;
    }
    /**
     * Add item to mtFilter value
     * @throws \InvalidArgumentException
     * @param \StructType\MtFilterImpl $item
     * @return \StructType\MtFilters
     */
    public function addToMtFilter(\StructType\MtFilterImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MtFilterImpl) {
            throw new \InvalidArgumentException(sprintf('The mtFilter property can only contain items of \StructType\MtFilterImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->mtFilter[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MtFilters
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
