<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for openPortSubscriberAccountImpl StructType
 * @subpackage Structs
 */
class OpenPortSubscriberAccountImpl extends AbsSubscriberAccountImpl
{
    /**
     * The commitmentStart
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $commitmentStart;
    /**
     * The commitmentEnd
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $commitmentEnd;
    /**
     * The plan
     * @var \StructType\OpenPortPlanImpl
     */
    public $plan;
    /**
     * The subscriberAccountMetadata
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OpenPortSubscriberAccountMetadataImpl
     */
    public $subscriberAccountMetadata;
    /**
     * The sim
     * @var \StructType\DeviceSimImpl
     */
    public $sim;
    /**
     * The imei
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $imei;
    /**
     * The ip
     * @var \StructType\DeviceIpImpl
     */
    public $ip;
    /**
     * The publicIP
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $publicIP;
    /**
     * The vpnId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $vpnId;
    /**
     * The phoneLines
     * @var \StructType\PhoneLines
     */
    public $phoneLines;
    /**
     * The scratchCardsRestricted
     * @var bool
     */
    public $scratchCardsRestricted;
    /**
     * Constructor method for openPortSubscriberAccountImpl
     * @uses OpenPortSubscriberAccountImpl::setCommitmentStart()
     * @uses OpenPortSubscriberAccountImpl::setCommitmentEnd()
     * @uses OpenPortSubscriberAccountImpl::setPlan()
     * @uses OpenPortSubscriberAccountImpl::setSubscriberAccountMetadata()
     * @uses OpenPortSubscriberAccountImpl::setSim()
     * @uses OpenPortSubscriberAccountImpl::setImei()
     * @uses OpenPortSubscriberAccountImpl::setIp()
     * @uses OpenPortSubscriberAccountImpl::setPublicIP()
     * @uses OpenPortSubscriberAccountImpl::setVpnId()
     * @uses OpenPortSubscriberAccountImpl::setPhoneLines()
     * @uses OpenPortSubscriberAccountImpl::setScratchCardsRestricted()
     * @param string $commitmentStart
     * @param string $commitmentEnd
     * @param \StructType\OpenPortPlanImpl $plan
     * @param \StructType\OpenPortSubscriberAccountMetadataImpl $subscriberAccountMetadata
     * @param \StructType\DeviceSimImpl $sim
     * @param string $imei
     * @param \StructType\DeviceIpImpl $ip
     * @param string $publicIP
     * @param string $vpnId
     * @param \StructType\PhoneLines $phoneLines
     * @param bool $scratchCardsRestricted
     */
    public function __construct($commitmentStart = null, $commitmentEnd = null, \StructType\OpenPortPlanImpl $plan = null, \StructType\OpenPortSubscriberAccountMetadataImpl $subscriberAccountMetadata = null, \StructType\DeviceSimImpl $sim = null, $imei = null, \StructType\DeviceIpImpl $ip = null, $publicIP = null, $vpnId = null, \StructType\PhoneLines $phoneLines = null, $scratchCardsRestricted = null)
    {
        $this
            ->setCommitmentStart($commitmentStart)
            ->setCommitmentEnd($commitmentEnd)
            ->setPlan($plan)
            ->setSubscriberAccountMetadata($subscriberAccountMetadata)
            ->setSim($sim)
            ->setImei($imei)
            ->setIp($ip)
            ->setPublicIP($publicIP)
            ->setVpnId($vpnId)
            ->setPhoneLines($phoneLines)
            ->setScratchCardsRestricted($scratchCardsRestricted);
    }
    /**
     * Get commitmentStart value
     * @return string|null
     */
    public function getCommitmentStart()
    {
        return $this->commitmentStart;
    }
    /**
     * Set commitmentStart value
     * @param string $commitmentStart
     * @return \StructType\OpenPortSubscriberAccountImpl
     */
    public function setCommitmentStart($commitmentStart = null)
    {
        // validation for constraint: string
        if (!is_null($commitmentStart) && !is_string($commitmentStart)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($commitmentStart)), __LINE__);
        }
        $this->commitmentStart = $commitmentStart;
        return $this;
    }
    /**
     * Get commitmentEnd value
     * @return string|null
     */
    public function getCommitmentEnd()
    {
        return $this->commitmentEnd;
    }
    /**
     * Set commitmentEnd value
     * @param string $commitmentEnd
     * @return \StructType\OpenPortSubscriberAccountImpl
     */
    public function setCommitmentEnd($commitmentEnd = null)
    {
        // validation for constraint: string
        if (!is_null($commitmentEnd) && !is_string($commitmentEnd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($commitmentEnd)), __LINE__);
        }
        $this->commitmentEnd = $commitmentEnd;
        return $this;
    }
    /**
     * Get plan value
     * @return \StructType\OpenPortPlanImpl|null
     */
    public function getPlan()
    {
        return $this->plan;
    }
    /**
     * Set plan value
     * @param \StructType\OpenPortPlanImpl $plan
     * @return \StructType\OpenPortSubscriberAccountImpl
     */
    public function setPlan(\StructType\OpenPortPlanImpl $plan = null)
    {
        $this->plan = $plan;
        return $this;
    }
    /**
     * Get subscriberAccountMetadata value
     * @return \StructType\OpenPortSubscriberAccountMetadataImpl|null
     */
    public function getSubscriberAccountMetadata()
    {
        return $this->subscriberAccountMetadata;
    }
    /**
     * Set subscriberAccountMetadata value
     * @param \StructType\OpenPortSubscriberAccountMetadataImpl $subscriberAccountMetadata
     * @return \StructType\OpenPortSubscriberAccountImpl
     */
    public function setSubscriberAccountMetadata(\StructType\OpenPortSubscriberAccountMetadataImpl $subscriberAccountMetadata = null)
    {
        $this->subscriberAccountMetadata = $subscriberAccountMetadata;
        return $this;
    }
    /**
     * Get sim value
     * @return \StructType\DeviceSimImpl|null
     */
    public function getSim()
    {
        return $this->sim;
    }
    /**
     * Set sim value
     * @param \StructType\DeviceSimImpl $sim
     * @return \StructType\OpenPortSubscriberAccountImpl
     */
    public function setSim(\StructType\DeviceSimImpl $sim = null)
    {
        $this->sim = $sim;
        return $this;
    }
    /**
     * Get imei value
     * @return string|null
     */
    public function getImei()
    {
        return $this->imei;
    }
    /**
     * Set imei value
     * @param string $imei
     * @return \StructType\OpenPortSubscriberAccountImpl
     */
    public function setImei($imei = null)
    {
        // validation for constraint: string
        if (!is_null($imei) && !is_string($imei)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($imei)), __LINE__);
        }
        $this->imei = $imei;
        return $this;
    }
    /**
     * Get ip value
     * @return \StructType\DeviceIpImpl|null
     */
    public function getIp()
    {
        return $this->ip;
    }
    /**
     * Set ip value
     * @param \StructType\DeviceIpImpl $ip
     * @return \StructType\OpenPortSubscriberAccountImpl
     */
    public function setIp(\StructType\DeviceIpImpl $ip = null)
    {
        $this->ip = $ip;
        return $this;
    }
    /**
     * Get publicIP value
     * @return string|null
     */
    public function getPublicIP()
    {
        return $this->publicIP;
    }
    /**
     * Set publicIP value
     * @param string $publicIP
     * @return \StructType\OpenPortSubscriberAccountImpl
     */
    public function setPublicIP($publicIP = null)
    {
        // validation for constraint: string
        if (!is_null($publicIP) && !is_string($publicIP)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($publicIP)), __LINE__);
        }
        $this->publicIP = $publicIP;
        return $this;
    }
    /**
     * Get vpnId value
     * @return string|null
     */
    public function getVpnId()
    {
        return $this->vpnId;
    }
    /**
     * Set vpnId value
     * @param string $vpnId
     * @return \StructType\OpenPortSubscriberAccountImpl
     */
    public function setVpnId($vpnId = null)
    {
        // validation for constraint: string
        if (!is_null($vpnId) && !is_string($vpnId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($vpnId)), __LINE__);
        }
        $this->vpnId = $vpnId;
        return $this;
    }
    /**
     * Get phoneLines value
     * @return \StructType\PhoneLines|null
     */
    public function getPhoneLines()
    {
        return $this->phoneLines;
    }
    /**
     * Set phoneLines value
     * @param \StructType\PhoneLines $phoneLines
     * @return \StructType\OpenPortSubscriberAccountImpl
     */
    public function setPhoneLines(\StructType\PhoneLines $phoneLines = null)
    {
        $this->phoneLines = $phoneLines;
        return $this;
    }
    /**
     * Get scratchCardsRestricted value
     * @return bool|null
     */
    public function getScratchCardsRestricted()
    {
        return $this->scratchCardsRestricted;
    }
    /**
     * Set scratchCardsRestricted value
     * @param bool $scratchCardsRestricted
     * @return \StructType\OpenPortSubscriberAccountImpl
     */
    public function setScratchCardsRestricted($scratchCardsRestricted = null)
    {
        $this->scratchCardsRestricted = $scratchCardsRestricted;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OpenPortSubscriberAccountImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
