<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for optionalGroups StructType
 * @subpackage Structs
 */
class OptionalGroups extends AbstractStructBase
{
    /**
     * The optionalGroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\OptionalGroupImpl[]
     */
    public $optionalGroup;
    /**
     * Constructor method for optionalGroups
     * @uses OptionalGroups::setOptionalGroup()
     * @param \StructType\OptionalGroupImpl[] $optionalGroup
     */
    public function __construct(array $optionalGroup = array())
    {
        $this
            ->setOptionalGroup($optionalGroup);
    }
    /**
     * Get optionalGroup value
     * @return \StructType\OptionalGroupImpl[]|null
     */
    public function getOptionalGroup()
    {
        return $this->optionalGroup;
    }
    /**
     * Set optionalGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\OptionalGroupImpl[] $optionalGroup
     * @return \StructType\OptionalGroups
     */
    public function setOptionalGroup(array $optionalGroup = array())
    {
        foreach ($optionalGroup as $optionalGroupsOptionalGroupItem) {
            // validation for constraint: itemType
            if (!$optionalGroupsOptionalGroupItem instanceof \StructType\OptionalGroupImpl) {
                throw new \InvalidArgumentException(sprintf('The optionalGroup property can only contain items of \StructType\OptionalGroupImpl, "%s" given', is_object($optionalGroupsOptionalGroupItem) ? get_class($optionalGroupsOptionalGroupItem) : gettype($optionalGroupsOptionalGroupItem)), __LINE__);
            }
        }
        $this->optionalGroup = $optionalGroup;
        return $this;
    }
    /**
     * Add item to optionalGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\OptionalGroupImpl $item
     * @return \StructType\OptionalGroups
     */
    public function addToOptionalGroup(\StructType\OptionalGroupImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OptionalGroupImpl) {
            throw new \InvalidArgumentException(sprintf('The optionalGroup property can only contain items of \StructType\OptionalGroupImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->optionalGroup[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OptionalGroups
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
