<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for outageScheduleItems StructType
 * @subpackage Structs
 */
class OutageScheduleItems extends AbstractStructBase
{
    /**
     * The outageScheduleItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\OutageScheduleItemImpl[]
     */
    public $outageScheduleItem;
    /**
     * Constructor method for outageScheduleItems
     * @uses OutageScheduleItems::setOutageScheduleItem()
     * @param \StructType\OutageScheduleItemImpl[] $outageScheduleItem
     */
    public function __construct(array $outageScheduleItem = array())
    {
        $this
            ->setOutageScheduleItem($outageScheduleItem);
    }
    /**
     * Get outageScheduleItem value
     * @return \StructType\OutageScheduleItemImpl[]|null
     */
    public function getOutageScheduleItem()
    {
        return $this->outageScheduleItem;
    }
    /**
     * Set outageScheduleItem value
     * @throws \InvalidArgumentException
     * @param \StructType\OutageScheduleItemImpl[] $outageScheduleItem
     * @return \StructType\OutageScheduleItems
     */
    public function setOutageScheduleItem(array $outageScheduleItem = array())
    {
        foreach ($outageScheduleItem as $outageScheduleItemsOutageScheduleItemItem) {
            // validation for constraint: itemType
            if (!$outageScheduleItemsOutageScheduleItemItem instanceof \StructType\OutageScheduleItemImpl) {
                throw new \InvalidArgumentException(sprintf('The outageScheduleItem property can only contain items of \StructType\OutageScheduleItemImpl, "%s" given', is_object($outageScheduleItemsOutageScheduleItemItem) ? get_class($outageScheduleItemsOutageScheduleItemItem) : gettype($outageScheduleItemsOutageScheduleItemItem)), __LINE__);
            }
        }
        $this->outageScheduleItem = $outageScheduleItem;
        return $this;
    }
    /**
     * Add item to outageScheduleItem value
     * @throws \InvalidArgumentException
     * @param \StructType\OutageScheduleItemImpl $item
     * @return \StructType\OutageScheduleItems
     */
    public function addToOutageScheduleItem(\StructType\OutageScheduleItemImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OutageScheduleItemImpl) {
            throw new \InvalidArgumentException(sprintf('The outageScheduleItem property can only contain items of \StructType\OutageScheduleItemImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->outageScheduleItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OutageScheduleItems
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
