<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for pagingPlanImpl StructType
 * @subpackage Structs
 */
class PagingPlanImpl extends PagingPlanBaseImpl
{
    /**
     * The subMarketId
     * @var string
     */
    public $subMarketId;
    /**
     * The servicePlanId
     * @var string
     */
    public $servicePlanId;
    /**
     * The servicePlanOptions
     * @var \StructType\ServicePlanOptions
     */
    public $servicePlanOptions;
    /**
     * Constructor method for pagingPlanImpl
     * @uses PagingPlanImpl::setSubMarketId()
     * @uses PagingPlanImpl::setServicePlanId()
     * @uses PagingPlanImpl::setServicePlanOptions()
     * @param string $subMarketId
     * @param string $servicePlanId
     * @param \StructType\ServicePlanOptions $servicePlanOptions
     */
    public function __construct($subMarketId = null, $servicePlanId = null, \StructType\ServicePlanOptions $servicePlanOptions = null)
    {
        $this
            ->setSubMarketId($subMarketId)
            ->setServicePlanId($servicePlanId)
            ->setServicePlanOptions($servicePlanOptions);
    }
    /**
     * Get subMarketId value
     * @return string|null
     */
    public function getSubMarketId()
    {
        return $this->subMarketId;
    }
    /**
     * Set subMarketId value
     * @param string $subMarketId
     * @return \StructType\PagingPlanImpl
     */
    public function setSubMarketId($subMarketId = null)
    {
        // validation for constraint: string
        if (!is_null($subMarketId) && !is_string($subMarketId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($subMarketId)), __LINE__);
        }
        $this->subMarketId = $subMarketId;
        return $this;
    }
    /**
     * Get servicePlanId value
     * @return string|null
     */
    public function getServicePlanId()
    {
        return $this->servicePlanId;
    }
    /**
     * Set servicePlanId value
     * @param string $servicePlanId
     * @return \StructType\PagingPlanImpl
     */
    public function setServicePlanId($servicePlanId = null)
    {
        // validation for constraint: string
        if (!is_null($servicePlanId) && !is_string($servicePlanId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($servicePlanId)), __LINE__);
        }
        $this->servicePlanId = $servicePlanId;
        return $this;
    }
    /**
     * Get servicePlanOptions value
     * @return \StructType\ServicePlanOptions|null
     */
    public function getServicePlanOptions()
    {
        return $this->servicePlanOptions;
    }
    /**
     * Set servicePlanOptions value
     * @param \StructType\ServicePlanOptions $servicePlanOptions
     * @return \StructType\PagingPlanImpl
     */
    public function setServicePlanOptions(\StructType\ServicePlanOptions $servicePlanOptions = null)
    {
        $this->servicePlanOptions = $servicePlanOptions;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PagingPlanImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
