<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for phoneLines StructType
 * @subpackage Structs
 */
class PhoneLines extends AbstractStructBase
{
    /**
     * The phoneLine
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\OpenPortDeviceNumberImpl[]
     */
    public $phoneLine;
    /**
     * Constructor method for phoneLines
     * @uses PhoneLines::setPhoneLine()
     * @param \StructType\OpenPortDeviceNumberImpl[] $phoneLine
     */
    public function __construct(array $phoneLine = array())
    {
        $this
            ->setPhoneLine($phoneLine);
    }
    /**
     * Get phoneLine value
     * @return \StructType\OpenPortDeviceNumberImpl[]|null
     */
    public function getPhoneLine()
    {
        return $this->phoneLine;
    }
    /**
     * Set phoneLine value
     * @throws \InvalidArgumentException
     * @param \StructType\OpenPortDeviceNumberImpl[] $phoneLine
     * @return \StructType\PhoneLines
     */
    public function setPhoneLine(array $phoneLine = array())
    {
        foreach ($phoneLine as $phoneLinesPhoneLineItem) {
            // validation for constraint: itemType
            if (!$phoneLinesPhoneLineItem instanceof \StructType\OpenPortDeviceNumberImpl) {
                throw new \InvalidArgumentException(sprintf('The phoneLine property can only contain items of \StructType\OpenPortDeviceNumberImpl, "%s" given', is_object($phoneLinesPhoneLineItem) ? get_class($phoneLinesPhoneLineItem) : gettype($phoneLinesPhoneLineItem)), __LINE__);
            }
        }
        $this->phoneLine = $phoneLine;
        return $this;
    }
    /**
     * Add item to phoneLine value
     * @throws \InvalidArgumentException
     * @param \StructType\OpenPortDeviceNumberImpl $item
     * @return \StructType\PhoneLines
     */
    public function addToPhoneLine(\StructType\OpenPortDeviceNumberImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OpenPortDeviceNumberImpl) {
            throw new \InvalidArgumentException(sprintf('The phoneLine property can only contain items of \StructType\OpenPortDeviceNumberImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->phoneLine[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PhoneLines
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
