<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for programmableButtons StructType
 * @subpackage Structs
 */
class ProgrammableButtons extends AbstractStructBase
{
    /**
     * The programmableButton
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $programmableButton;
    /**
     * Constructor method for programmableButtons
     * @uses ProgrammableButtons::setProgrammableButton()
     * @param string[] $programmableButton
     */
    public function __construct(array $programmableButton = array())
    {
        $this
            ->setProgrammableButton($programmableButton);
    }
    /**
     * Get programmableButton value
     * @return string[]|null
     */
    public function getProgrammableButton()
    {
        return $this->programmableButton;
    }
    /**
     * Set programmableButton value
     * @throws \InvalidArgumentException
     * @param string[] $programmableButton
     * @return \StructType\ProgrammableButtons
     */
    public function setProgrammableButton(array $programmableButton = array())
    {
        foreach ($programmableButton as $programmableButtonsProgrammableButtonItem) {
            // validation for constraint: itemType
            if (!is_string($programmableButtonsProgrammableButtonItem)) {
                throw new \InvalidArgumentException(sprintf('The programmableButton property can only contain items of string, "%s" given', is_object($programmableButtonsProgrammableButtonItem) ? get_class($programmableButtonsProgrammableButtonItem) : gettype($programmableButtonsProgrammableButtonItem)), __LINE__);
            }
        }
        $this->programmableButton = $programmableButton;
        return $this;
    }
    /**
     * Add item to programmableButton value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\ProgrammableButtons
     */
    public function addToProgrammableButton($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The programmableButton property can only contain items of string, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->programmableButton[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ProgrammableButtons
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
