<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for pttDeviceSubscriberAccountImpl StructType
 * @subpackage Structs
 */
class PttDeviceSubscriberAccountImpl extends AbsSubscriberAccountImpl
{
    /**
     * The commitmentStart
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $commitmentStart;
    /**
     * The commitmentEnd
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $commitmentEnd;
    /**
     * The subscriptionOrgId
     * @var string
     */
    public $subscriptionOrgId;
    /**
     * The plan
     * @var \StructType\PttDevicePlanImpl
     */
    public $plan;
    /**
     * The imei
     * @var string
     */
    public $imei;
    /**
     * The bulkAction
     * Meta informations extracted from the WSDL
     * - default: false
     * @var bool
     */
    public $bulkAction;
    /**
     * The pttDeviceBulkDetails
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PttDeviceBulkDetails
     */
    public $pttDeviceBulkDetails;
    /**
     * The subscriberAccountMetadata
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PttDeviceSubscriberAccountMetadataImpl
     */
    public $subscriberAccountMetadata;
    /**
     * Constructor method for pttDeviceSubscriberAccountImpl
     * @uses PttDeviceSubscriberAccountImpl::setCommitmentStart()
     * @uses PttDeviceSubscriberAccountImpl::setCommitmentEnd()
     * @uses PttDeviceSubscriberAccountImpl::setSubscriptionOrgId()
     * @uses PttDeviceSubscriberAccountImpl::setPlan()
     * @uses PttDeviceSubscriberAccountImpl::setImei()
     * @uses PttDeviceSubscriberAccountImpl::setBulkAction()
     * @uses PttDeviceSubscriberAccountImpl::setPttDeviceBulkDetails()
     * @uses PttDeviceSubscriberAccountImpl::setSubscriberAccountMetadata()
     * @param string $commitmentStart
     * @param string $commitmentEnd
     * @param string $subscriptionOrgId
     * @param \StructType\PttDevicePlanImpl $plan
     * @param string $imei
     * @param bool $bulkAction
     * @param \StructType\PttDeviceBulkDetails $pttDeviceBulkDetails
     * @param \StructType\PttDeviceSubscriberAccountMetadataImpl $subscriberAccountMetadata
     */
    public function __construct($commitmentStart = null, $commitmentEnd = null, $subscriptionOrgId = null, \StructType\PttDevicePlanImpl $plan = null, $imei = null, $bulkAction = false, \StructType\PttDeviceBulkDetails $pttDeviceBulkDetails = null, \StructType\PttDeviceSubscriberAccountMetadataImpl $subscriberAccountMetadata = null)
    {
        $this
            ->setCommitmentStart($commitmentStart)
            ->setCommitmentEnd($commitmentEnd)
            ->setSubscriptionOrgId($subscriptionOrgId)
            ->setPlan($plan)
            ->setImei($imei)
            ->setBulkAction($bulkAction)
            ->setPttDeviceBulkDetails($pttDeviceBulkDetails)
            ->setSubscriberAccountMetadata($subscriberAccountMetadata);
    }
    /**
     * Get commitmentStart value
     * @return string|null
     */
    public function getCommitmentStart()
    {
        return $this->commitmentStart;
    }
    /**
     * Set commitmentStart value
     * @param string $commitmentStart
     * @return \StructType\PttDeviceSubscriberAccountImpl
     */
    public function setCommitmentStart($commitmentStart = null)
    {
        // validation for constraint: string
        if (!is_null($commitmentStart) && !is_string($commitmentStart)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($commitmentStart)), __LINE__);
        }
        $this->commitmentStart = $commitmentStart;
        return $this;
    }
    /**
     * Get commitmentEnd value
     * @return string|null
     */
    public function getCommitmentEnd()
    {
        return $this->commitmentEnd;
    }
    /**
     * Set commitmentEnd value
     * @param string $commitmentEnd
     * @return \StructType\PttDeviceSubscriberAccountImpl
     */
    public function setCommitmentEnd($commitmentEnd = null)
    {
        // validation for constraint: string
        if (!is_null($commitmentEnd) && !is_string($commitmentEnd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($commitmentEnd)), __LINE__);
        }
        $this->commitmentEnd = $commitmentEnd;
        return $this;
    }
    /**
     * Get subscriptionOrgId value
     * @return string|null
     */
    public function getSubscriptionOrgId()
    {
        return $this->subscriptionOrgId;
    }
    /**
     * Set subscriptionOrgId value
     * @param string $subscriptionOrgId
     * @return \StructType\PttDeviceSubscriberAccountImpl
     */
    public function setSubscriptionOrgId($subscriptionOrgId = null)
    {
        // validation for constraint: string
        if (!is_null($subscriptionOrgId) && !is_string($subscriptionOrgId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($subscriptionOrgId)), __LINE__);
        }
        $this->subscriptionOrgId = $subscriptionOrgId;
        return $this;
    }
    /**
     * Get plan value
     * @return \StructType\PttDevicePlanImpl|null
     */
    public function getPlan()
    {
        return $this->plan;
    }
    /**
     * Set plan value
     * @param \StructType\PttDevicePlanImpl $plan
     * @return \StructType\PttDeviceSubscriberAccountImpl
     */
    public function setPlan(\StructType\PttDevicePlanImpl $plan = null)
    {
        $this->plan = $plan;
        return $this;
    }
    /**
     * Get imei value
     * @return string|null
     */
    public function getImei()
    {
        return $this->imei;
    }
    /**
     * Set imei value
     * @param string $imei
     * @return \StructType\PttDeviceSubscriberAccountImpl
     */
    public function setImei($imei = null)
    {
        // validation for constraint: string
        if (!is_null($imei) && !is_string($imei)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($imei)), __LINE__);
        }
        $this->imei = $imei;
        return $this;
    }
    /**
     * Get bulkAction value
     * @return bool|null
     */
    public function getBulkAction()
    {
        return $this->bulkAction;
    }
    /**
     * Set bulkAction value
     * @param bool $bulkAction
     * @return \StructType\PttDeviceSubscriberAccountImpl
     */
    public function setBulkAction($bulkAction = false)
    {
        $this->bulkAction = $bulkAction;
        return $this;
    }
    /**
     * Get pttDeviceBulkDetails value
     * @return \StructType\PttDeviceBulkDetails|null
     */
    public function getPttDeviceBulkDetails()
    {
        return $this->pttDeviceBulkDetails;
    }
    /**
     * Set pttDeviceBulkDetails value
     * @param \StructType\PttDeviceBulkDetails $pttDeviceBulkDetails
     * @return \StructType\PttDeviceSubscriberAccountImpl
     */
    public function setPttDeviceBulkDetails(\StructType\PttDeviceBulkDetails $pttDeviceBulkDetails = null)
    {
        $this->pttDeviceBulkDetails = $pttDeviceBulkDetails;
        return $this;
    }
    /**
     * Get subscriberAccountMetadata value
     * @return \StructType\PttDeviceSubscriberAccountMetadataImpl|null
     */
    public function getSubscriberAccountMetadata()
    {
        return $this->subscriberAccountMetadata;
    }
    /**
     * Set subscriberAccountMetadata value
     * @param \StructType\PttDeviceSubscriberAccountMetadataImpl $subscriberAccountMetadata
     * @return \StructType\PttDeviceSubscriberAccountImpl
     */
    public function setSubscriberAccountMetadata(\StructType\PttDeviceSubscriberAccountMetadataImpl $subscriberAccountMetadata = null)
    {
        $this->subscriberAccountMetadata = $subscriberAccountMetadata;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PttDeviceSubscriberAccountImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
