<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for pttDevices StructType
 * @subpackage Structs
 */
class PttDevices extends AbstractStructBase
{
    /**
     * The device
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\PttDeviceDetailImpl[]
     */
    public $device;
    /**
     * Constructor method for pttDevices
     * @uses PttDevices::setDevice()
     * @param \StructType\PttDeviceDetailImpl[] $device
     */
    public function __construct(array $device = array())
    {
        $this
            ->setDevice($device);
    }
    /**
     * Get device value
     * @return \StructType\PttDeviceDetailImpl[]|null
     */
    public function getDevice()
    {
        return $this->device;
    }
    /**
     * Set device value
     * @throws \InvalidArgumentException
     * @param \StructType\PttDeviceDetailImpl[] $device
     * @return \StructType\PttDevices
     */
    public function setDevice(array $device = array())
    {
        foreach ($device as $pttDevicesDeviceItem) {
            // validation for constraint: itemType
            if (!$pttDevicesDeviceItem instanceof \StructType\PttDeviceDetailImpl) {
                throw new \InvalidArgumentException(sprintf('The device property can only contain items of \StructType\PttDeviceDetailImpl, "%s" given', is_object($pttDevicesDeviceItem) ? get_class($pttDevicesDeviceItem) : gettype($pttDevicesDeviceItem)), __LINE__);
            }
        }
        $this->device = $device;
        return $this;
    }
    /**
     * Add item to device value
     * @throws \InvalidArgumentException
     * @param \StructType\PttDeviceDetailImpl $item
     * @return \StructType\PttDevices
     */
    public function addToDevice(\StructType\PttDeviceDetailImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PttDeviceDetailImpl) {
            throw new \InvalidArgumentException(sprintf('The device property can only contain items of \StructType\PttDeviceDetailImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->device[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PttDevices
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
