<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for pttTalkGroupSubscriberAccountImpl StructType
 * @subpackage Structs
 */
class PttTalkGroupSubscriberAccountImpl extends AbsSubscriberAccountImpl
{
    /**
     * The commitmentStart
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $commitmentStart;
    /**
     * The commitmentEnd
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $commitmentEnd;
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The talkgroupId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $talkgroupId;
    /**
     * The subscriptionOrgId
     * @var string
     */
    public $subscriptionOrgId;
    /**
     * The plan
     * @var \StructType\PttTalkGroupPlanImpl
     */
    public $plan;
    /**
     * The subscriberAccountMetadata
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PttTalkGroupSubscriberAccountMetadataImpl
     */
    public $subscriberAccountMetadata;
    /**
     * Constructor method for pttTalkGroupSubscriberAccountImpl
     * @uses PttTalkGroupSubscriberAccountImpl::setCommitmentStart()
     * @uses PttTalkGroupSubscriberAccountImpl::setCommitmentEnd()
     * @uses PttTalkGroupSubscriberAccountImpl::setName()
     * @uses PttTalkGroupSubscriberAccountImpl::setTalkgroupId()
     * @uses PttTalkGroupSubscriberAccountImpl::setSubscriptionOrgId()
     * @uses PttTalkGroupSubscriberAccountImpl::setPlan()
     * @uses PttTalkGroupSubscriberAccountImpl::setSubscriberAccountMetadata()
     * @param string $commitmentStart
     * @param string $commitmentEnd
     * @param string $name
     * @param string $talkgroupId
     * @param string $subscriptionOrgId
     * @param \StructType\PttTalkGroupPlanImpl $plan
     * @param \StructType\PttTalkGroupSubscriberAccountMetadataImpl $subscriberAccountMetadata
     */
    public function __construct($commitmentStart = null, $commitmentEnd = null, $name = null, $talkgroupId = null, $subscriptionOrgId = null, \StructType\PttTalkGroupPlanImpl $plan = null, \StructType\PttTalkGroupSubscriberAccountMetadataImpl $subscriberAccountMetadata = null)
    {
        $this
            ->setCommitmentStart($commitmentStart)
            ->setCommitmentEnd($commitmentEnd)
            ->setName($name)
            ->setTalkgroupId($talkgroupId)
            ->setSubscriptionOrgId($subscriptionOrgId)
            ->setPlan($plan)
            ->setSubscriberAccountMetadata($subscriberAccountMetadata);
    }
    /**
     * Get commitmentStart value
     * @return string|null
     */
    public function getCommitmentStart()
    {
        return $this->commitmentStart;
    }
    /**
     * Set commitmentStart value
     * @param string $commitmentStart
     * @return \StructType\PttTalkGroupSubscriberAccountImpl
     */
    public function setCommitmentStart($commitmentStart = null)
    {
        // validation for constraint: string
        if (!is_null($commitmentStart) && !is_string($commitmentStart)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($commitmentStart)), __LINE__);
        }
        $this->commitmentStart = $commitmentStart;
        return $this;
    }
    /**
     * Get commitmentEnd value
     * @return string|null
     */
    public function getCommitmentEnd()
    {
        return $this->commitmentEnd;
    }
    /**
     * Set commitmentEnd value
     * @param string $commitmentEnd
     * @return \StructType\PttTalkGroupSubscriberAccountImpl
     */
    public function setCommitmentEnd($commitmentEnd = null)
    {
        // validation for constraint: string
        if (!is_null($commitmentEnd) && !is_string($commitmentEnd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($commitmentEnd)), __LINE__);
        }
        $this->commitmentEnd = $commitmentEnd;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\PttTalkGroupSubscriberAccountImpl
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get talkgroupId value
     * @return string|null
     */
    public function getTalkgroupId()
    {
        return $this->talkgroupId;
    }
    /**
     * Set talkgroupId value
     * @param string $talkgroupId
     * @return \StructType\PttTalkGroupSubscriberAccountImpl
     */
    public function setTalkgroupId($talkgroupId = null)
    {
        // validation for constraint: string
        if (!is_null($talkgroupId) && !is_string($talkgroupId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($talkgroupId)), __LINE__);
        }
        $this->talkgroupId = $talkgroupId;
        return $this;
    }
    /**
     * Get subscriptionOrgId value
     * @return string|null
     */
    public function getSubscriptionOrgId()
    {
        return $this->subscriptionOrgId;
    }
    /**
     * Set subscriptionOrgId value
     * @param string $subscriptionOrgId
     * @return \StructType\PttTalkGroupSubscriberAccountImpl
     */
    public function setSubscriptionOrgId($subscriptionOrgId = null)
    {
        // validation for constraint: string
        if (!is_null($subscriptionOrgId) && !is_string($subscriptionOrgId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($subscriptionOrgId)), __LINE__);
        }
        $this->subscriptionOrgId = $subscriptionOrgId;
        return $this;
    }
    /**
     * Get plan value
     * @return \StructType\PttTalkGroupPlanImpl|null
     */
    public function getPlan()
    {
        return $this->plan;
    }
    /**
     * Set plan value
     * @param \StructType\PttTalkGroupPlanImpl $plan
     * @return \StructType\PttTalkGroupSubscriberAccountImpl
     */
    public function setPlan(\StructType\PttTalkGroupPlanImpl $plan = null)
    {
        $this->plan = $plan;
        return $this;
    }
    /**
     * Get subscriberAccountMetadata value
     * @return \StructType\PttTalkGroupSubscriberAccountMetadataImpl|null
     */
    public function getSubscriberAccountMetadata()
    {
        return $this->subscriberAccountMetadata;
    }
    /**
     * Set subscriberAccountMetadata value
     * @param \StructType\PttTalkGroupSubscriberAccountMetadataImpl $subscriberAccountMetadata
     * @return \StructType\PttTalkGroupSubscriberAccountImpl
     */
    public function setSubscriberAccountMetadata(\StructType\PttTalkGroupSubscriberAccountMetadataImpl $subscriberAccountMetadata = null)
    {
        $this->subscriberAccountMetadata = $subscriberAccountMetadata;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PttTalkGroupSubscriberAccountImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
