<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for pttTalkgroups StructType
 * @subpackage Structs
 */
class PttTalkgroups extends AbstractStructBase
{
    /**
     * The talkgroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\PttTalkgroupDetailImpl[]
     */
    public $talkgroup;
    /**
     * Constructor method for pttTalkgroups
     * @uses PttTalkgroups::setTalkgroup()
     * @param \StructType\PttTalkgroupDetailImpl[] $talkgroup
     */
    public function __construct(array $talkgroup = array())
    {
        $this
            ->setTalkgroup($talkgroup);
    }
    /**
     * Get talkgroup value
     * @return \StructType\PttTalkgroupDetailImpl[]|null
     */
    public function getTalkgroup()
    {
        return $this->talkgroup;
    }
    /**
     * Set talkgroup value
     * @throws \InvalidArgumentException
     * @param \StructType\PttTalkgroupDetailImpl[] $talkgroup
     * @return \StructType\PttTalkgroups
     */
    public function setTalkgroup(array $talkgroup = array())
    {
        foreach ($talkgroup as $pttTalkgroupsTalkgroupItem) {
            // validation for constraint: itemType
            if (!$pttTalkgroupsTalkgroupItem instanceof \StructType\PttTalkgroupDetailImpl) {
                throw new \InvalidArgumentException(sprintf('The talkgroup property can only contain items of \StructType\PttTalkgroupDetailImpl, "%s" given', is_object($pttTalkgroupsTalkgroupItem) ? get_class($pttTalkgroupsTalkgroupItem) : gettype($pttTalkgroupsTalkgroupItem)), __LINE__);
            }
        }
        $this->talkgroup = $talkgroup;
        return $this;
    }
    /**
     * Add item to talkgroup value
     * @throws \InvalidArgumentException
     * @param \StructType\PttTalkgroupDetailImpl $item
     * @return \StructType\PttTalkgroups
     */
    public function addToTalkgroup(\StructType\PttTalkgroupDetailImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PttTalkgroupDetailImpl) {
            throw new \InvalidArgumentException(sprintf('The talkgroup property can only contain items of \StructType\PttTalkgroupDetailImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->talkgroup[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PttTalkgroups
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
