<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for rechargeHistoryEntryImpl StructType
 * @subpackage Structs
 */
class RechargeHistoryEntryImpl extends AbstractStructBase
{
    /**
     * The accountNumber
     * @var string
     */
    public $accountNumber;
    /**
     * The voucherDate
     * @var string
     */
    public $voucherDate;
    /**
     * The serialNumber
     * @var string
     */
    public $serialNumber;
    /**
     * The voucherType
     * @var string
     */
    public $voucherType;
    /**
     * The addedUnitsOrDays
     * @var string
     */
    public $addedUnitsOrDays;
    /**
     * The oldBalance
     * @var string
     */
    public $oldBalance;
    /**
     * The newBalance
     * @var string
     */
    public $newBalance;
    /**
     * The oldExpirationDate
     * @var string
     */
    public $oldExpirationDate;
    /**
     * The newExpirationDate
     * @var string
     */
    public $newExpirationDate;
    /**
     * The createdBy
     * @var string
     */
    public $createdBy;
    /**
     * The rechargeFlag
     * @var bool
     */
    public $rechargeFlag;
    /**
     * The isRefunded
     * @var bool
     */
    public $isRefunded;
    /**
     * Constructor method for rechargeHistoryEntryImpl
     * @uses RechargeHistoryEntryImpl::setAccountNumber()
     * @uses RechargeHistoryEntryImpl::setVoucherDate()
     * @uses RechargeHistoryEntryImpl::setSerialNumber()
     * @uses RechargeHistoryEntryImpl::setVoucherType()
     * @uses RechargeHistoryEntryImpl::setAddedUnitsOrDays()
     * @uses RechargeHistoryEntryImpl::setOldBalance()
     * @uses RechargeHistoryEntryImpl::setNewBalance()
     * @uses RechargeHistoryEntryImpl::setOldExpirationDate()
     * @uses RechargeHistoryEntryImpl::setNewExpirationDate()
     * @uses RechargeHistoryEntryImpl::setCreatedBy()
     * @uses RechargeHistoryEntryImpl::setRechargeFlag()
     * @uses RechargeHistoryEntryImpl::setIsRefunded()
     * @param string $accountNumber
     * @param string $voucherDate
     * @param string $serialNumber
     * @param string $voucherType
     * @param string $addedUnitsOrDays
     * @param string $oldBalance
     * @param string $newBalance
     * @param string $oldExpirationDate
     * @param string $newExpirationDate
     * @param string $createdBy
     * @param bool $rechargeFlag
     * @param bool $isRefunded
     */
    public function __construct($accountNumber = null, $voucherDate = null, $serialNumber = null, $voucherType = null, $addedUnitsOrDays = null, $oldBalance = null, $newBalance = null, $oldExpirationDate = null, $newExpirationDate = null, $createdBy = null, $rechargeFlag = null, $isRefunded = null)
    {
        $this
            ->setAccountNumber($accountNumber)
            ->setVoucherDate($voucherDate)
            ->setSerialNumber($serialNumber)
            ->setVoucherType($voucherType)
            ->setAddedUnitsOrDays($addedUnitsOrDays)
            ->setOldBalance($oldBalance)
            ->setNewBalance($newBalance)
            ->setOldExpirationDate($oldExpirationDate)
            ->setNewExpirationDate($newExpirationDate)
            ->setCreatedBy($createdBy)
            ->setRechargeFlag($rechargeFlag)
            ->setIsRefunded($isRefunded);
    }
    /**
     * Get accountNumber value
     * @return string|null
     */
    public function getAccountNumber()
    {
        return $this->accountNumber;
    }
    /**
     * Set accountNumber value
     * @param string $accountNumber
     * @return \StructType\RechargeHistoryEntryImpl
     */
    public function setAccountNumber($accountNumber = null)
    {
        // validation for constraint: string
        if (!is_null($accountNumber) && !is_string($accountNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($accountNumber)), __LINE__);
        }
        $this->accountNumber = $accountNumber;
        return $this;
    }
    /**
     * Get voucherDate value
     * @return string|null
     */
    public function getVoucherDate()
    {
        return $this->voucherDate;
    }
    /**
     * Set voucherDate value
     * @param string $voucherDate
     * @return \StructType\RechargeHistoryEntryImpl
     */
    public function setVoucherDate($voucherDate = null)
    {
        // validation for constraint: string
        if (!is_null($voucherDate) && !is_string($voucherDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($voucherDate)), __LINE__);
        }
        $this->voucherDate = $voucherDate;
        return $this;
    }
    /**
     * Get serialNumber value
     * @return string|null
     */
    public function getSerialNumber()
    {
        return $this->serialNumber;
    }
    /**
     * Set serialNumber value
     * @param string $serialNumber
     * @return \StructType\RechargeHistoryEntryImpl
     */
    public function setSerialNumber($serialNumber = null)
    {
        // validation for constraint: string
        if (!is_null($serialNumber) && !is_string($serialNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($serialNumber)), __LINE__);
        }
        $this->serialNumber = $serialNumber;
        return $this;
    }
    /**
     * Get voucherType value
     * @return string|null
     */
    public function getVoucherType()
    {
        return $this->voucherType;
    }
    /**
     * Set voucherType value
     * @param string $voucherType
     * @return \StructType\RechargeHistoryEntryImpl
     */
    public function setVoucherType($voucherType = null)
    {
        // validation for constraint: string
        if (!is_null($voucherType) && !is_string($voucherType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($voucherType)), __LINE__);
        }
        $this->voucherType = $voucherType;
        return $this;
    }
    /**
     * Get addedUnitsOrDays value
     * @return string|null
     */
    public function getAddedUnitsOrDays()
    {
        return $this->addedUnitsOrDays;
    }
    /**
     * Set addedUnitsOrDays value
     * @param string $addedUnitsOrDays
     * @return \StructType\RechargeHistoryEntryImpl
     */
    public function setAddedUnitsOrDays($addedUnitsOrDays = null)
    {
        // validation for constraint: string
        if (!is_null($addedUnitsOrDays) && !is_string($addedUnitsOrDays)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($addedUnitsOrDays)), __LINE__);
        }
        $this->addedUnitsOrDays = $addedUnitsOrDays;
        return $this;
    }
    /**
     * Get oldBalance value
     * @return string|null
     */
    public function getOldBalance()
    {
        return $this->oldBalance;
    }
    /**
     * Set oldBalance value
     * @param string $oldBalance
     * @return \StructType\RechargeHistoryEntryImpl
     */
    public function setOldBalance($oldBalance = null)
    {
        // validation for constraint: string
        if (!is_null($oldBalance) && !is_string($oldBalance)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($oldBalance)), __LINE__);
        }
        $this->oldBalance = $oldBalance;
        return $this;
    }
    /**
     * Get newBalance value
     * @return string|null
     */
    public function getNewBalance()
    {
        return $this->newBalance;
    }
    /**
     * Set newBalance value
     * @param string $newBalance
     * @return \StructType\RechargeHistoryEntryImpl
     */
    public function setNewBalance($newBalance = null)
    {
        // validation for constraint: string
        if (!is_null($newBalance) && !is_string($newBalance)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($newBalance)), __LINE__);
        }
        $this->newBalance = $newBalance;
        return $this;
    }
    /**
     * Get oldExpirationDate value
     * @return string|null
     */
    public function getOldExpirationDate()
    {
        return $this->oldExpirationDate;
    }
    /**
     * Set oldExpirationDate value
     * @param string $oldExpirationDate
     * @return \StructType\RechargeHistoryEntryImpl
     */
    public function setOldExpirationDate($oldExpirationDate = null)
    {
        // validation for constraint: string
        if (!is_null($oldExpirationDate) && !is_string($oldExpirationDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($oldExpirationDate)), __LINE__);
        }
        $this->oldExpirationDate = $oldExpirationDate;
        return $this;
    }
    /**
     * Get newExpirationDate value
     * @return string|null
     */
    public function getNewExpirationDate()
    {
        return $this->newExpirationDate;
    }
    /**
     * Set newExpirationDate value
     * @param string $newExpirationDate
     * @return \StructType\RechargeHistoryEntryImpl
     */
    public function setNewExpirationDate($newExpirationDate = null)
    {
        // validation for constraint: string
        if (!is_null($newExpirationDate) && !is_string($newExpirationDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($newExpirationDate)), __LINE__);
        }
        $this->newExpirationDate = $newExpirationDate;
        return $this;
    }
    /**
     * Get createdBy value
     * @return string|null
     */
    public function getCreatedBy()
    {
        return $this->createdBy;
    }
    /**
     * Set createdBy value
     * @param string $createdBy
     * @return \StructType\RechargeHistoryEntryImpl
     */
    public function setCreatedBy($createdBy = null)
    {
        // validation for constraint: string
        if (!is_null($createdBy) && !is_string($createdBy)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($createdBy)), __LINE__);
        }
        $this->createdBy = $createdBy;
        return $this;
    }
    /**
     * Get rechargeFlag value
     * @return bool|null
     */
    public function getRechargeFlag()
    {
        return $this->rechargeFlag;
    }
    /**
     * Set rechargeFlag value
     * @param bool $rechargeFlag
     * @return \StructType\RechargeHistoryEntryImpl
     */
    public function setRechargeFlag($rechargeFlag = null)
    {
        $this->rechargeFlag = $rechargeFlag;
        return $this;
    }
    /**
     * Get isRefunded value
     * @return bool|null
     */
    public function getIsRefunded()
    {
        return $this->isRefunded;
    }
    /**
     * Set isRefunded value
     * @param bool $isRefunded
     * @return \StructType\RechargeHistoryEntryImpl
     */
    public function setIsRefunded($isRefunded = null)
    {
        $this->isRefunded = $isRefunded;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RechargeHistoryEntryImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
