<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for rechargePrepaidAccountRequestImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:rechargePrepaidAccountRequestImpl
 * @subpackage Structs
 */
class RechargePrepaidAccountRequestImpl extends AuthenticatedIwsRequestImpl
{
    /**
     * The msisdn
     * @var string
     */
    public $msisdn;
    /**
     * The accountNo
     * @var string
     */
    public $accountNo;
    /**
     * The prepaidVoucher
     * @var \StructType\PrepaidVoucherImpl
     */
    public $prepaidVoucher;
    /**
     * Constructor method for rechargePrepaidAccountRequestImpl
     * @uses RechargePrepaidAccountRequestImpl::setMsisdn()
     * @uses RechargePrepaidAccountRequestImpl::setAccountNo()
     * @uses RechargePrepaidAccountRequestImpl::setPrepaidVoucher()
     * @param string $msisdn
     * @param string $accountNo
     * @param \StructType\PrepaidVoucherImpl $prepaidVoucher
     */
    public function __construct($msisdn = null, $accountNo = null, \StructType\PrepaidVoucherImpl $prepaidVoucher = null)
    {
        $this
            ->setMsisdn($msisdn)
            ->setAccountNo($accountNo)
            ->setPrepaidVoucher($prepaidVoucher);
    }
    /**
     * Get msisdn value
     * @return string|null
     */
    public function getMsisdn()
    {
        return $this->msisdn;
    }
    /**
     * Set msisdn value
     * @param string $msisdn
     * @return \StructType\RechargePrepaidAccountRequestImpl
     */
    public function setMsisdn($msisdn = null)
    {
        // validation for constraint: string
        if (!is_null($msisdn) && !is_string($msisdn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($msisdn)), __LINE__);
        }
        $this->msisdn = $msisdn;
        return $this;
    }
    /**
     * Get accountNo value
     * @return string|null
     */
    public function getAccountNo()
    {
        return $this->accountNo;
    }
    /**
     * Set accountNo value
     * @param string $accountNo
     * @return \StructType\RechargePrepaidAccountRequestImpl
     */
    public function setAccountNo($accountNo = null)
    {
        // validation for constraint: string
        if (!is_null($accountNo) && !is_string($accountNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($accountNo)), __LINE__);
        }
        $this->accountNo = $accountNo;
        return $this;
    }
    /**
     * Get prepaidVoucher value
     * @return \StructType\PrepaidVoucherImpl|null
     */
    public function getPrepaidVoucher()
    {
        return $this->prepaidVoucher;
    }
    /**
     * Set prepaidVoucher value
     * @param \StructType\PrepaidVoucherImpl $prepaidVoucher
     * @return \StructType\RechargePrepaidAccountRequestImpl
     */
    public function setPrepaidVoucher(\StructType\PrepaidVoucherImpl $prepaidVoucher = null)
    {
        $this->prepaidVoucher = $prepaidVoucher;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RechargePrepaidAccountRequestImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
