<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for requiredGroups StructType
 * @subpackage Structs
 */
class RequiredGroups extends AbstractStructBase
{
    /**
     * The requiredGroup
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RequiredGroupImpl[]
     */
    public $requiredGroup;
    /**
     * Constructor method for requiredGroups
     * @uses RequiredGroups::setRequiredGroup()
     * @param \StructType\RequiredGroupImpl[] $requiredGroup
     */
    public function __construct(array $requiredGroup = array())
    {
        $this
            ->setRequiredGroup($requiredGroup);
    }
    /**
     * Get requiredGroup value
     * @return \StructType\RequiredGroupImpl[]|null
     */
    public function getRequiredGroup()
    {
        return $this->requiredGroup;
    }
    /**
     * Set requiredGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\RequiredGroupImpl[] $requiredGroup
     * @return \StructType\RequiredGroups
     */
    public function setRequiredGroup(array $requiredGroup = array())
    {
        foreach ($requiredGroup as $requiredGroupsRequiredGroupItem) {
            // validation for constraint: itemType
            if (!$requiredGroupsRequiredGroupItem instanceof \StructType\RequiredGroupImpl) {
                throw new \InvalidArgumentException(sprintf('The requiredGroup property can only contain items of \StructType\RequiredGroupImpl, "%s" given', is_object($requiredGroupsRequiredGroupItem) ? get_class($requiredGroupsRequiredGroupItem) : gettype($requiredGroupsRequiredGroupItem)), __LINE__);
            }
        }
        $this->requiredGroup = $requiredGroup;
        return $this;
    }
    /**
     * Add item to requiredGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\RequiredGroupImpl $item
     * @return \StructType\RequiredGroups
     */
    public function addToRequiredGroup(\StructType\RequiredGroupImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RequiredGroupImpl) {
            throw new \InvalidArgumentException(sprintf('The requiredGroup property can only contain items of \StructType\RequiredGroupImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->requiredGroup[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RequiredGroups
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
