<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for resourceInventoryReportImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:resourceInventoryReportImpl
 * @subpackage Structs
 */
class ResourceInventoryReportImpl extends AbstractStructBase
{
    /**
     * The resourceId
     * @var string
     */
    public $resourceId;
    /**
     * The serviceType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $serviceType;
    /**
     * The status
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $status;
    /**
     * The subMarket
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $subMarket;
    /**
     * The portNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $portNumber;
    /**
     * The resType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $resType;
    /**
     * The lastUpdated
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $lastUpdated;
    /**
     * The vertical
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $vertical;
    /**
     * The manufacturer
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $manufacturer;
    /**
     * The modelNum
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $modelNum;
    /**
     * The modelName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $modelName;
    /**
     * Constructor method for resourceInventoryReportImpl
     * @uses ResourceInventoryReportImpl::setResourceId()
     * @uses ResourceInventoryReportImpl::setServiceType()
     * @uses ResourceInventoryReportImpl::setStatus()
     * @uses ResourceInventoryReportImpl::setSubMarket()
     * @uses ResourceInventoryReportImpl::setPortNumber()
     * @uses ResourceInventoryReportImpl::setResType()
     * @uses ResourceInventoryReportImpl::setLastUpdated()
     * @uses ResourceInventoryReportImpl::setVertical()
     * @uses ResourceInventoryReportImpl::setManufacturer()
     * @uses ResourceInventoryReportImpl::setModelNum()
     * @uses ResourceInventoryReportImpl::setModelName()
     * @param string $resourceId
     * @param string $serviceType
     * @param string $status
     * @param string $subMarket
     * @param string $portNumber
     * @param string $resType
     * @param string $lastUpdated
     * @param string $vertical
     * @param string $manufacturer
     * @param string $modelNum
     * @param string $modelName
     */
    public function __construct($resourceId = null, $serviceType = null, $status = null, $subMarket = null, $portNumber = null, $resType = null, $lastUpdated = null, $vertical = null, $manufacturer = null, $modelNum = null, $modelName = null)
    {
        $this
            ->setResourceId($resourceId)
            ->setServiceType($serviceType)
            ->setStatus($status)
            ->setSubMarket($subMarket)
            ->setPortNumber($portNumber)
            ->setResType($resType)
            ->setLastUpdated($lastUpdated)
            ->setVertical($vertical)
            ->setManufacturer($manufacturer)
            ->setModelNum($modelNum)
            ->setModelName($modelName);
    }
    /**
     * Get resourceId value
     * @return string|null
     */
    public function getResourceId()
    {
        return $this->resourceId;
    }
    /**
     * Set resourceId value
     * @param string $resourceId
     * @return \StructType\ResourceInventoryReportImpl
     */
    public function setResourceId($resourceId = null)
    {
        // validation for constraint: string
        if (!is_null($resourceId) && !is_string($resourceId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($resourceId)), __LINE__);
        }
        $this->resourceId = $resourceId;
        return $this;
    }
    /**
     * Get serviceType value
     * @return string|null
     */
    public function getServiceType()
    {
        return $this->serviceType;
    }
    /**
     * Set serviceType value
     * @param string $serviceType
     * @return \StructType\ResourceInventoryReportImpl
     */
    public function setServiceType($serviceType = null)
    {
        // validation for constraint: string
        if (!is_null($serviceType) && !is_string($serviceType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($serviceType)), __LINE__);
        }
        $this->serviceType = $serviceType;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\ResourceInventoryReportImpl
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get subMarket value
     * @return string|null
     */
    public function getSubMarket()
    {
        return $this->subMarket;
    }
    /**
     * Set subMarket value
     * @param string $subMarket
     * @return \StructType\ResourceInventoryReportImpl
     */
    public function setSubMarket($subMarket = null)
    {
        // validation for constraint: string
        if (!is_null($subMarket) && !is_string($subMarket)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($subMarket)), __LINE__);
        }
        $this->subMarket = $subMarket;
        return $this;
    }
    /**
     * Get portNumber value
     * @return string|null
     */
    public function getPortNumber()
    {
        return $this->portNumber;
    }
    /**
     * Set portNumber value
     * @param string $portNumber
     * @return \StructType\ResourceInventoryReportImpl
     */
    public function setPortNumber($portNumber = null)
    {
        // validation for constraint: string
        if (!is_null($portNumber) && !is_string($portNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($portNumber)), __LINE__);
        }
        $this->portNumber = $portNumber;
        return $this;
    }
    /**
     * Get resType value
     * @return string|null
     */
    public function getResType()
    {
        return $this->resType;
    }
    /**
     * Set resType value
     * @param string $resType
     * @return \StructType\ResourceInventoryReportImpl
     */
    public function setResType($resType = null)
    {
        // validation for constraint: string
        if (!is_null($resType) && !is_string($resType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($resType)), __LINE__);
        }
        $this->resType = $resType;
        return $this;
    }
    /**
     * Get lastUpdated value
     * @return string|null
     */
    public function getLastUpdated()
    {
        return $this->lastUpdated;
    }
    /**
     * Set lastUpdated value
     * @param string $lastUpdated
     * @return \StructType\ResourceInventoryReportImpl
     */
    public function setLastUpdated($lastUpdated = null)
    {
        // validation for constraint: string
        if (!is_null($lastUpdated) && !is_string($lastUpdated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastUpdated)), __LINE__);
        }
        $this->lastUpdated = $lastUpdated;
        return $this;
    }
    /**
     * Get vertical value
     * @return string|null
     */
    public function getVertical()
    {
        return $this->vertical;
    }
    /**
     * Set vertical value
     * @param string $vertical
     * @return \StructType\ResourceInventoryReportImpl
     */
    public function setVertical($vertical = null)
    {
        // validation for constraint: string
        if (!is_null($vertical) && !is_string($vertical)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($vertical)), __LINE__);
        }
        $this->vertical = $vertical;
        return $this;
    }
    /**
     * Get manufacturer value
     * @return string|null
     */
    public function getManufacturer()
    {
        return $this->manufacturer;
    }
    /**
     * Set manufacturer value
     * @param string $manufacturer
     * @return \StructType\ResourceInventoryReportImpl
     */
    public function setManufacturer($manufacturer = null)
    {
        // validation for constraint: string
        if (!is_null($manufacturer) && !is_string($manufacturer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($manufacturer)), __LINE__);
        }
        $this->manufacturer = $manufacturer;
        return $this;
    }
    /**
     * Get modelNum value
     * @return string|null
     */
    public function getModelNum()
    {
        return $this->modelNum;
    }
    /**
     * Set modelNum value
     * @param string $modelNum
     * @return \StructType\ResourceInventoryReportImpl
     */
    public function setModelNum($modelNum = null)
    {
        // validation for constraint: string
        if (!is_null($modelNum) && !is_string($modelNum)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($modelNum)), __LINE__);
        }
        $this->modelNum = $modelNum;
        return $this;
    }
    /**
     * Get modelName value
     * @return string|null
     */
    public function getModelName()
    {
        return $this->modelName;
    }
    /**
     * Set modelName value
     * @param string $modelName
     * @return \StructType\ResourceInventoryReportImpl
     */
    public function setModelName($modelName = null)
    {
        // validation for constraint: string
        if (!is_null($modelName) && !is_string($modelName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($modelName)), __LINE__);
        }
        $this->modelName = $modelName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ResourceInventoryReportImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
