<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for restrictedDeviceSwapImpl StructType
 * @subpackage Structs
 */
class RestrictedDeviceSwapImpl extends AbstractStructBase
{
    /**
     * The oldDeviceNumber
     * @var string
     */
    public $oldDeviceNumber;
    /**
     * The newDeviceNumber
     * @var string
     */
    public $newDeviceNumber;
    /**
     * Constructor method for restrictedDeviceSwapImpl
     * @uses RestrictedDeviceSwapImpl::setOldDeviceNumber()
     * @uses RestrictedDeviceSwapImpl::setNewDeviceNumber()
     * @param string $oldDeviceNumber
     * @param string $newDeviceNumber
     */
    public function __construct($oldDeviceNumber = null, $newDeviceNumber = null)
    {
        $this
            ->setOldDeviceNumber($oldDeviceNumber)
            ->setNewDeviceNumber($newDeviceNumber);
    }
    /**
     * Get oldDeviceNumber value
     * @return string|null
     */
    public function getOldDeviceNumber()
    {
        return $this->oldDeviceNumber;
    }
    /**
     * Set oldDeviceNumber value
     * @param string $oldDeviceNumber
     * @return \StructType\RestrictedDeviceSwapImpl
     */
    public function setOldDeviceNumber($oldDeviceNumber = null)
    {
        // validation for constraint: string
        if (!is_null($oldDeviceNumber) && !is_string($oldDeviceNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($oldDeviceNumber)), __LINE__);
        }
        $this->oldDeviceNumber = $oldDeviceNumber;
        return $this;
    }
    /**
     * Get newDeviceNumber value
     * @return string|null
     */
    public function getNewDeviceNumber()
    {
        return $this->newDeviceNumber;
    }
    /**
     * Set newDeviceNumber value
     * @param string $newDeviceNumber
     * @return \StructType\RestrictedDeviceSwapImpl
     */
    public function setNewDeviceNumber($newDeviceNumber = null)
    {
        // validation for constraint: string
        if (!is_null($newDeviceNumber) && !is_string($newDeviceNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($newDeviceNumber)), __LINE__);
        }
        $this->newDeviceNumber = $newDeviceNumber;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RestrictedDeviceSwapImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
