<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for restrictedSimSwapRequestImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:restrictedSimSwapRequestImpl
 * @subpackage Structs
 */
class RestrictedSimSwapRequestImpl extends AuthenticatedIwsRequestImpl
{
    /**
     * The subscriberAccountNumber
     * @var string
     */
    public $subscriberAccountNumber;
    /**
     * The deviceSwap
     * @var \StructType\RestrictedDeviceSwapImpl
     */
    public $deviceSwap;
    /**
     * Constructor method for restrictedSimSwapRequestImpl
     * @uses RestrictedSimSwapRequestImpl::setSubscriberAccountNumber()
     * @uses RestrictedSimSwapRequestImpl::setDeviceSwap()
     * @param string $subscriberAccountNumber
     * @param \StructType\RestrictedDeviceSwapImpl $deviceSwap
     */
    public function __construct($subscriberAccountNumber = null, \StructType\RestrictedDeviceSwapImpl $deviceSwap = null)
    {
        $this
            ->setSubscriberAccountNumber($subscriberAccountNumber)
            ->setDeviceSwap($deviceSwap);
    }
    /**
     * Get subscriberAccountNumber value
     * @return string|null
     */
    public function getSubscriberAccountNumber()
    {
        return $this->subscriberAccountNumber;
    }
    /**
     * Set subscriberAccountNumber value
     * @param string $subscriberAccountNumber
     * @return \StructType\RestrictedSimSwapRequestImpl
     */
    public function setSubscriberAccountNumber($subscriberAccountNumber = null)
    {
        // validation for constraint: string
        if (!is_null($subscriberAccountNumber) && !is_string($subscriberAccountNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($subscriberAccountNumber)), __LINE__);
        }
        $this->subscriberAccountNumber = $subscriberAccountNumber;
        return $this;
    }
    /**
     * Get deviceSwap value
     * @return \StructType\RestrictedDeviceSwapImpl|null
     */
    public function getDeviceSwap()
    {
        return $this->deviceSwap;
    }
    /**
     * Set deviceSwap value
     * @param \StructType\RestrictedDeviceSwapImpl $deviceSwap
     * @return \StructType\RestrictedSimSwapRequestImpl
     */
    public function setDeviceSwap(\StructType\RestrictedDeviceSwapImpl $deviceSwap = null)
    {
        $this->deviceSwap = $deviceSwap;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RestrictedSimSwapRequestImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
