<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for results StructType
 * @subpackage Structs
 */
class Results extends AbstractStructBase
{
    /**
     * The result
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SbdDeleteDownloadResultEntryImpl[]
     */
    public $result;
    /**
     * Constructor method for results
     * @uses Results::setResult()
     * @param \StructType\SbdDeleteDownloadResultEntryImpl[] $result
     */
    public function __construct(array $result = array())
    {
        $this
            ->setResult($result);
    }
    /**
     * Get result value
     * @return \StructType\SbdDeleteDownloadResultEntryImpl[]|null
     */
    public function getResult()
    {
        return $this->result;
    }
    /**
     * Set result value
     * @throws \InvalidArgumentException
     * @param \StructType\SbdDeleteDownloadResultEntryImpl[] $result
     * @return \StructType\Results
     */
    public function setResult(array $result = array())
    {
        foreach ($result as $resultsResultItem) {
            // validation for constraint: itemType
            if (!$resultsResultItem instanceof \StructType\SbdDeleteDownloadResultEntryImpl) {
                throw new \InvalidArgumentException(sprintf('The result property can only contain items of \StructType\SbdDeleteDownloadResultEntryImpl, "%s" given', is_object($resultsResultItem) ? get_class($resultsResultItem) : gettype($resultsResultItem)), __LINE__);
            }
        }
        $this->result = $result;
        return $this;
    }
    /**
     * Add item to result value
     * @throws \InvalidArgumentException
     * @param \StructType\SbdDeleteDownloadResultEntryImpl $item
     * @return \StructType\Results
     */
    public function addToResult(\StructType\SbdDeleteDownloadResultEntryImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SbdDeleteDownloadResultEntryImpl) {
            throw new \InvalidArgumentException(sprintf('The result property can only contain items of \StructType\SbdDeleteDownloadResultEntryImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->result[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Results
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
