<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for sbdActivityImpl StructType
 * @subpackage Structs
 */
abstract class SbdActivityImpl extends AbstractStructBase
{
    /**
     * The id
     * @var int
     */
    public $id;
    /**
     * The imei
     * @var string
     */
    public $imei;
    /**
     * The size
     * @var int
     */
    public $size;
    /**
     * The deliveryStatus
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $deliveryStatus;
    /**
     * Constructor method for sbdActivityImpl
     * @uses SbdActivityImpl::setId()
     * @uses SbdActivityImpl::setImei()
     * @uses SbdActivityImpl::setSize()
     * @uses SbdActivityImpl::setDeliveryStatus()
     * @param int $id
     * @param string $imei
     * @param int $size
     * @param string $deliveryStatus
     */
    public function __construct($id = null, $imei = null, $size = null, $deliveryStatus = null)
    {
        $this
            ->setId($id)
            ->setImei($imei)
            ->setSize($size)
            ->setDeliveryStatus($deliveryStatus);
    }
    /**
     * Get id value
     * @return int|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param int $id
     * @return \StructType\SbdActivityImpl
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !is_numeric($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get imei value
     * @return string|null
     */
    public function getImei()
    {
        return $this->imei;
    }
    /**
     * Set imei value
     * @param string $imei
     * @return \StructType\SbdActivityImpl
     */
    public function setImei($imei = null)
    {
        // validation for constraint: string
        if (!is_null($imei) && !is_string($imei)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($imei)), __LINE__);
        }
        $this->imei = $imei;
        return $this;
    }
    /**
     * Get size value
     * @return int|null
     */
    public function getSize()
    {
        return $this->size;
    }
    /**
     * Set size value
     * @param int $size
     * @return \StructType\SbdActivityImpl
     */
    public function setSize($size = null)
    {
        // validation for constraint: int
        if (!is_null($size) && !is_numeric($size)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($size)), __LINE__);
        }
        $this->size = $size;
        return $this;
    }
    /**
     * Get deliveryStatus value
     * @return string|null
     */
    public function getDeliveryStatus()
    {
        return $this->deliveryStatus;
    }
    /**
     * Set deliveryStatus value
     * @param string $deliveryStatus
     * @return \StructType\SbdActivityImpl
     */
    public function setDeliveryStatus($deliveryStatus = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryStatus) && !is_string($deliveryStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($deliveryStatus)), __LINE__);
        }
        $this->deliveryStatus = $deliveryStatus;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SbdActivityImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
