<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for sbdDeleteDownloadResultEntryImpl StructType
 * @subpackage Structs
 */
class SbdDeleteDownloadResultEntryImpl extends AbstractStructBase
{
    /**
     * The messageId
     * @var int
     */
    public $messageId;
    /**
     * The result
     * @var string
     */
    public $result;
    /**
     * Constructor method for sbdDeleteDownloadResultEntryImpl
     * @uses SbdDeleteDownloadResultEntryImpl::setMessageId()
     * @uses SbdDeleteDownloadResultEntryImpl::setResult()
     * @param int $messageId
     * @param string $result
     */
    public function __construct($messageId = null, $result = null)
    {
        $this
            ->setMessageId($messageId)
            ->setResult($result);
    }
    /**
     * Get messageId value
     * @return int|null
     */
    public function getMessageId()
    {
        return $this->messageId;
    }
    /**
     * Set messageId value
     * @param int $messageId
     * @return \StructType\SbdDeleteDownloadResultEntryImpl
     */
    public function setMessageId($messageId = null)
    {
        // validation for constraint: int
        if (!is_null($messageId) && !is_numeric($messageId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($messageId)), __LINE__);
        }
        $this->messageId = $messageId;
        return $this;
    }
    /**
     * Get result value
     * @return string|null
     */
    public function getResult()
    {
        return $this->result;
    }
    /**
     * Set result value
     * @uses \EnumType\SbdDeleteDownloadResultTypeEnum::valueIsValid()
     * @uses \EnumType\SbdDeleteDownloadResultTypeEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $result
     * @return \StructType\SbdDeleteDownloadResultEntryImpl
     */
    public function setResult($result = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\SbdDeleteDownloadResultTypeEnum::valueIsValid($result)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $result, implode(', ', \EnumType\SbdDeleteDownloadResultTypeEnum::getValidValues())), __LINE__);
        }
        $this->result = $result;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SbdDeleteDownloadResultEntryImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
