<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for sbdPlanImpl StructType
 * @subpackage Structs
 */
class SbdPlanImpl extends AbsPlanImpl
{
    /**
     * The sbdBundleId
     * Meta informations extracted from the WSDL
     * - default: 0
     * @var string
     */
    public $sbdBundleId;
    /**
     * The lritFlagstate
     * @var string
     */
    public $lritFlagstate;
    /**
     * The ringAlertsFlag
     * Meta informations extracted from the WSDL
     * - default: false
     * @var bool
     */
    public $ringAlertsFlag;
    /**
     * Constructor method for sbdPlanImpl
     * @uses SbdPlanImpl::setSbdBundleId()
     * @uses SbdPlanImpl::setLritFlagstate()
     * @uses SbdPlanImpl::setRingAlertsFlag()
     * @param string $sbdBundleId
     * @param string $lritFlagstate
     * @param bool $ringAlertsFlag
     */
    public function __construct($sbdBundleId = '0', $lritFlagstate = null, $ringAlertsFlag = false)
    {
        $this
            ->setSbdBundleId($sbdBundleId)
            ->setLritFlagstate($lritFlagstate)
            ->setRingAlertsFlag($ringAlertsFlag);
    }
    /**
     * Get sbdBundleId value
     * @return string|null
     */
    public function getSbdBundleId()
    {
        return $this->sbdBundleId;
    }
    /**
     * Set sbdBundleId value
     * @param string $sbdBundleId
     * @return \StructType\SbdPlanImpl
     */
    public function setSbdBundleId($sbdBundleId = '0')
    {
        // validation for constraint: string
        if (!is_null($sbdBundleId) && !is_string($sbdBundleId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sbdBundleId)), __LINE__);
        }
        $this->sbdBundleId = $sbdBundleId;
        return $this;
    }
    /**
     * Get lritFlagstate value
     * @return string|null
     */
    public function getLritFlagstate()
    {
        return $this->lritFlagstate;
    }
    /**
     * Set lritFlagstate value
     * @param string $lritFlagstate
     * @return \StructType\SbdPlanImpl
     */
    public function setLritFlagstate($lritFlagstate = null)
    {
        // validation for constraint: string
        if (!is_null($lritFlagstate) && !is_string($lritFlagstate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lritFlagstate)), __LINE__);
        }
        $this->lritFlagstate = $lritFlagstate;
        return $this;
    }
    /**
     * Get ringAlertsFlag value
     * @return bool|null
     */
    public function getRingAlertsFlag()
    {
        return $this->ringAlertsFlag;
    }
    /**
     * Set ringAlertsFlag value
     * @param bool $ringAlertsFlag
     * @return \StructType\SbdPlanImpl
     */
    public function setRingAlertsFlag($ringAlertsFlag = false)
    {
        $this->ringAlertsFlag = $ringAlertsFlag;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SbdPlanImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
