<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for sbdmtActivityImpl StructType
 * @subpackage Structs
 */
class SbdmtActivityImpl extends SbdActivityImpl
{
    /**
     * The timeReceived
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $timeReceived;
    /**
     * The timeQueued
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $timeQueued;
    /**
     * The timeDelivered
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $timeDelivered;
    /**
     * The mtmsn
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $mtmsn;
    /**
     * Constructor method for sbdmtActivityImpl
     * @uses SbdmtActivityImpl::setTimeReceived()
     * @uses SbdmtActivityImpl::setTimeQueued()
     * @uses SbdmtActivityImpl::setTimeDelivered()
     * @uses SbdmtActivityImpl::setMtmsn()
     * @param string $timeReceived
     * @param string $timeQueued
     * @param string $timeDelivered
     * @param string $mtmsn
     */
    public function __construct($timeReceived = null, $timeQueued = null, $timeDelivered = null, $mtmsn = null)
    {
        $this
            ->setTimeReceived($timeReceived)
            ->setTimeQueued($timeQueued)
            ->setTimeDelivered($timeDelivered)
            ->setMtmsn($mtmsn);
    }
    /**
     * Get timeReceived value
     * @return string|null
     */
    public function getTimeReceived()
    {
        return $this->timeReceived;
    }
    /**
     * Set timeReceived value
     * @param string $timeReceived
     * @return \StructType\SbdmtActivityImpl
     */
    public function setTimeReceived($timeReceived = null)
    {
        // validation for constraint: string
        if (!is_null($timeReceived) && !is_string($timeReceived)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($timeReceived)), __LINE__);
        }
        $this->timeReceived = $timeReceived;
        return $this;
    }
    /**
     * Get timeQueued value
     * @return string|null
     */
    public function getTimeQueued()
    {
        return $this->timeQueued;
    }
    /**
     * Set timeQueued value
     * @param string $timeQueued
     * @return \StructType\SbdmtActivityImpl
     */
    public function setTimeQueued($timeQueued = null)
    {
        // validation for constraint: string
        if (!is_null($timeQueued) && !is_string($timeQueued)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($timeQueued)), __LINE__);
        }
        $this->timeQueued = $timeQueued;
        return $this;
    }
    /**
     * Get timeDelivered value
     * @return string|null
     */
    public function getTimeDelivered()
    {
        return $this->timeDelivered;
    }
    /**
     * Set timeDelivered value
     * @param string $timeDelivered
     * @return \StructType\SbdmtActivityImpl
     */
    public function setTimeDelivered($timeDelivered = null)
    {
        // validation for constraint: string
        if (!is_null($timeDelivered) && !is_string($timeDelivered)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($timeDelivered)), __LINE__);
        }
        $this->timeDelivered = $timeDelivered;
        return $this;
    }
    /**
     * Get mtmsn value
     * @return string|null
     */
    public function getMtmsn()
    {
        return $this->mtmsn;
    }
    /**
     * Set mtmsn value
     * @param string $mtmsn
     * @return \StructType\SbdmtActivityImpl
     */
    public function setMtmsn($mtmsn = null)
    {
        // validation for constraint: string
        if (!is_null($mtmsn) && !is_string($mtmsn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mtmsn)), __LINE__);
        }
        $this->mtmsn = $mtmsn;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SbdmtActivityImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
