<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for scratchCardBatchesEntryImpl StructType
 * @subpackage Structs
 */
class ScratchCardBatchesEntryImpl extends AbstractStructBase
{
    /**
     * The voucherType
     * @var string
     */
    public $voucherType;
    /**
     * The batchNumber
     * @var string
     */
    public $batchNumber;
    /**
     * The totalBatch
     * @var int
     */
    public $totalBatch;
    /**
     * The availableToActivate
     * @var int
     */
    public $availableToActivate;
    /**
     * The activeForUse
     * @var int
     */
    public $activeForUse;
    /**
     * The inUse
     * @var string
     */
    public $inUse;
    /**
     * The expired
     * @var int
     */
    public $expired;
    /**
     * The usedUp
     * @var int
     */
    public $usedUp;
    /**
     * The startSerialNumber
     * @var string
     */
    public $startSerialNumber;
    /**
     * The endSerialNumber
     * @var string
     */
    public $endSerialNumber;
    /**
     * Constructor method for scratchCardBatchesEntryImpl
     * @uses ScratchCardBatchesEntryImpl::setVoucherType()
     * @uses ScratchCardBatchesEntryImpl::setBatchNumber()
     * @uses ScratchCardBatchesEntryImpl::setTotalBatch()
     * @uses ScratchCardBatchesEntryImpl::setAvailableToActivate()
     * @uses ScratchCardBatchesEntryImpl::setActiveForUse()
     * @uses ScratchCardBatchesEntryImpl::setInUse()
     * @uses ScratchCardBatchesEntryImpl::setExpired()
     * @uses ScratchCardBatchesEntryImpl::setUsedUp()
     * @uses ScratchCardBatchesEntryImpl::setStartSerialNumber()
     * @uses ScratchCardBatchesEntryImpl::setEndSerialNumber()
     * @param string $voucherType
     * @param string $batchNumber
     * @param int $totalBatch
     * @param int $availableToActivate
     * @param int $activeForUse
     * @param string $inUse
     * @param int $expired
     * @param int $usedUp
     * @param string $startSerialNumber
     * @param string $endSerialNumber
     */
    public function __construct($voucherType = null, $batchNumber = null, $totalBatch = null, $availableToActivate = null, $activeForUse = null, $inUse = null, $expired = null, $usedUp = null, $startSerialNumber = null, $endSerialNumber = null)
    {
        $this
            ->setVoucherType($voucherType)
            ->setBatchNumber($batchNumber)
            ->setTotalBatch($totalBatch)
            ->setAvailableToActivate($availableToActivate)
            ->setActiveForUse($activeForUse)
            ->setInUse($inUse)
            ->setExpired($expired)
            ->setUsedUp($usedUp)
            ->setStartSerialNumber($startSerialNumber)
            ->setEndSerialNumber($endSerialNumber);
    }
    /**
     * Get voucherType value
     * @return string|null
     */
    public function getVoucherType()
    {
        return $this->voucherType;
    }
    /**
     * Set voucherType value
     * @param string $voucherType
     * @return \StructType\ScratchCardBatchesEntryImpl
     */
    public function setVoucherType($voucherType = null)
    {
        // validation for constraint: string
        if (!is_null($voucherType) && !is_string($voucherType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($voucherType)), __LINE__);
        }
        $this->voucherType = $voucherType;
        return $this;
    }
    /**
     * Get batchNumber value
     * @return string|null
     */
    public function getBatchNumber()
    {
        return $this->batchNumber;
    }
    /**
     * Set batchNumber value
     * @param string $batchNumber
     * @return \StructType\ScratchCardBatchesEntryImpl
     */
    public function setBatchNumber($batchNumber = null)
    {
        // validation for constraint: string
        if (!is_null($batchNumber) && !is_string($batchNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($batchNumber)), __LINE__);
        }
        $this->batchNumber = $batchNumber;
        return $this;
    }
    /**
     * Get totalBatch value
     * @return int|null
     */
    public function getTotalBatch()
    {
        return $this->totalBatch;
    }
    /**
     * Set totalBatch value
     * @param int $totalBatch
     * @return \StructType\ScratchCardBatchesEntryImpl
     */
    public function setTotalBatch($totalBatch = null)
    {
        // validation for constraint: int
        if (!is_null($totalBatch) && !is_numeric($totalBatch)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($totalBatch)), __LINE__);
        }
        $this->totalBatch = $totalBatch;
        return $this;
    }
    /**
     * Get availableToActivate value
     * @return int|null
     */
    public function getAvailableToActivate()
    {
        return $this->availableToActivate;
    }
    /**
     * Set availableToActivate value
     * @param int $availableToActivate
     * @return \StructType\ScratchCardBatchesEntryImpl
     */
    public function setAvailableToActivate($availableToActivate = null)
    {
        // validation for constraint: int
        if (!is_null($availableToActivate) && !is_numeric($availableToActivate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($availableToActivate)), __LINE__);
        }
        $this->availableToActivate = $availableToActivate;
        return $this;
    }
    /**
     * Get activeForUse value
     * @return int|null
     */
    public function getActiveForUse()
    {
        return $this->activeForUse;
    }
    /**
     * Set activeForUse value
     * @param int $activeForUse
     * @return \StructType\ScratchCardBatchesEntryImpl
     */
    public function setActiveForUse($activeForUse = null)
    {
        // validation for constraint: int
        if (!is_null($activeForUse) && !is_numeric($activeForUse)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($activeForUse)), __LINE__);
        }
        $this->activeForUse = $activeForUse;
        return $this;
    }
    /**
     * Get inUse value
     * @return string|null
     */
    public function getInUse()
    {
        return $this->inUse;
    }
    /**
     * Set inUse value
     * @param string $inUse
     * @return \StructType\ScratchCardBatchesEntryImpl
     */
    public function setInUse($inUse = null)
    {
        // validation for constraint: string
        if (!is_null($inUse) && !is_string($inUse)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($inUse)), __LINE__);
        }
        $this->inUse = $inUse;
        return $this;
    }
    /**
     * Get expired value
     * @return int|null
     */
    public function getExpired()
    {
        return $this->expired;
    }
    /**
     * Set expired value
     * @param int $expired
     * @return \StructType\ScratchCardBatchesEntryImpl
     */
    public function setExpired($expired = null)
    {
        // validation for constraint: int
        if (!is_null($expired) && !is_numeric($expired)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($expired)), __LINE__);
        }
        $this->expired = $expired;
        return $this;
    }
    /**
     * Get usedUp value
     * @return int|null
     */
    public function getUsedUp()
    {
        return $this->usedUp;
    }
    /**
     * Set usedUp value
     * @param int $usedUp
     * @return \StructType\ScratchCardBatchesEntryImpl
     */
    public function setUsedUp($usedUp = null)
    {
        // validation for constraint: int
        if (!is_null($usedUp) && !is_numeric($usedUp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($usedUp)), __LINE__);
        }
        $this->usedUp = $usedUp;
        return $this;
    }
    /**
     * Get startSerialNumber value
     * @return string|null
     */
    public function getStartSerialNumber()
    {
        return $this->startSerialNumber;
    }
    /**
     * Set startSerialNumber value
     * @param string $startSerialNumber
     * @return \StructType\ScratchCardBatchesEntryImpl
     */
    public function setStartSerialNumber($startSerialNumber = null)
    {
        // validation for constraint: string
        if (!is_null($startSerialNumber) && !is_string($startSerialNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($startSerialNumber)), __LINE__);
        }
        $this->startSerialNumber = $startSerialNumber;
        return $this;
    }
    /**
     * Get endSerialNumber value
     * @return string|null
     */
    public function getEndSerialNumber()
    {
        return $this->endSerialNumber;
    }
    /**
     * Set endSerialNumber value
     * @param string $endSerialNumber
     * @return \StructType\ScratchCardBatchesEntryImpl
     */
    public function setEndSerialNumber($endSerialNumber = null)
    {
        // validation for constraint: string
        if (!is_null($endSerialNumber) && !is_string($endSerialNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($endSerialNumber)), __LINE__);
        }
        $this->endSerialNumber = $endSerialNumber;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ScratchCardBatchesEntryImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
