<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for scratchCards StructType
 * @subpackage Structs
 */
class ScratchCards extends AbstractStructBase
{
    /**
     * The scratchCardsDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ScratchCardsDetailEntryImpl[]
     */
    public $scratchCardsDetail;
    /**
     * Constructor method for scratchCards
     * @uses ScratchCards::setScratchCardsDetail()
     * @param \StructType\ScratchCardsDetailEntryImpl[] $scratchCardsDetail
     */
    public function __construct(array $scratchCardsDetail = array())
    {
        $this
            ->setScratchCardsDetail($scratchCardsDetail);
    }
    /**
     * Get scratchCardsDetail value
     * @return \StructType\ScratchCardsDetailEntryImpl[]|null
     */
    public function getScratchCardsDetail()
    {
        return $this->scratchCardsDetail;
    }
    /**
     * Set scratchCardsDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\ScratchCardsDetailEntryImpl[] $scratchCardsDetail
     * @return \StructType\ScratchCards
     */
    public function setScratchCardsDetail(array $scratchCardsDetail = array())
    {
        foreach ($scratchCardsDetail as $scratchCardsScratchCardsDetailItem) {
            // validation for constraint: itemType
            if (!$scratchCardsScratchCardsDetailItem instanceof \StructType\ScratchCardsDetailEntryImpl) {
                throw new \InvalidArgumentException(sprintf('The scratchCardsDetail property can only contain items of \StructType\ScratchCardsDetailEntryImpl, "%s" given', is_object($scratchCardsScratchCardsDetailItem) ? get_class($scratchCardsScratchCardsDetailItem) : gettype($scratchCardsScratchCardsDetailItem)), __LINE__);
            }
        }
        $this->scratchCardsDetail = $scratchCardsDetail;
        return $this;
    }
    /**
     * Add item to scratchCardsDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\ScratchCardsDetailEntryImpl $item
     * @return \StructType\ScratchCards
     */
    public function addToScratchCardsDetail(\StructType\ScratchCardsDetailEntryImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ScratchCardsDetailEntryImpl) {
            throw new \InvalidArgumentException(sprintf('The scratchCardsDetail property can only contain items of \StructType\ScratchCardsDetailEntryImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->scratchCardsDetail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ScratchCards
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
