<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for serialRangeImpl StructType
 * @subpackage Structs
 */
class SerialRangeImpl extends AbstractStructBase
{
    /**
     * The rangeEnd
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $rangeEnd;
    /**
     * The rangeStart
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $rangeStart;
    /**
     * Constructor method for serialRangeImpl
     * @uses SerialRangeImpl::setRangeEnd()
     * @uses SerialRangeImpl::setRangeStart()
     * @param string $rangeEnd
     * @param string $rangeStart
     */
    public function __construct($rangeEnd = null, $rangeStart = null)
    {
        $this
            ->setRangeEnd($rangeEnd)
            ->setRangeStart($rangeStart);
    }
    /**
     * Get rangeEnd value
     * @return string|null
     */
    public function getRangeEnd()
    {
        return $this->rangeEnd;
    }
    /**
     * Set rangeEnd value
     * @param string $rangeEnd
     * @return \StructType\SerialRangeImpl
     */
    public function setRangeEnd($rangeEnd = null)
    {
        // validation for constraint: string
        if (!is_null($rangeEnd) && !is_string($rangeEnd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rangeEnd)), __LINE__);
        }
        $this->rangeEnd = $rangeEnd;
        return $this;
    }
    /**
     * Get rangeStart value
     * @return string|null
     */
    public function getRangeStart()
    {
        return $this->rangeStart;
    }
    /**
     * Set rangeStart value
     * @param string $rangeStart
     * @return \StructType\SerialRangeImpl
     */
    public function setRangeStart($rangeStart = null)
    {
        // validation for constraint: string
        if (!is_null($rangeStart) && !is_string($rangeStart)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rangeStart)), __LINE__);
        }
        $this->rangeStart = $rangeStart;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SerialRangeImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
