<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for servicePlanImpl StructType
 * @subpackage Structs
 */
class ServicePlanImpl extends AbsServicePlanImpl
{
    /**
     * The serviceCategories
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ServiceCategories
     */
    public $serviceCategories;
    /**
     * The permittedServices
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PermittedServices
     */
    public $permittedServices;
    /**
     * The requiredGroups
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RequiredGroups
     */
    public $requiredGroups;
    /**
     * The optionalGroups
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OptionalGroups
     */
    public $optionalGroups;
    /**
     * The servicePlanOptions
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ServicePlanOptions
     */
    public $servicePlanOptions;
    /**
     * The twoStageBlock
     * @var bool
     */
    public $twoStageBlock;
    /**
     * Constructor method for servicePlanImpl
     * @uses ServicePlanImpl::setServiceCategories()
     * @uses ServicePlanImpl::setPermittedServices()
     * @uses ServicePlanImpl::setRequiredGroups()
     * @uses ServicePlanImpl::setOptionalGroups()
     * @uses ServicePlanImpl::setServicePlanOptions()
     * @uses ServicePlanImpl::setTwoStageBlock()
     * @param \StructType\ServiceCategories $serviceCategories
     * @param \StructType\PermittedServices $permittedServices
     * @param \StructType\RequiredGroups $requiredGroups
     * @param \StructType\OptionalGroups $optionalGroups
     * @param \StructType\ServicePlanOptions $servicePlanOptions
     * @param bool $twoStageBlock
     */
    public function __construct(\StructType\ServiceCategories $serviceCategories = null, \StructType\PermittedServices $permittedServices = null, \StructType\RequiredGroups $requiredGroups = null, \StructType\OptionalGroups $optionalGroups = null, \StructType\ServicePlanOptions $servicePlanOptions = null, $twoStageBlock = null)
    {
        $this
            ->setServiceCategories($serviceCategories)
            ->setPermittedServices($permittedServices)
            ->setRequiredGroups($requiredGroups)
            ->setOptionalGroups($optionalGroups)
            ->setServicePlanOptions($servicePlanOptions)
            ->setTwoStageBlock($twoStageBlock);
    }
    /**
     * Get serviceCategories value
     * @return \StructType\ServiceCategories|null
     */
    public function getServiceCategories()
    {
        return $this->serviceCategories;
    }
    /**
     * Set serviceCategories value
     * @param \StructType\ServiceCategories $serviceCategories
     * @return \StructType\ServicePlanImpl
     */
    public function setServiceCategories(\StructType\ServiceCategories $serviceCategories = null)
    {
        $this->serviceCategories = $serviceCategories;
        return $this;
    }
    /**
     * Get permittedServices value
     * @return \StructType\PermittedServices|null
     */
    public function getPermittedServices()
    {
        return $this->permittedServices;
    }
    /**
     * Set permittedServices value
     * @param \StructType\PermittedServices $permittedServices
     * @return \StructType\ServicePlanImpl
     */
    public function setPermittedServices(\StructType\PermittedServices $permittedServices = null)
    {
        $this->permittedServices = $permittedServices;
        return $this;
    }
    /**
     * Get requiredGroups value
     * @return \StructType\RequiredGroups|null
     */
    public function getRequiredGroups()
    {
        return $this->requiredGroups;
    }
    /**
     * Set requiredGroups value
     * @param \StructType\RequiredGroups $requiredGroups
     * @return \StructType\ServicePlanImpl
     */
    public function setRequiredGroups(\StructType\RequiredGroups $requiredGroups = null)
    {
        $this->requiredGroups = $requiredGroups;
        return $this;
    }
    /**
     * Get optionalGroups value
     * @return \StructType\OptionalGroups|null
     */
    public function getOptionalGroups()
    {
        return $this->optionalGroups;
    }
    /**
     * Set optionalGroups value
     * @param \StructType\OptionalGroups $optionalGroups
     * @return \StructType\ServicePlanImpl
     */
    public function setOptionalGroups(\StructType\OptionalGroups $optionalGroups = null)
    {
        $this->optionalGroups = $optionalGroups;
        return $this;
    }
    /**
     * Get servicePlanOptions value
     * @return \StructType\ServicePlanOptions|null
     */
    public function getServicePlanOptions()
    {
        return $this->servicePlanOptions;
    }
    /**
     * Set servicePlanOptions value
     * @param \StructType\ServicePlanOptions $servicePlanOptions
     * @return \StructType\ServicePlanImpl
     */
    public function setServicePlanOptions(\StructType\ServicePlanOptions $servicePlanOptions = null)
    {
        $this->servicePlanOptions = $servicePlanOptions;
        return $this;
    }
    /**
     * Get twoStageBlock value
     * @return bool|null
     */
    public function getTwoStageBlock()
    {
        return $this->twoStageBlock;
    }
    /**
     * Set twoStageBlock value
     * @param bool $twoStageBlock
     * @return \StructType\ServicePlanImpl
     */
    public function setTwoStageBlock($twoStageBlock = null)
    {
        $this->twoStageBlock = $twoStageBlock;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ServicePlanImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
