<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for servicePlanOptionImpl StructType
 * @subpackage Structs
 */
class ServicePlanOptionImpl extends AbstractStructBase
{
    /**
     * The id
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $id;
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $name;
    /**
     * The required
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var bool
     */
    public $required;
    /**
     * The defaulted
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var bool
     */
    public $defaulted;
    /**
     * The displayColumn
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $displayColumn;
    /**
     * The displayOrder
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $displayOrder;
    /**
     * The groupName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $groupName;
    /**
     * The requires
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $requires;
    /**
     * The obsolete
     * @var bool
     */
    public $obsolete;
    /**
     * The dependentDeal
     * @var string
     */
    public $dependentDeal;
    /**
     * Constructor method for servicePlanOptionImpl
     * @uses ServicePlanOptionImpl::setId()
     * @uses ServicePlanOptionImpl::setName()
     * @uses ServicePlanOptionImpl::setRequired()
     * @uses ServicePlanOptionImpl::setDefaulted()
     * @uses ServicePlanOptionImpl::setDisplayColumn()
     * @uses ServicePlanOptionImpl::setDisplayOrder()
     * @uses ServicePlanOptionImpl::setGroupName()
     * @uses ServicePlanOptionImpl::setRequires()
     * @uses ServicePlanOptionImpl::setObsolete()
     * @uses ServicePlanOptionImpl::setDependentDeal()
     * @param string $id
     * @param string $name
     * @param bool $required
     * @param bool $defaulted
     * @param string $displayColumn
     * @param string $displayOrder
     * @param string $groupName
     * @param string $requires
     * @param bool $obsolete
     * @param string $dependentDeal
     */
    public function __construct($id = null, $name = null, $required = null, $defaulted = null, $displayColumn = null, $displayOrder = null, $groupName = null, $requires = null, $obsolete = null, $dependentDeal = null)
    {
        $this
            ->setId($id)
            ->setName($name)
            ->setRequired($required)
            ->setDefaulted($defaulted)
            ->setDisplayColumn($displayColumn)
            ->setDisplayOrder($displayOrder)
            ->setGroupName($groupName)
            ->setRequires($requires)
            ->setObsolete($obsolete)
            ->setDependentDeal($dependentDeal);
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\ServicePlanOptionImpl
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\ServicePlanOptionImpl
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get required value
     * @return bool|null
     */
    public function getRequired()
    {
        return $this->required;
    }
    /**
     * Set required value
     * @param bool $required
     * @return \StructType\ServicePlanOptionImpl
     */
    public function setRequired($required = null)
    {
        $this->required = $required;
        return $this;
    }
    /**
     * Get defaulted value
     * @return bool|null
     */
    public function getDefaulted()
    {
        return $this->defaulted;
    }
    /**
     * Set defaulted value
     * @param bool $defaulted
     * @return \StructType\ServicePlanOptionImpl
     */
    public function setDefaulted($defaulted = null)
    {
        $this->defaulted = $defaulted;
        return $this;
    }
    /**
     * Get displayColumn value
     * @return string|null
     */
    public function getDisplayColumn()
    {
        return $this->displayColumn;
    }
    /**
     * Set displayColumn value
     * @param string $displayColumn
     * @return \StructType\ServicePlanOptionImpl
     */
    public function setDisplayColumn($displayColumn = null)
    {
        // validation for constraint: string
        if (!is_null($displayColumn) && !is_string($displayColumn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($displayColumn)), __LINE__);
        }
        $this->displayColumn = $displayColumn;
        return $this;
    }
    /**
     * Get displayOrder value
     * @return string|null
     */
    public function getDisplayOrder()
    {
        return $this->displayOrder;
    }
    /**
     * Set displayOrder value
     * @param string $displayOrder
     * @return \StructType\ServicePlanOptionImpl
     */
    public function setDisplayOrder($displayOrder = null)
    {
        // validation for constraint: string
        if (!is_null($displayOrder) && !is_string($displayOrder)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($displayOrder)), __LINE__);
        }
        $this->displayOrder = $displayOrder;
        return $this;
    }
    /**
     * Get groupName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGroupName()
    {
        return isset($this->groupName) ? $this->groupName : null;
    }
    /**
     * Set groupName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $groupName
     * @return \StructType\ServicePlanOptionImpl
     */
    public function setGroupName($groupName = null)
    {
        // validation for constraint: string
        if (!is_null($groupName) && !is_string($groupName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($groupName)), __LINE__);
        }
        if (is_null($groupName) || (is_array($groupName) && empty($groupName))) {
            unset($this->groupName);
        } else {
            $this->groupName = $groupName;
        }
        return $this;
    }
    /**
     * Get requires value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRequires()
    {
        return isset($this->requires) ? $this->requires : null;
    }
    /**
     * Set requires value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $requires
     * @return \StructType\ServicePlanOptionImpl
     */
    public function setRequires($requires = null)
    {
        // validation for constraint: string
        if (!is_null($requires) && !is_string($requires)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($requires)), __LINE__);
        }
        if (is_null($requires) || (is_array($requires) && empty($requires))) {
            unset($this->requires);
        } else {
            $this->requires = $requires;
        }
        return $this;
    }
    /**
     * Get obsolete value
     * @return bool|null
     */
    public function getObsolete()
    {
        return $this->obsolete;
    }
    /**
     * Set obsolete value
     * @param bool $obsolete
     * @return \StructType\ServicePlanOptionImpl
     */
    public function setObsolete($obsolete = null)
    {
        $this->obsolete = $obsolete;
        return $this;
    }
    /**
     * Get dependentDeal value
     * @return string|null
     */
    public function getDependentDeal()
    {
        return $this->dependentDeal;
    }
    /**
     * Set dependentDeal value
     * @param string $dependentDeal
     * @return \StructType\ServicePlanOptionImpl
     */
    public function setDependentDeal($dependentDeal = null)
    {
        // validation for constraint: string
        if (!is_null($dependentDeal) && !is_string($dependentDeal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dependentDeal)), __LINE__);
        }
        $this->dependentDeal = $dependentDeal;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ServicePlanOptionImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
