<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for servicePlans StructType
 * @subpackage Structs
 */
class ServicePlans extends AbstractStructBase
{
    /**
     * The servicePlan
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AbsServicePlanImpl[]
     */
    public $servicePlan;
    /**
     * Constructor method for servicePlans
     * @uses ServicePlans::setServicePlan()
     * @param \StructType\AbsServicePlanImpl[] $servicePlan
     */
    public function __construct(array $servicePlan = array())
    {
        $this
            ->setServicePlan($servicePlan);
    }
    /**
     * Get servicePlan value
     * @return \StructType\AbsServicePlanImpl[]|null
     */
    public function getServicePlan()
    {
        return $this->servicePlan;
    }
    /**
     * Set servicePlan value
     * @throws \InvalidArgumentException
     * @param \StructType\AbsServicePlanImpl[] $servicePlan
     * @return \StructType\ServicePlans
     */
    public function setServicePlan(array $servicePlan = array())
    {
        foreach ($servicePlan as $servicePlansServicePlanItem) {
            // validation for constraint: itemType
            if (!$servicePlansServicePlanItem instanceof \StructType\AbsServicePlanImpl) {
                throw new \InvalidArgumentException(sprintf('The servicePlan property can only contain items of \StructType\AbsServicePlanImpl, "%s" given', is_object($servicePlansServicePlanItem) ? get_class($servicePlansServicePlanItem) : gettype($servicePlansServicePlanItem)), __LINE__);
            }
        }
        $this->servicePlan = $servicePlan;
        return $this;
    }
    /**
     * Add item to servicePlan value
     * @throws \InvalidArgumentException
     * @param \StructType\AbsServicePlanImpl $item
     * @return \StructType\ServicePlans
     */
    public function addToServicePlan(\StructType\AbsServicePlanImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AbsServicePlanImpl) {
            throw new \InvalidArgumentException(sprintf('The servicePlan property can only contain items of \StructType\AbsServicePlanImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->servicePlan[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ServicePlans
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
