<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for subscribeBurstServiceRequestImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:subscribeBurstServiceRequestImpl
 * @subpackage Structs
 */
class SubscribeBurstServiceRequestImpl extends AuthenticatedIwsRequestImpl
{
    /**
     * The imei
     * @var string
     */
    public $imei;
    /**
     * The serviceName
     * @var string
     */
    public $serviceName;
    /**
     * The GDA
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $GDA;
    /**
     * The BCA
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $BCA;
    /**
     * The otaFlag
     * @var string
     */
    public $otaFlag;
    /**
     * The expirationDate
     * @var string
     */
    public $expirationDate;
    /**
     * Constructor method for subscribeBurstServiceRequestImpl
     * @uses SubscribeBurstServiceRequestImpl::setImei()
     * @uses SubscribeBurstServiceRequestImpl::setServiceName()
     * @uses SubscribeBurstServiceRequestImpl::setGDA()
     * @uses SubscribeBurstServiceRequestImpl::setBCA()
     * @uses SubscribeBurstServiceRequestImpl::setOtaFlag()
     * @uses SubscribeBurstServiceRequestImpl::setExpirationDate()
     * @param string $imei
     * @param string $serviceName
     * @param string $gDA
     * @param string $bCA
     * @param string $otaFlag
     * @param string $expirationDate
     */
    public function __construct($imei = null, $serviceName = null, $gDA = null, $bCA = null, $otaFlag = null, $expirationDate = null)
    {
        $this
            ->setImei($imei)
            ->setServiceName($serviceName)
            ->setGDA($gDA)
            ->setBCA($bCA)
            ->setOtaFlag($otaFlag)
            ->setExpirationDate($expirationDate);
    }
    /**
     * Get imei value
     * @return string|null
     */
    public function getImei()
    {
        return $this->imei;
    }
    /**
     * Set imei value
     * @param string $imei
     * @return \StructType\SubscribeBurstServiceRequestImpl
     */
    public function setImei($imei = null)
    {
        // validation for constraint: string
        if (!is_null($imei) && !is_string($imei)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($imei)), __LINE__);
        }
        $this->imei = $imei;
        return $this;
    }
    /**
     * Get serviceName value
     * @return string|null
     */
    public function getServiceName()
    {
        return $this->serviceName;
    }
    /**
     * Set serviceName value
     * @param string $serviceName
     * @return \StructType\SubscribeBurstServiceRequestImpl
     */
    public function setServiceName($serviceName = null)
    {
        // validation for constraint: string
        if (!is_null($serviceName) && !is_string($serviceName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($serviceName)), __LINE__);
        }
        $this->serviceName = $serviceName;
        return $this;
    }
    /**
     * Get GDA value
     * @return string|null
     */
    public function getGDA()
    {
        return $this->GDA;
    }
    /**
     * Set GDA value
     * @param string $gDA
     * @return \StructType\SubscribeBurstServiceRequestImpl
     */
    public function setGDA($gDA = null)
    {
        // validation for constraint: string
        if (!is_null($gDA) && !is_string($gDA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($gDA)), __LINE__);
        }
        $this->GDA = $gDA;
        return $this;
    }
    /**
     * Get BCA value
     * @return string|null
     */
    public function getBCA()
    {
        return $this->BCA;
    }
    /**
     * Set BCA value
     * @param string $bCA
     * @return \StructType\SubscribeBurstServiceRequestImpl
     */
    public function setBCA($bCA = null)
    {
        // validation for constraint: string
        if (!is_null($bCA) && !is_string($bCA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($bCA)), __LINE__);
        }
        $this->BCA = $bCA;
        return $this;
    }
    /**
     * Get otaFlag value
     * @return string|null
     */
    public function getOtaFlag()
    {
        return $this->otaFlag;
    }
    /**
     * Set otaFlag value
     * @param string $otaFlag
     * @return \StructType\SubscribeBurstServiceRequestImpl
     */
    public function setOtaFlag($otaFlag = null)
    {
        // validation for constraint: string
        if (!is_null($otaFlag) && !is_string($otaFlag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($otaFlag)), __LINE__);
        }
        $this->otaFlag = $otaFlag;
        return $this;
    }
    /**
     * Get expirationDate value
     * @return string|null
     */
    public function getExpirationDate()
    {
        return $this->expirationDate;
    }
    /**
     * Set expirationDate value
     * @param string $expirationDate
     * @return \StructType\SubscribeBurstServiceRequestImpl
     */
    public function setExpirationDate($expirationDate = null)
    {
        // validation for constraint: string
        if (!is_null($expirationDate) && !is_string($expirationDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($expirationDate)), __LINE__);
        }
        $this->expirationDate = $expirationDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SubscribeBurstServiceRequestImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
