<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for subscriberAccountSearchResultsImpl StructType
 * @subpackage Structs
 */
class SubscriberAccountSearchResultsImpl extends AbstractStructBase
{
    /**
     * The subscriberAccounts
     * @var \StructType\SubscriberAccounts
     */
    public $subscriberAccounts;
    /**
     * The configuredResultLimit
     * @var int
     */
    public $configuredResultLimit;
    /**
     * The totalResultCount
     * @var int
     */
    public $totalResultCount;
    /**
     * Constructor method for subscriberAccountSearchResultsImpl
     * @uses SubscriberAccountSearchResultsImpl::setSubscriberAccounts()
     * @uses SubscriberAccountSearchResultsImpl::setConfiguredResultLimit()
     * @uses SubscriberAccountSearchResultsImpl::setTotalResultCount()
     * @param \StructType\SubscriberAccounts $subscriberAccounts
     * @param int $configuredResultLimit
     * @param int $totalResultCount
     */
    public function __construct(\StructType\SubscriberAccounts $subscriberAccounts = null, $configuredResultLimit = null, $totalResultCount = null)
    {
        $this
            ->setSubscriberAccounts($subscriberAccounts)
            ->setConfiguredResultLimit($configuredResultLimit)
            ->setTotalResultCount($totalResultCount);
    }
    /**
     * Get subscriberAccounts value
     * @return \StructType\SubscriberAccounts|null
     */
    public function getSubscriberAccounts()
    {
        return $this->subscriberAccounts;
    }
    /**
     * Set subscriberAccounts value
     * @param \StructType\SubscriberAccounts $subscriberAccounts
     * @return \StructType\SubscriberAccountSearchResultsImpl
     */
    public function setSubscriberAccounts(\StructType\SubscriberAccounts $subscriberAccounts = null)
    {
        $this->subscriberAccounts = $subscriberAccounts;
        return $this;
    }
    /**
     * Get configuredResultLimit value
     * @return int|null
     */
    public function getConfiguredResultLimit()
    {
        return $this->configuredResultLimit;
    }
    /**
     * Set configuredResultLimit value
     * @param int $configuredResultLimit
     * @return \StructType\SubscriberAccountSearchResultsImpl
     */
    public function setConfiguredResultLimit($configuredResultLimit = null)
    {
        // validation for constraint: int
        if (!is_null($configuredResultLimit) && !is_numeric($configuredResultLimit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($configuredResultLimit)), __LINE__);
        }
        $this->configuredResultLimit = $configuredResultLimit;
        return $this;
    }
    /**
     * Get totalResultCount value
     * @return int|null
     */
    public function getTotalResultCount()
    {
        return $this->totalResultCount;
    }
    /**
     * Set totalResultCount value
     * @param int $totalResultCount
     * @return \StructType\SubscriberAccountSearchResultsImpl
     */
    public function setTotalResultCount($totalResultCount = null)
    {
        // validation for constraint: int
        if (!is_null($totalResultCount) && !is_numeric($totalResultCount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($totalResultCount)), __LINE__);
        }
        $this->totalResultCount = $totalResultCount;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SubscriberAccountSearchResultsImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
