<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for subscriberAccounts StructType
 * @subpackage Structs
 */
class SubscriberAccounts extends AbstractStructBase
{
    /**
     * The subscriberAccount
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SubscriberAccountEntryImpl[]
     */
    public $subscriberAccount;
    /**
     * Constructor method for subscriberAccounts
     * @uses SubscriberAccounts::setSubscriberAccount()
     * @param \StructType\SubscriberAccountEntryImpl[] $subscriberAccount
     */
    public function __construct(array $subscriberAccount = array())
    {
        $this
            ->setSubscriberAccount($subscriberAccount);
    }
    /**
     * Get subscriberAccount value
     * @return \StructType\SubscriberAccountEntryImpl[]|null
     */
    public function getSubscriberAccount()
    {
        return $this->subscriberAccount;
    }
    /**
     * Set subscriberAccount value
     * @throws \InvalidArgumentException
     * @param \StructType\SubscriberAccountEntryImpl[] $subscriberAccount
     * @return \StructType\SubscriberAccounts
     */
    public function setSubscriberAccount(array $subscriberAccount = array())
    {
        foreach ($subscriberAccount as $subscriberAccountsSubscriberAccountItem) {
            // validation for constraint: itemType
            if (!$subscriberAccountsSubscriberAccountItem instanceof \StructType\SubscriberAccountEntryImpl) {
                throw new \InvalidArgumentException(sprintf('The subscriberAccount property can only contain items of \StructType\SubscriberAccountEntryImpl, "%s" given', is_object($subscriberAccountsSubscriberAccountItem) ? get_class($subscriberAccountsSubscriberAccountItem) : gettype($subscriberAccountsSubscriberAccountItem)), __LINE__);
            }
        }
        $this->subscriberAccount = $subscriberAccount;
        return $this;
    }
    /**
     * Add item to subscriberAccount value
     * @throws \InvalidArgumentException
     * @param \StructType\SubscriberAccountEntryImpl $item
     * @return \StructType\SubscriberAccounts
     */
    public function addToSubscriberAccount(\StructType\SubscriberAccountEntryImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SubscriberAccountEntryImpl) {
            throw new \InvalidArgumentException(sprintf('The subscriberAccount property can only contain items of \StructType\SubscriberAccountEntryImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->subscriberAccount[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SubscriberAccounts
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
