<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for subscriberOrganizationImpl StructType
 * @subpackage Structs
 */
class SubscriberOrganizationImpl extends AbstractStructBase
{
    /**
     * The id
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $id;
    /**
     * The refId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $refId;
    /**
     * The submarketId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $submarketId;
    /**
     * The organizationName
     * @var string
     */
    public $organizationName;
    /**
     * The description
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The status
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $status;
    /**
     * The createDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $createDate;
    /**
     * Constructor method for subscriberOrganizationImpl
     * @uses SubscriberOrganizationImpl::setId()
     * @uses SubscriberOrganizationImpl::setRefId()
     * @uses SubscriberOrganizationImpl::setSubmarketId()
     * @uses SubscriberOrganizationImpl::setOrganizationName()
     * @uses SubscriberOrganizationImpl::setDescription()
     * @uses SubscriberOrganizationImpl::setStatus()
     * @uses SubscriberOrganizationImpl::setCreateDate()
     * @param string $id
     * @param string $refId
     * @param string $submarketId
     * @param string $organizationName
     * @param string $description
     * @param string $status
     * @param string $createDate
     */
    public function __construct($id = null, $refId = null, $submarketId = null, $organizationName = null, $description = null, $status = null, $createDate = null)
    {
        $this
            ->setId($id)
            ->setRefId($refId)
            ->setSubmarketId($submarketId)
            ->setOrganizationName($organizationName)
            ->setDescription($description)
            ->setStatus($status)
            ->setCreateDate($createDate);
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\SubscriberOrganizationImpl
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get refId value
     * @return string|null
     */
    public function getRefId()
    {
        return $this->refId;
    }
    /**
     * Set refId value
     * @param string $refId
     * @return \StructType\SubscriberOrganizationImpl
     */
    public function setRefId($refId = null)
    {
        // validation for constraint: string
        if (!is_null($refId) && !is_string($refId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($refId)), __LINE__);
        }
        $this->refId = $refId;
        return $this;
    }
    /**
     * Get submarketId value
     * @return string|null
     */
    public function getSubmarketId()
    {
        return $this->submarketId;
    }
    /**
     * Set submarketId value
     * @param string $submarketId
     * @return \StructType\SubscriberOrganizationImpl
     */
    public function setSubmarketId($submarketId = null)
    {
        // validation for constraint: string
        if (!is_null($submarketId) && !is_string($submarketId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($submarketId)), __LINE__);
        }
        $this->submarketId = $submarketId;
        return $this;
    }
    /**
     * Get organizationName value
     * @return string|null
     */
    public function getOrganizationName()
    {
        return $this->organizationName;
    }
    /**
     * Set organizationName value
     * @param string $organizationName
     * @return \StructType\SubscriberOrganizationImpl
     */
    public function setOrganizationName($organizationName = null)
    {
        // validation for constraint: string
        if (!is_null($organizationName) && !is_string($organizationName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($organizationName)), __LINE__);
        }
        $this->organizationName = $organizationName;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\SubscriberOrganizationImpl
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @uses \EnumType\StatusEnum::valueIsValid()
     * @uses \EnumType\StatusEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $status
     * @return \StructType\SubscriberOrganizationImpl
     */
    public function setStatus($status = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\StatusEnum::valueIsValid($status)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $status, implode(', ', \EnumType\StatusEnum::getValidValues())), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get createDate value
     * @return string|null
     */
    public function getCreateDate()
    {
        return $this->createDate;
    }
    /**
     * Set createDate value
     * @param string $createDate
     * @return \StructType\SubscriberOrganizationImpl
     */
    public function setCreateDate($createDate = null)
    {
        // validation for constraint: string
        if (!is_null($createDate) && !is_string($createDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($createDate)), __LINE__);
        }
        $this->createDate = $createDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SubscriberOrganizationImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
