<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for subscriberOrganizations StructType
 * @subpackage Structs
 */
class SubscriberOrganizations extends AbstractStructBase
{
    /**
     * The subscriberOrganization
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\SubscriberOrganizationImpl[]
     */
    public $subscriberOrganization;
    /**
     * Constructor method for subscriberOrganizations
     * @uses SubscriberOrganizations::setSubscriberOrganization()
     * @param \StructType\SubscriberOrganizationImpl[] $subscriberOrganization
     */
    public function __construct(array $subscriberOrganization = array())
    {
        $this
            ->setSubscriberOrganization($subscriberOrganization);
    }
    /**
     * Get subscriberOrganization value
     * @return \StructType\SubscriberOrganizationImpl[]|null
     */
    public function getSubscriberOrganization()
    {
        return $this->subscriberOrganization;
    }
    /**
     * Set subscriberOrganization value
     * @throws \InvalidArgumentException
     * @param \StructType\SubscriberOrganizationImpl[] $subscriberOrganization
     * @return \StructType\SubscriberOrganizations
     */
    public function setSubscriberOrganization(array $subscriberOrganization = array())
    {
        foreach ($subscriberOrganization as $subscriberOrganizationsSubscriberOrganizationItem) {
            // validation for constraint: itemType
            if (!$subscriberOrganizationsSubscriberOrganizationItem instanceof \StructType\SubscriberOrganizationImpl) {
                throw new \InvalidArgumentException(sprintf('The subscriberOrganization property can only contain items of \StructType\SubscriberOrganizationImpl, "%s" given', is_object($subscriberOrganizationsSubscriberOrganizationItem) ? get_class($subscriberOrganizationsSubscriberOrganizationItem) : gettype($subscriberOrganizationsSubscriberOrganizationItem)), __LINE__);
            }
        }
        $this->subscriberOrganization = $subscriberOrganization;
        return $this;
    }
    /**
     * Add item to subscriberOrganization value
     * @throws \InvalidArgumentException
     * @param \StructType\SubscriberOrganizationImpl $item
     * @return \StructType\SubscriberOrganizations
     */
    public function addToSubscriberOrganization(\StructType\SubscriberOrganizationImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SubscriberOrganizationImpl) {
            throw new \InvalidArgumentException(sprintf('The subscriberOrganization property can only contain items of \StructType\SubscriberOrganizationImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->subscriberOrganization[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SubscriberOrganizations
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
