<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for systemStatusImpl StructType
 * @subpackage Structs
 */
class SystemStatusImpl extends AbstractStructBase
{
    /**
     * The cbrmTime
     * @var string
     */
    public $cbrmTime;
    /**
     * The openForBusiness
     * Meta informations extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $openForBusiness;
    /**
     * The maintenanceOccurring
     * @var bool
     */
    public $maintenanceOccurring;
    /**
     * The outageReason
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $outageReason;
    /**
     * The iwsVersion
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $iwsVersion;
    /**
     * The wsdlRevision
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $wsdlRevision;
    /**
     * The obsolete
     * @var bool
     */
    public $obsolete;
    /**
     * The outageScheduleItems
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OutageScheduleItems
     */
    public $outageScheduleItems;
    /**
     * Constructor method for systemStatusImpl
     * @uses SystemStatusImpl::setCbrmTime()
     * @uses SystemStatusImpl::setOpenForBusiness()
     * @uses SystemStatusImpl::setMaintenanceOccurring()
     * @uses SystemStatusImpl::setOutageReason()
     * @uses SystemStatusImpl::setIwsVersion()
     * @uses SystemStatusImpl::setWsdlRevision()
     * @uses SystemStatusImpl::setObsolete()
     * @uses SystemStatusImpl::setOutageScheduleItems()
     * @param string $cbrmTime
     * @param bool $openForBusiness
     * @param bool $maintenanceOccurring
     * @param string $outageReason
     * @param string $iwsVersion
     * @param string $wsdlRevision
     * @param bool $obsolete
     * @param \StructType\OutageScheduleItems $outageScheduleItems
     */
    public function __construct($cbrmTime = null, $openForBusiness = true, $maintenanceOccurring = null, $outageReason = null, $iwsVersion = null, $wsdlRevision = null, $obsolete = null, \StructType\OutageScheduleItems $outageScheduleItems = null)
    {
        $this
            ->setCbrmTime($cbrmTime)
            ->setOpenForBusiness($openForBusiness)
            ->setMaintenanceOccurring($maintenanceOccurring)
            ->setOutageReason($outageReason)
            ->setIwsVersion($iwsVersion)
            ->setWsdlRevision($wsdlRevision)
            ->setObsolete($obsolete)
            ->setOutageScheduleItems($outageScheduleItems);
    }
    /**
     * Get cbrmTime value
     * @return string|null
     */
    public function getCbrmTime()
    {
        return $this->cbrmTime;
    }
    /**
     * Set cbrmTime value
     * @param string $cbrmTime
     * @return \StructType\SystemStatusImpl
     */
    public function setCbrmTime($cbrmTime = null)
    {
        // validation for constraint: string
        if (!is_null($cbrmTime) && !is_string($cbrmTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cbrmTime)), __LINE__);
        }
        $this->cbrmTime = $cbrmTime;
        return $this;
    }
    /**
     * Get openForBusiness value
     * @return bool|null
     */
    public function getOpenForBusiness()
    {
        return $this->openForBusiness;
    }
    /**
     * Set openForBusiness value
     * @param bool $openForBusiness
     * @return \StructType\SystemStatusImpl
     */
    public function setOpenForBusiness($openForBusiness = true)
    {
        $this->openForBusiness = $openForBusiness;
        return $this;
    }
    /**
     * Get maintenanceOccurring value
     * @return bool|null
     */
    public function getMaintenanceOccurring()
    {
        return $this->maintenanceOccurring;
    }
    /**
     * Set maintenanceOccurring value
     * @param bool $maintenanceOccurring
     * @return \StructType\SystemStatusImpl
     */
    public function setMaintenanceOccurring($maintenanceOccurring = null)
    {
        $this->maintenanceOccurring = $maintenanceOccurring;
        return $this;
    }
    /**
     * Get outageReason value
     * @return string|null
     */
    public function getOutageReason()
    {
        return $this->outageReason;
    }
    /**
     * Set outageReason value
     * @param string $outageReason
     * @return \StructType\SystemStatusImpl
     */
    public function setOutageReason($outageReason = null)
    {
        // validation for constraint: string
        if (!is_null($outageReason) && !is_string($outageReason)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($outageReason)), __LINE__);
        }
        $this->outageReason = $outageReason;
        return $this;
    }
    /**
     * Get iwsVersion value
     * @return string|null
     */
    public function getIwsVersion()
    {
        return $this->iwsVersion;
    }
    /**
     * Set iwsVersion value
     * @param string $iwsVersion
     * @return \StructType\SystemStatusImpl
     */
    public function setIwsVersion($iwsVersion = null)
    {
        // validation for constraint: string
        if (!is_null($iwsVersion) && !is_string($iwsVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($iwsVersion)), __LINE__);
        }
        $this->iwsVersion = $iwsVersion;
        return $this;
    }
    /**
     * Get wsdlRevision value
     * @return string|null
     */
    public function getWsdlRevision()
    {
        return $this->wsdlRevision;
    }
    /**
     * Set wsdlRevision value
     * @param string $wsdlRevision
     * @return \StructType\SystemStatusImpl
     */
    public function setWsdlRevision($wsdlRevision = null)
    {
        // validation for constraint: string
        if (!is_null($wsdlRevision) && !is_string($wsdlRevision)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($wsdlRevision)), __LINE__);
        }
        $this->wsdlRevision = $wsdlRevision;
        return $this;
    }
    /**
     * Get obsolete value
     * @return bool|null
     */
    public function getObsolete()
    {
        return $this->obsolete;
    }
    /**
     * Set obsolete value
     * @param bool $obsolete
     * @return \StructType\SystemStatusImpl
     */
    public function setObsolete($obsolete = null)
    {
        $this->obsolete = $obsolete;
        return $this;
    }
    /**
     * Get outageScheduleItems value
     * @return \StructType\OutageScheduleItems|null
     */
    public function getOutageScheduleItems()
    {
        return $this->outageScheduleItems;
    }
    /**
     * Set outageScheduleItems value
     * @param \StructType\OutageScheduleItems $outageScheduleItems
     * @return \StructType\SystemStatusImpl
     */
    public function setOutageScheduleItems(\StructType\OutageScheduleItems $outageScheduleItems = null)
    {
        $this->outageScheduleItems = $outageScheduleItems;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SystemStatusImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
