<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for telephonyBulkPlanUpdateImpl StructType
 * @subpackage Structs
 */
class TelephonyBulkPlanUpdateImpl extends AbstractStructBase
{
    /**
     * The currentServicePlan
     * @var \StructType\TelephonyBulkBaseImpl
     */
    public $currentServicePlan;
    /**
     * The updateServicePlan
     * @var \StructType\TelephonyBulkPlanImpl
     */
    public $updateServicePlan;
    /**
     * The telephonyBulkDetails
     * @var \StructType\TelephonyBulkDetails
     */
    public $telephonyBulkDetails;
    /**
     * Constructor method for telephonyBulkPlanUpdateImpl
     * @uses TelephonyBulkPlanUpdateImpl::setCurrentServicePlan()
     * @uses TelephonyBulkPlanUpdateImpl::setUpdateServicePlan()
     * @uses TelephonyBulkPlanUpdateImpl::setTelephonyBulkDetails()
     * @param \StructType\TelephonyBulkBaseImpl $currentServicePlan
     * @param \StructType\TelephonyBulkPlanImpl $updateServicePlan
     * @param \StructType\TelephonyBulkDetails $telephonyBulkDetails
     */
    public function __construct(\StructType\TelephonyBulkBaseImpl $currentServicePlan = null, \StructType\TelephonyBulkPlanImpl $updateServicePlan = null, \StructType\TelephonyBulkDetails $telephonyBulkDetails = null)
    {
        $this
            ->setCurrentServicePlan($currentServicePlan)
            ->setUpdateServicePlan($updateServicePlan)
            ->setTelephonyBulkDetails($telephonyBulkDetails);
    }
    /**
     * Get currentServicePlan value
     * @return \StructType\TelephonyBulkBaseImpl|null
     */
    public function getCurrentServicePlan()
    {
        return $this->currentServicePlan;
    }
    /**
     * Set currentServicePlan value
     * @param \StructType\TelephonyBulkBaseImpl $currentServicePlan
     * @return \StructType\TelephonyBulkPlanUpdateImpl
     */
    public function setCurrentServicePlan(\StructType\TelephonyBulkBaseImpl $currentServicePlan = null)
    {
        $this->currentServicePlan = $currentServicePlan;
        return $this;
    }
    /**
     * Get updateServicePlan value
     * @return \StructType\TelephonyBulkPlanImpl|null
     */
    public function getUpdateServicePlan()
    {
        return $this->updateServicePlan;
    }
    /**
     * Set updateServicePlan value
     * @param \StructType\TelephonyBulkPlanImpl $updateServicePlan
     * @return \StructType\TelephonyBulkPlanUpdateImpl
     */
    public function setUpdateServicePlan(\StructType\TelephonyBulkPlanImpl $updateServicePlan = null)
    {
        $this->updateServicePlan = $updateServicePlan;
        return $this;
    }
    /**
     * Get telephonyBulkDetails value
     * @return \StructType\TelephonyBulkDetails|null
     */
    public function getTelephonyBulkDetails()
    {
        return $this->telephonyBulkDetails;
    }
    /**
     * Set telephonyBulkDetails value
     * @param \StructType\TelephonyBulkDetails $telephonyBulkDetails
     * @return \StructType\TelephonyBulkPlanUpdateImpl
     */
    public function setTelephonyBulkDetails(\StructType\TelephonyBulkDetails $telephonyBulkDetails = null)
    {
        $this->telephonyBulkDetails = $telephonyBulkDetails;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TelephonyBulkPlanUpdateImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
