<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for telephonySubscriberAccountBaseImpl StructType
 * @subpackage Structs
 */
class TelephonySubscriberAccountBaseImpl extends AbsSubscriberAccountImpl
{
    /**
     * The commitmentStart
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $commitmentStart;
    /**
     * The commitmentEnd
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $commitmentEnd;
    /**
     * The plan
     * @var \StructType\TelephonyPlanImpl
     */
    public $plan;
    /**
     * The sim
     * @var \StructType\DeviceSimImpl
     */
    public $sim;
    /**
     * The imei
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $imei;
    /**
     * The msisdn
     * @var \StructType\DeviceNumberImpl
     */
    public $msisdn;
    /**
     * The msisdnb
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DeviceNumberImpl
     */
    public $msisdnb;
    /**
     * The msisdnc
     * @var \StructType\DeviceNumberImpl
     */
    public $msisdnc;
    /**
     * The enableLocalNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $enableLocalNumber;
    /**
     * The localCountry
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $localCountry;
    /**
     * The plusNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DeviceNumberImpl
     */
    public $plusNumber;
    /**
     * The bulkAction
     * Meta informations extracted from the WSDL
     * - default: false
     * @var bool
     */
    public $bulkAction;
    /**
     * The telephonyBulkDetails
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TelephonyBulkDetails
     */
    public $telephonyBulkDetails;
    /**
     * The subscriberAccountMetadata
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TelephonySubscriberAccountMetadataImpl
     */
    public $subscriberAccountMetadata;
    /**
     * The twoStageVoice
     * @var \StructType\TwoStageImpl
     */
    public $twoStageVoice;
    /**
     * The twoStageData
     * @var \StructType\TwoStageImpl
     */
    public $twoStageData;
    /**
     * Constructor method for telephonySubscriberAccountBaseImpl
     * @uses TelephonySubscriberAccountBaseImpl::setCommitmentStart()
     * @uses TelephonySubscriberAccountBaseImpl::setCommitmentEnd()
     * @uses TelephonySubscriberAccountBaseImpl::setPlan()
     * @uses TelephonySubscriberAccountBaseImpl::setSim()
     * @uses TelephonySubscriberAccountBaseImpl::setImei()
     * @uses TelephonySubscriberAccountBaseImpl::setMsisdn()
     * @uses TelephonySubscriberAccountBaseImpl::setMsisdnb()
     * @uses TelephonySubscriberAccountBaseImpl::setMsisdnc()
     * @uses TelephonySubscriberAccountBaseImpl::setEnableLocalNumber()
     * @uses TelephonySubscriberAccountBaseImpl::setLocalCountry()
     * @uses TelephonySubscriberAccountBaseImpl::setPlusNumber()
     * @uses TelephonySubscriberAccountBaseImpl::setBulkAction()
     * @uses TelephonySubscriberAccountBaseImpl::setTelephonyBulkDetails()
     * @uses TelephonySubscriberAccountBaseImpl::setSubscriberAccountMetadata()
     * @uses TelephonySubscriberAccountBaseImpl::setTwoStageVoice()
     * @uses TelephonySubscriberAccountBaseImpl::setTwoStageData()
     * @param string $commitmentStart
     * @param string $commitmentEnd
     * @param \StructType\TelephonyPlanImpl $plan
     * @param \StructType\DeviceSimImpl $sim
     * @param string $imei
     * @param \StructType\DeviceNumberImpl $msisdn
     * @param \StructType\DeviceNumberImpl $msisdnb
     * @param \StructType\DeviceNumberImpl $msisdnc
     * @param string $enableLocalNumber
     * @param string $localCountry
     * @param \StructType\DeviceNumberImpl $plusNumber
     * @param bool $bulkAction
     * @param \StructType\TelephonyBulkDetails $telephonyBulkDetails
     * @param \StructType\TelephonySubscriberAccountMetadataImpl $subscriberAccountMetadata
     * @param \StructType\TwoStageImpl $twoStageVoice
     * @param \StructType\TwoStageImpl $twoStageData
     */
    public function __construct($commitmentStart = null, $commitmentEnd = null, \StructType\TelephonyPlanImpl $plan = null, \StructType\DeviceSimImpl $sim = null, $imei = null, \StructType\DeviceNumberImpl $msisdn = null, \StructType\DeviceNumberImpl $msisdnb = null, \StructType\DeviceNumberImpl $msisdnc = null, $enableLocalNumber = null, $localCountry = null, \StructType\DeviceNumberImpl $plusNumber = null, $bulkAction = false, \StructType\TelephonyBulkDetails $telephonyBulkDetails = null, \StructType\TelephonySubscriberAccountMetadataImpl $subscriberAccountMetadata = null, \StructType\TwoStageImpl $twoStageVoice = null, \StructType\TwoStageImpl $twoStageData = null)
    {
        $this
            ->setCommitmentStart($commitmentStart)
            ->setCommitmentEnd($commitmentEnd)
            ->setPlan($plan)
            ->setSim($sim)
            ->setImei($imei)
            ->setMsisdn($msisdn)
            ->setMsisdnb($msisdnb)
            ->setMsisdnc($msisdnc)
            ->setEnableLocalNumber($enableLocalNumber)
            ->setLocalCountry($localCountry)
            ->setPlusNumber($plusNumber)
            ->setBulkAction($bulkAction)
            ->setTelephonyBulkDetails($telephonyBulkDetails)
            ->setSubscriberAccountMetadata($subscriberAccountMetadata)
            ->setTwoStageVoice($twoStageVoice)
            ->setTwoStageData($twoStageData);
    }
    /**
     * Get commitmentStart value
     * @return string|null
     */
    public function getCommitmentStart()
    {
        return $this->commitmentStart;
    }
    /**
     * Set commitmentStart value
     * @param string $commitmentStart
     * @return \StructType\TelephonySubscriberAccountBaseImpl
     */
    public function setCommitmentStart($commitmentStart = null)
    {
        // validation for constraint: string
        if (!is_null($commitmentStart) && !is_string($commitmentStart)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($commitmentStart)), __LINE__);
        }
        $this->commitmentStart = $commitmentStart;
        return $this;
    }
    /**
     * Get commitmentEnd value
     * @return string|null
     */
    public function getCommitmentEnd()
    {
        return $this->commitmentEnd;
    }
    /**
     * Set commitmentEnd value
     * @param string $commitmentEnd
     * @return \StructType\TelephonySubscriberAccountBaseImpl
     */
    public function setCommitmentEnd($commitmentEnd = null)
    {
        // validation for constraint: string
        if (!is_null($commitmentEnd) && !is_string($commitmentEnd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($commitmentEnd)), __LINE__);
        }
        $this->commitmentEnd = $commitmentEnd;
        return $this;
    }
    /**
     * Get plan value
     * @return \StructType\TelephonyPlanImpl|null
     */
    public function getPlan()
    {
        return $this->plan;
    }
    /**
     * Set plan value
     * @param \StructType\TelephonyPlanImpl $plan
     * @return \StructType\TelephonySubscriberAccountBaseImpl
     */
    public function setPlan(\StructType\TelephonyPlanImpl $plan = null)
    {
        $this->plan = $plan;
        return $this;
    }
    /**
     * Get sim value
     * @return \StructType\DeviceSimImpl|null
     */
    public function getSim()
    {
        return $this->sim;
    }
    /**
     * Set sim value
     * @param \StructType\DeviceSimImpl $sim
     * @return \StructType\TelephonySubscriberAccountBaseImpl
     */
    public function setSim(\StructType\DeviceSimImpl $sim = null)
    {
        $this->sim = $sim;
        return $this;
    }
    /**
     * Get imei value
     * @return string|null
     */
    public function getImei()
    {
        return $this->imei;
    }
    /**
     * Set imei value
     * @param string $imei
     * @return \StructType\TelephonySubscriberAccountBaseImpl
     */
    public function setImei($imei = null)
    {
        // validation for constraint: string
        if (!is_null($imei) && !is_string($imei)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($imei)), __LINE__);
        }
        $this->imei = $imei;
        return $this;
    }
    /**
     * Get msisdn value
     * @return \StructType\DeviceNumberImpl|null
     */
    public function getMsisdn()
    {
        return $this->msisdn;
    }
    /**
     * Set msisdn value
     * @param \StructType\DeviceNumberImpl $msisdn
     * @return \StructType\TelephonySubscriberAccountBaseImpl
     */
    public function setMsisdn(\StructType\DeviceNumberImpl $msisdn = null)
    {
        $this->msisdn = $msisdn;
        return $this;
    }
    /**
     * Get msisdnb value
     * @return \StructType\DeviceNumberImpl|null
     */
    public function getMsisdnb()
    {
        return $this->msisdnb;
    }
    /**
     * Set msisdnb value
     * @param \StructType\DeviceNumberImpl $msisdnb
     * @return \StructType\TelephonySubscriberAccountBaseImpl
     */
    public function setMsisdnb(\StructType\DeviceNumberImpl $msisdnb = null)
    {
        $this->msisdnb = $msisdnb;
        return $this;
    }
    /**
     * Get msisdnc value
     * @return \StructType\DeviceNumberImpl|null
     */
    public function getMsisdnc()
    {
        return $this->msisdnc;
    }
    /**
     * Set msisdnc value
     * @param \StructType\DeviceNumberImpl $msisdnc
     * @return \StructType\TelephonySubscriberAccountBaseImpl
     */
    public function setMsisdnc(\StructType\DeviceNumberImpl $msisdnc = null)
    {
        $this->msisdnc = $msisdnc;
        return $this;
    }
    /**
     * Get enableLocalNumber value
     * @return string|null
     */
    public function getEnableLocalNumber()
    {
        return $this->enableLocalNumber;
    }
    /**
     * Set enableLocalNumber value
     * @param string $enableLocalNumber
     * @return \StructType\TelephonySubscriberAccountBaseImpl
     */
    public function setEnableLocalNumber($enableLocalNumber = null)
    {
        // validation for constraint: string
        if (!is_null($enableLocalNumber) && !is_string($enableLocalNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($enableLocalNumber)), __LINE__);
        }
        $this->enableLocalNumber = $enableLocalNumber;
        return $this;
    }
    /**
     * Get localCountry value
     * @return string|null
     */
    public function getLocalCountry()
    {
        return $this->localCountry;
    }
    /**
     * Set localCountry value
     * @param string $localCountry
     * @return \StructType\TelephonySubscriberAccountBaseImpl
     */
    public function setLocalCountry($localCountry = null)
    {
        // validation for constraint: string
        if (!is_null($localCountry) && !is_string($localCountry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($localCountry)), __LINE__);
        }
        $this->localCountry = $localCountry;
        return $this;
    }
    /**
     * Get plusNumber value
     * @return \StructType\DeviceNumberImpl|null
     */
    public function getPlusNumber()
    {
        return $this->plusNumber;
    }
    /**
     * Set plusNumber value
     * @param \StructType\DeviceNumberImpl $plusNumber
     * @return \StructType\TelephonySubscriberAccountBaseImpl
     */
    public function setPlusNumber(\StructType\DeviceNumberImpl $plusNumber = null)
    {
        $this->plusNumber = $plusNumber;
        return $this;
    }
    /**
     * Get bulkAction value
     * @return bool|null
     */
    public function getBulkAction()
    {
        return $this->bulkAction;
    }
    /**
     * Set bulkAction value
     * @param bool $bulkAction
     * @return \StructType\TelephonySubscriberAccountBaseImpl
     */
    public function setBulkAction($bulkAction = false)
    {
        $this->bulkAction = $bulkAction;
        return $this;
    }
    /**
     * Get telephonyBulkDetails value
     * @return \StructType\TelephonyBulkDetails|null
     */
    public function getTelephonyBulkDetails()
    {
        return $this->telephonyBulkDetails;
    }
    /**
     * Set telephonyBulkDetails value
     * @param \StructType\TelephonyBulkDetails $telephonyBulkDetails
     * @return \StructType\TelephonySubscriberAccountBaseImpl
     */
    public function setTelephonyBulkDetails(\StructType\TelephonyBulkDetails $telephonyBulkDetails = null)
    {
        $this->telephonyBulkDetails = $telephonyBulkDetails;
        return $this;
    }
    /**
     * Get subscriberAccountMetadata value
     * @return \StructType\TelephonySubscriberAccountMetadataImpl|null
     */
    public function getSubscriberAccountMetadata()
    {
        return $this->subscriberAccountMetadata;
    }
    /**
     * Set subscriberAccountMetadata value
     * @param \StructType\TelephonySubscriberAccountMetadataImpl $subscriberAccountMetadata
     * @return \StructType\TelephonySubscriberAccountBaseImpl
     */
    public function setSubscriberAccountMetadata(\StructType\TelephonySubscriberAccountMetadataImpl $subscriberAccountMetadata = null)
    {
        $this->subscriberAccountMetadata = $subscriberAccountMetadata;
        return $this;
    }
    /**
     * Get twoStageVoice value
     * @return \StructType\TwoStageImpl|null
     */
    public function getTwoStageVoice()
    {
        return $this->twoStageVoice;
    }
    /**
     * Set twoStageVoice value
     * @param \StructType\TwoStageImpl $twoStageVoice
     * @return \StructType\TelephonySubscriberAccountBaseImpl
     */
    public function setTwoStageVoice(\StructType\TwoStageImpl $twoStageVoice = null)
    {
        $this->twoStageVoice = $twoStageVoice;
        return $this;
    }
    /**
     * Get twoStageData value
     * @return \StructType\TwoStageImpl|null
     */
    public function getTwoStageData()
    {
        return $this->twoStageData;
    }
    /**
     * Set twoStageData value
     * @param \StructType\TwoStageImpl $twoStageData
     * @return \StructType\TelephonySubscriberAccountBaseImpl
     */
    public function setTwoStageData(\StructType\TwoStageImpl $twoStageData = null)
    {
        $this->twoStageData = $twoStageData;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TelephonySubscriberAccountBaseImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
