<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for telephonySubscriberAccountImpl StructType
 * @subpackage Structs
 */
class TelephonySubscriberAccountImpl extends TelephonySubscriberAccountBaseImpl
{
    /**
     * The activatePrepaid
     * @var bool
     */
    public $activatePrepaid;
    /**
     * The prepaidPlan
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PrePaidPlanImpl
     */
    public $prepaidPlan;
    /**
     * The activateCrew
     * @var bool
     */
    public $activateCrew;
    /**
     * The crewPlan
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CrewPlanImpl
     */
    public $crewPlan;
    /**
     * Constructor method for telephonySubscriberAccountImpl
     * @uses TelephonySubscriberAccountImpl::setActivatePrepaid()
     * @uses TelephonySubscriberAccountImpl::setPrepaidPlan()
     * @uses TelephonySubscriberAccountImpl::setActivateCrew()
     * @uses TelephonySubscriberAccountImpl::setCrewPlan()
     * @param bool $activatePrepaid
     * @param \StructType\PrePaidPlanImpl $prepaidPlan
     * @param bool $activateCrew
     * @param \StructType\CrewPlanImpl $crewPlan
     */
    public function __construct($activatePrepaid = null, \StructType\PrePaidPlanImpl $prepaidPlan = null, $activateCrew = null, \StructType\CrewPlanImpl $crewPlan = null)
    {
        $this
            ->setActivatePrepaid($activatePrepaid)
            ->setPrepaidPlan($prepaidPlan)
            ->setActivateCrew($activateCrew)
            ->setCrewPlan($crewPlan);
    }
    /**
     * Get activatePrepaid value
     * @return bool|null
     */
    public function getActivatePrepaid()
    {
        return $this->activatePrepaid;
    }
    /**
     * Set activatePrepaid value
     * @param bool $activatePrepaid
     * @return \StructType\TelephonySubscriberAccountImpl
     */
    public function setActivatePrepaid($activatePrepaid = null)
    {
        $this->activatePrepaid = $activatePrepaid;
        return $this;
    }
    /**
     * Get prepaidPlan value
     * @return \StructType\PrePaidPlanImpl|null
     */
    public function getPrepaidPlan()
    {
        return $this->prepaidPlan;
    }
    /**
     * Set prepaidPlan value
     * @param \StructType\PrePaidPlanImpl $prepaidPlan
     * @return \StructType\TelephonySubscriberAccountImpl
     */
    public function setPrepaidPlan(\StructType\PrePaidPlanImpl $prepaidPlan = null)
    {
        $this->prepaidPlan = $prepaidPlan;
        return $this;
    }
    /**
     * Get activateCrew value
     * @return bool|null
     */
    public function getActivateCrew()
    {
        return $this->activateCrew;
    }
    /**
     * Set activateCrew value
     * @param bool $activateCrew
     * @return \StructType\TelephonySubscriberAccountImpl
     */
    public function setActivateCrew($activateCrew = null)
    {
        $this->activateCrew = $activateCrew;
        return $this;
    }
    /**
     * Get crewPlan value
     * @return \StructType\CrewPlanImpl|null
     */
    public function getCrewPlan()
    {
        return $this->crewPlan;
    }
    /**
     * Set crewPlan value
     * @param \StructType\CrewPlanImpl $crewPlan
     * @return \StructType\TelephonySubscriberAccountImpl
     */
    public function setCrewPlan(\StructType\CrewPlanImpl $crewPlan = null)
    {
        $this->crewPlan = $crewPlan;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TelephonySubscriberAccountImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
