<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for twoStageImpl StructType
 * @subpackage Structs
 */
class TwoStageImpl extends AbstractStructBase
{
    /**
     * The twoStageEnable
     * @var bool
     */
    public $twoStageEnable;
    /**
     * The twoStagePin
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $twoStagePin;
    /**
     * Constructor method for twoStageImpl
     * @uses TwoStageImpl::setTwoStageEnable()
     * @uses TwoStageImpl::setTwoStagePin()
     * @param bool $twoStageEnable
     * @param string $twoStagePin
     */
    public function __construct($twoStageEnable = null, $twoStagePin = null)
    {
        $this
            ->setTwoStageEnable($twoStageEnable)
            ->setTwoStagePin($twoStagePin);
    }
    /**
     * Get twoStageEnable value
     * @return bool|null
     */
    public function getTwoStageEnable()
    {
        return $this->twoStageEnable;
    }
    /**
     * Set twoStageEnable value
     * @param bool $twoStageEnable
     * @return \StructType\TwoStageImpl
     */
    public function setTwoStageEnable($twoStageEnable = null)
    {
        $this->twoStageEnable = $twoStageEnable;
        return $this;
    }
    /**
     * Get twoStagePin value
     * @return string|null
     */
    public function getTwoStagePin()
    {
        return $this->twoStagePin;
    }
    /**
     * Set twoStagePin value
     * @param string $twoStagePin
     * @return \StructType\TwoStageImpl
     */
    public function setTwoStagePin($twoStagePin = null)
    {
        // validation for constraint: string
        if (!is_null($twoStagePin) && !is_string($twoStagePin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($twoStagePin)), __LINE__);
        }
        $this->twoStagePin = $twoStagePin;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TwoStageImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
