<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for voiceLines StructType
 * @subpackage Structs
 */
class VoiceLines extends AbstractStructBase
{
    /**
     * The voiceLine
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\CertusDeviceNumberImpl[]
     */
    public $voiceLine;
    /**
     * Constructor method for voiceLines
     * @uses VoiceLines::setVoiceLine()
     * @param \StructType\CertusDeviceNumberImpl[] $voiceLine
     */
    public function __construct(array $voiceLine = array())
    {
        $this
            ->setVoiceLine($voiceLine);
    }
    /**
     * Get voiceLine value
     * @return \StructType\CertusDeviceNumberImpl[]|null
     */
    public function getVoiceLine()
    {
        return $this->voiceLine;
    }
    /**
     * Set voiceLine value
     * @throws \InvalidArgumentException
     * @param \StructType\CertusDeviceNumberImpl[] $voiceLine
     * @return \StructType\VoiceLines
     */
    public function setVoiceLine(array $voiceLine = array())
    {
        foreach ($voiceLine as $voiceLinesVoiceLineItem) {
            // validation for constraint: itemType
            if (!$voiceLinesVoiceLineItem instanceof \StructType\CertusDeviceNumberImpl) {
                throw new \InvalidArgumentException(sprintf('The voiceLine property can only contain items of \StructType\CertusDeviceNumberImpl, "%s" given', is_object($voiceLinesVoiceLineItem) ? get_class($voiceLinesVoiceLineItem) : gettype($voiceLinesVoiceLineItem)), __LINE__);
            }
        }
        $this->voiceLine = $voiceLine;
        return $this;
    }
    /**
     * Add item to voiceLine value
     * @throws \InvalidArgumentException
     * @param \StructType\CertusDeviceNumberImpl $item
     * @return \StructType\VoiceLines
     */
    public function addToVoiceLine(\StructType\CertusDeviceNumberImpl $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CertusDeviceNumberImpl) {
            throw new \InvalidArgumentException(sprintf('The voiceLine property can only contain items of \StructType\CertusDeviceNumberImpl, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->voiceLine[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VoiceLines
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
