<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for voucherActivityImpl StructType
 * @subpackage Structs
 */
class VoucherActivityImpl extends AbstractStructBase
{
    /**
     * The imsi
     * @var string
     */
    public $imsi;
    /**
     * The imei
     * @var string
     */
    public $imei;
    /**
     * The msisdn
     * @var string
     */
    public $msisdn;
    /**
     * The callDate
     * @var string
     */
    public $callDate;
    /**
     * The calledNumber
     * @var string
     */
    public $calledNumber;
    /**
     * The callDuration
     * @var int
     */
    public $callDuration;
    /**
     * The ratedUnits
     * @var int
     */
    public $ratedUnits;
    /**
     * The countryName
     * @var string
     */
    public $countryName;
    /**
     * The regionName
     * @var string
     */
    public $regionName;
    /**
     * The lac
     * @var string
     */
    public $lac;
    /**
     * The latMin
     * @var string
     */
    public $latMin;
    /**
     * The latPol
     * @var int
     */
    public $latPol;
    /**
     * The longMin
     * @var string
     */
    public $longMin;
    /**
     * The longPol
     * @var int
     */
    public $longPol;
    /**
     * The tZIndicator
     * @var int
     */
    public $tZIndicator;
    /**
     * The tZOffset
     * @var string
     */
    public $tZOffset;
    /**
     * The setAltitude
     * @var int
     */
    public $setAltitude;
    /**
     * The callingHC
     * @var int
     */
    public $callingHC;
    /**
     * The callingVC
     * @var int
     */
    public $callingVC;
    /**
     * The releaseCause
     * @var int
     */
    public $releaseCause;
    /**
     * Constructor method for voucherActivityImpl
     * @uses VoucherActivityImpl::setImsi()
     * @uses VoucherActivityImpl::setImei()
     * @uses VoucherActivityImpl::setMsisdn()
     * @uses VoucherActivityImpl::setCallDate()
     * @uses VoucherActivityImpl::setCalledNumber()
     * @uses VoucherActivityImpl::setCallDuration()
     * @uses VoucherActivityImpl::setRatedUnits()
     * @uses VoucherActivityImpl::setCountryName()
     * @uses VoucherActivityImpl::setRegionName()
     * @uses VoucherActivityImpl::setLac()
     * @uses VoucherActivityImpl::setLatMin()
     * @uses VoucherActivityImpl::setLatPol()
     * @uses VoucherActivityImpl::setLongMin()
     * @uses VoucherActivityImpl::setLongPol()
     * @uses VoucherActivityImpl::setTZIndicator()
     * @uses VoucherActivityImpl::setTZOffset()
     * @uses VoucherActivityImpl::setSetAltitude()
     * @uses VoucherActivityImpl::setCallingHC()
     * @uses VoucherActivityImpl::setCallingVC()
     * @uses VoucherActivityImpl::setReleaseCause()
     * @param string $imsi
     * @param string $imei
     * @param string $msisdn
     * @param string $callDate
     * @param string $calledNumber
     * @param int $callDuration
     * @param int $ratedUnits
     * @param string $countryName
     * @param string $regionName
     * @param string $lac
     * @param string $latMin
     * @param int $latPol
     * @param string $longMin
     * @param int $longPol
     * @param int $tZIndicator
     * @param string $tZOffset
     * @param int $setAltitude
     * @param int $callingHC
     * @param int $callingVC
     * @param int $releaseCause
     */
    public function __construct($imsi = null, $imei = null, $msisdn = null, $callDate = null, $calledNumber = null, $callDuration = null, $ratedUnits = null, $countryName = null, $regionName = null, $lac = null, $latMin = null, $latPol = null, $longMin = null, $longPol = null, $tZIndicator = null, $tZOffset = null, $setAltitude = null, $callingHC = null, $callingVC = null, $releaseCause = null)
    {
        $this
            ->setImsi($imsi)
            ->setImei($imei)
            ->setMsisdn($msisdn)
            ->setCallDate($callDate)
            ->setCalledNumber($calledNumber)
            ->setCallDuration($callDuration)
            ->setRatedUnits($ratedUnits)
            ->setCountryName($countryName)
            ->setRegionName($regionName)
            ->setLac($lac)
            ->setLatMin($latMin)
            ->setLatPol($latPol)
            ->setLongMin($longMin)
            ->setLongPol($longPol)
            ->setTZIndicator($tZIndicator)
            ->setTZOffset($tZOffset)
            ->setSetAltitude($setAltitude)
            ->setCallingHC($callingHC)
            ->setCallingVC($callingVC)
            ->setReleaseCause($releaseCause);
    }
    /**
     * Get imsi value
     * @return string|null
     */
    public function getImsi()
    {
        return $this->imsi;
    }
    /**
     * Set imsi value
     * @param string $imsi
     * @return \StructType\VoucherActivityImpl
     */
    public function setImsi($imsi = null)
    {
        // validation for constraint: string
        if (!is_null($imsi) && !is_string($imsi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($imsi)), __LINE__);
        }
        $this->imsi = $imsi;
        return $this;
    }
    /**
     * Get imei value
     * @return string|null
     */
    public function getImei()
    {
        return $this->imei;
    }
    /**
     * Set imei value
     * @param string $imei
     * @return \StructType\VoucherActivityImpl
     */
    public function setImei($imei = null)
    {
        // validation for constraint: string
        if (!is_null($imei) && !is_string($imei)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($imei)), __LINE__);
        }
        $this->imei = $imei;
        return $this;
    }
    /**
     * Get msisdn value
     * @return string|null
     */
    public function getMsisdn()
    {
        return $this->msisdn;
    }
    /**
     * Set msisdn value
     * @param string $msisdn
     * @return \StructType\VoucherActivityImpl
     */
    public function setMsisdn($msisdn = null)
    {
        // validation for constraint: string
        if (!is_null($msisdn) && !is_string($msisdn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($msisdn)), __LINE__);
        }
        $this->msisdn = $msisdn;
        return $this;
    }
    /**
     * Get callDate value
     * @return string|null
     */
    public function getCallDate()
    {
        return $this->callDate;
    }
    /**
     * Set callDate value
     * @param string $callDate
     * @return \StructType\VoucherActivityImpl
     */
    public function setCallDate($callDate = null)
    {
        // validation for constraint: string
        if (!is_null($callDate) && !is_string($callDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($callDate)), __LINE__);
        }
        $this->callDate = $callDate;
        return $this;
    }
    /**
     * Get calledNumber value
     * @return string|null
     */
    public function getCalledNumber()
    {
        return $this->calledNumber;
    }
    /**
     * Set calledNumber value
     * @param string $calledNumber
     * @return \StructType\VoucherActivityImpl
     */
    public function setCalledNumber($calledNumber = null)
    {
        // validation for constraint: string
        if (!is_null($calledNumber) && !is_string($calledNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($calledNumber)), __LINE__);
        }
        $this->calledNumber = $calledNumber;
        return $this;
    }
    /**
     * Get callDuration value
     * @return int|null
     */
    public function getCallDuration()
    {
        return $this->callDuration;
    }
    /**
     * Set callDuration value
     * @param int $callDuration
     * @return \StructType\VoucherActivityImpl
     */
    public function setCallDuration($callDuration = null)
    {
        // validation for constraint: int
        if (!is_null($callDuration) && !is_numeric($callDuration)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($callDuration)), __LINE__);
        }
        $this->callDuration = $callDuration;
        return $this;
    }
    /**
     * Get ratedUnits value
     * @return int|null
     */
    public function getRatedUnits()
    {
        return $this->ratedUnits;
    }
    /**
     * Set ratedUnits value
     * @param int $ratedUnits
     * @return \StructType\VoucherActivityImpl
     */
    public function setRatedUnits($ratedUnits = null)
    {
        // validation for constraint: int
        if (!is_null($ratedUnits) && !is_numeric($ratedUnits)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($ratedUnits)), __LINE__);
        }
        $this->ratedUnits = $ratedUnits;
        return $this;
    }
    /**
     * Get countryName value
     * @return string|null
     */
    public function getCountryName()
    {
        return $this->countryName;
    }
    /**
     * Set countryName value
     * @param string $countryName
     * @return \StructType\VoucherActivityImpl
     */
    public function setCountryName($countryName = null)
    {
        // validation for constraint: string
        if (!is_null($countryName) && !is_string($countryName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($countryName)), __LINE__);
        }
        $this->countryName = $countryName;
        return $this;
    }
    /**
     * Get regionName value
     * @return string|null
     */
    public function getRegionName()
    {
        return $this->regionName;
    }
    /**
     * Set regionName value
     * @param string $regionName
     * @return \StructType\VoucherActivityImpl
     */
    public function setRegionName($regionName = null)
    {
        // validation for constraint: string
        if (!is_null($regionName) && !is_string($regionName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($regionName)), __LINE__);
        }
        $this->regionName = $regionName;
        return $this;
    }
    /**
     * Get lac value
     * @return string|null
     */
    public function getLac()
    {
        return $this->lac;
    }
    /**
     * Set lac value
     * @param string $lac
     * @return \StructType\VoucherActivityImpl
     */
    public function setLac($lac = null)
    {
        // validation for constraint: string
        if (!is_null($lac) && !is_string($lac)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lac)), __LINE__);
        }
        $this->lac = $lac;
        return $this;
    }
    /**
     * Get latMin value
     * @return string|null
     */
    public function getLatMin()
    {
        return $this->latMin;
    }
    /**
     * Set latMin value
     * @param string $latMin
     * @return \StructType\VoucherActivityImpl
     */
    public function setLatMin($latMin = null)
    {
        // validation for constraint: string
        if (!is_null($latMin) && !is_string($latMin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($latMin)), __LINE__);
        }
        $this->latMin = $latMin;
        return $this;
    }
    /**
     * Get latPol value
     * @return int|null
     */
    public function getLatPol()
    {
        return $this->latPol;
    }
    /**
     * Set latPol value
     * @param int $latPol
     * @return \StructType\VoucherActivityImpl
     */
    public function setLatPol($latPol = null)
    {
        // validation for constraint: int
        if (!is_null($latPol) && !is_numeric($latPol)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($latPol)), __LINE__);
        }
        $this->latPol = $latPol;
        return $this;
    }
    /**
     * Get longMin value
     * @return string|null
     */
    public function getLongMin()
    {
        return $this->longMin;
    }
    /**
     * Set longMin value
     * @param string $longMin
     * @return \StructType\VoucherActivityImpl
     */
    public function setLongMin($longMin = null)
    {
        // validation for constraint: string
        if (!is_null($longMin) && !is_string($longMin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($longMin)), __LINE__);
        }
        $this->longMin = $longMin;
        return $this;
    }
    /**
     * Get longPol value
     * @return int|null
     */
    public function getLongPol()
    {
        return $this->longPol;
    }
    /**
     * Set longPol value
     * @param int $longPol
     * @return \StructType\VoucherActivityImpl
     */
    public function setLongPol($longPol = null)
    {
        // validation for constraint: int
        if (!is_null($longPol) && !is_numeric($longPol)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($longPol)), __LINE__);
        }
        $this->longPol = $longPol;
        return $this;
    }
    /**
     * Get tZIndicator value
     * @return int|null
     */
    public function getTZIndicator()
    {
        return $this->tZIndicator;
    }
    /**
     * Set tZIndicator value
     * @param int $tZIndicator
     * @return \StructType\VoucherActivityImpl
     */
    public function setTZIndicator($tZIndicator = null)
    {
        // validation for constraint: int
        if (!is_null($tZIndicator) && !is_numeric($tZIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($tZIndicator)), __LINE__);
        }
        $this->tZIndicator = $tZIndicator;
        return $this;
    }
    /**
     * Get tZOffset value
     * @return string|null
     */
    public function getTZOffset()
    {
        return $this->tZOffset;
    }
    /**
     * Set tZOffset value
     * @param string $tZOffset
     * @return \StructType\VoucherActivityImpl
     */
    public function setTZOffset($tZOffset = null)
    {
        // validation for constraint: string
        if (!is_null($tZOffset) && !is_string($tZOffset)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tZOffset)), __LINE__);
        }
        $this->tZOffset = $tZOffset;
        return $this;
    }
    /**
     * Get setAltitude value
     * @return int|null
     */
    public function getSetAltitude()
    {
        return $this->setAltitude;
    }
    /**
     * Set setAltitude value
     * @param int $setAltitude
     * @return \StructType\VoucherActivityImpl
     */
    public function setSetAltitude($setAltitude = null)
    {
        // validation for constraint: int
        if (!is_null($setAltitude) && !is_numeric($setAltitude)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($setAltitude)), __LINE__);
        }
        $this->setAltitude = $setAltitude;
        return $this;
    }
    /**
     * Get callingHC value
     * @return int|null
     */
    public function getCallingHC()
    {
        return $this->callingHC;
    }
    /**
     * Set callingHC value
     * @param int $callingHC
     * @return \StructType\VoucherActivityImpl
     */
    public function setCallingHC($callingHC = null)
    {
        // validation for constraint: int
        if (!is_null($callingHC) && !is_numeric($callingHC)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($callingHC)), __LINE__);
        }
        $this->callingHC = $callingHC;
        return $this;
    }
    /**
     * Get callingVC value
     * @return int|null
     */
    public function getCallingVC()
    {
        return $this->callingVC;
    }
    /**
     * Set callingVC value
     * @param int $callingVC
     * @return \StructType\VoucherActivityImpl
     */
    public function setCallingVC($callingVC = null)
    {
        // validation for constraint: int
        if (!is_null($callingVC) && !is_numeric($callingVC)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($callingVC)), __LINE__);
        }
        $this->callingVC = $callingVC;
        return $this;
    }
    /**
     * Get releaseCause value
     * @return int|null
     */
    public function getReleaseCause()
    {
        return $this->releaseCause;
    }
    /**
     * Set releaseCause value
     * @param int $releaseCause
     * @return \StructType\VoucherActivityImpl
     */
    public function setReleaseCause($releaseCause = null)
    {
        // validation for constraint: int
        if (!is_null($releaseCause) && !is_numeric($releaseCause)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($releaseCause)), __LINE__);
        }
        $this->releaseCause = $releaseCause;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VoucherActivityImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
