<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for voucherDenominationImpl StructType
 * Meta informations extracted from the WSDL
 * - type: tns:voucherDenominationImpl
 * @subpackage Structs
 */
class VoucherDenominationImpl extends AbstractStructBase
{
    /**
     * The displayName
     * @var string
     */
    public $displayName;
    /**
     * The voucherDenominationId
     * @var string
     */
    public $voucherDenominationId;
    /**
     * The voucherName
     * @var string
     */
    public $voucherName;
    /**
     * The voucherDenomination
     * @var int
     */
    public $voucherDenomination;
    /**
     * The maxPurchase
     * @var int
     */
    public $maxPurchase;
    /**
     * The extendActivation
     * @var string
     */
    public $extendActivation;
    /**
     * The extendRecharge
     * @var string
     */
    public $extendRecharge;
    /**
     * Constructor method for voucherDenominationImpl
     * @uses VoucherDenominationImpl::setDisplayName()
     * @uses VoucherDenominationImpl::setVoucherDenominationId()
     * @uses VoucherDenominationImpl::setVoucherName()
     * @uses VoucherDenominationImpl::setVoucherDenomination()
     * @uses VoucherDenominationImpl::setMaxPurchase()
     * @uses VoucherDenominationImpl::setExtendActivation()
     * @uses VoucherDenominationImpl::setExtendRecharge()
     * @param string $displayName
     * @param string $voucherDenominationId
     * @param string $voucherName
     * @param int $voucherDenomination
     * @param int $maxPurchase
     * @param string $extendActivation
     * @param string $extendRecharge
     */
    public function __construct($displayName = null, $voucherDenominationId = null, $voucherName = null, $voucherDenomination = null, $maxPurchase = null, $extendActivation = null, $extendRecharge = null)
    {
        $this
            ->setDisplayName($displayName)
            ->setVoucherDenominationId($voucherDenominationId)
            ->setVoucherName($voucherName)
            ->setVoucherDenomination($voucherDenomination)
            ->setMaxPurchase($maxPurchase)
            ->setExtendActivation($extendActivation)
            ->setExtendRecharge($extendRecharge);
    }
    /**
     * Get displayName value
     * @return string|null
     */
    public function getDisplayName()
    {
        return $this->displayName;
    }
    /**
     * Set displayName value
     * @param string $displayName
     * @return \StructType\VoucherDenominationImpl
     */
    public function setDisplayName($displayName = null)
    {
        // validation for constraint: string
        if (!is_null($displayName) && !is_string($displayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($displayName)), __LINE__);
        }
        $this->displayName = $displayName;
        return $this;
    }
    /**
     * Get voucherDenominationId value
     * @return string|null
     */
    public function getVoucherDenominationId()
    {
        return $this->voucherDenominationId;
    }
    /**
     * Set voucherDenominationId value
     * @param string $voucherDenominationId
     * @return \StructType\VoucherDenominationImpl
     */
    public function setVoucherDenominationId($voucherDenominationId = null)
    {
        // validation for constraint: string
        if (!is_null($voucherDenominationId) && !is_string($voucherDenominationId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($voucherDenominationId)), __LINE__);
        }
        $this->voucherDenominationId = $voucherDenominationId;
        return $this;
    }
    /**
     * Get voucherName value
     * @return string|null
     */
    public function getVoucherName()
    {
        return $this->voucherName;
    }
    /**
     * Set voucherName value
     * @param string $voucherName
     * @return \StructType\VoucherDenominationImpl
     */
    public function setVoucherName($voucherName = null)
    {
        // validation for constraint: string
        if (!is_null($voucherName) && !is_string($voucherName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($voucherName)), __LINE__);
        }
        $this->voucherName = $voucherName;
        return $this;
    }
    /**
     * Get voucherDenomination value
     * @return int|null
     */
    public function getVoucherDenomination()
    {
        return $this->voucherDenomination;
    }
    /**
     * Set voucherDenomination value
     * @param int $voucherDenomination
     * @return \StructType\VoucherDenominationImpl
     */
    public function setVoucherDenomination($voucherDenomination = null)
    {
        // validation for constraint: int
        if (!is_null($voucherDenomination) && !is_numeric($voucherDenomination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($voucherDenomination)), __LINE__);
        }
        $this->voucherDenomination = $voucherDenomination;
        return $this;
    }
    /**
     * Get maxPurchase value
     * @return int|null
     */
    public function getMaxPurchase()
    {
        return $this->maxPurchase;
    }
    /**
     * Set maxPurchase value
     * @param int $maxPurchase
     * @return \StructType\VoucherDenominationImpl
     */
    public function setMaxPurchase($maxPurchase = null)
    {
        // validation for constraint: int
        if (!is_null($maxPurchase) && !is_numeric($maxPurchase)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($maxPurchase)), __LINE__);
        }
        $this->maxPurchase = $maxPurchase;
        return $this;
    }
    /**
     * Get extendActivation value
     * @return string|null
     */
    public function getExtendActivation()
    {
        return $this->extendActivation;
    }
    /**
     * Set extendActivation value
     * @param string $extendActivation
     * @return \StructType\VoucherDenominationImpl
     */
    public function setExtendActivation($extendActivation = null)
    {
        // validation for constraint: string
        if (!is_null($extendActivation) && !is_string($extendActivation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($extendActivation)), __LINE__);
        }
        $this->extendActivation = $extendActivation;
        return $this;
    }
    /**
     * Get extendRecharge value
     * @return string|null
     */
    public function getExtendRecharge()
    {
        return $this->extendRecharge;
    }
    /**
     * Set extendRecharge value
     * @param string $extendRecharge
     * @return \StructType\VoucherDenominationImpl
     */
    public function setExtendRecharge($extendRecharge = null)
    {
        // validation for constraint: string
        if (!is_null($extendRecharge) && !is_string($extendRecharge)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($extendRecharge)), __LINE__);
        }
        $this->extendRecharge = $extendRecharge;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VoucherDenominationImpl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
