<?php
/**
 * This file aims to show you how to use this generated package.
 * In addition, the goal is to show which methods are available and the fist needed parameter(s)
 * You have to use an associative array such as:
 * - the key must be a constant beginning with WSDL_ from AbstractSoapClientbase class each generated ServiceType class extends this class
 * - the value must be the corresponding key value (each option matches a {@link http://www.php.net/manual/en/soapclient.soapclient.php} option)
 * $options = array(
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_URL => 'https://iws.iridium.com:8443/iws-current/iws?wsdl',
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_TRACE => true,
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_LOGIN => 'you_secret_login',
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_PASSWORD => 'you_secret_password',
 * );
 * etc....
 */
require_once __DIR__ . '/vendor/autoload.php';
/**
 * Minimal options
 */
$options = array(
    \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_URL => 'https://iws.iridium.com:8443/iws-current/iws?wsdl',
    \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_CLASSMAP => ClassMap::get(),
);
/**
 * Samples for Activate ServiceType
 */
$activate = new \ServiceType\Activate($options);
/**
 * Sample call for activateTelephonyScratchCards operation/method
 */
if ($activate->activateTelephonyScratchCards(new \StructType\ActivateTelephonyScratchCardsRequestImpl()) !== false) {
    print_r($activate->getResult());
} else {
    print_r($activate->getLastError());
}
/**
 * Sample call for activateSubscriber operation/method
 */
if ($activate->activateSubscriber(new \StructType\ActivateSubscriberRequestImpl()) !== false) {
    print_r($activate->getResult());
} else {
    print_r($activate->getLastError());
}
/**
 * Sample call for activateScratchCards operation/method
 */
if ($activate->activateScratchCards(new \StructType\ActivateScratchCardRequestImpl()) !== false) {
    print_r($activate->getResult());
} else {
    print_r($activate->getLastError());
}
/**
 * Samples for Get ServiceType
 */
$get = new \ServiceType\Get($options);
/**
 * Sample call for getModels operation/method
 */
if ($get->getModels(new \StructType\GetModelsRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getPrepaidAccountDetail operation/method
 */
if ($get->getPrepaidAccountDetail(new \StructType\GetPrepaidAccountDetailRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getEmailNotification operation/method
 */
if ($get->getEmailNotification(new \StructType\GetEmailNotificationRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getRechargeHistory operation/method
 */
if ($get->getRechargeHistory(new \StructType\GetRechargeHistoryRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getRoles operation/method
 */
if ($get->getRoles(new \StructType\GetRolesRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getPrepaidAccountSummary operation/method
 */
if ($get->getPrepaidAccountSummary(new \StructType\GetPrepaidAccountSummaryRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getAirlines operation/method
 */
if ($get->getAirlines(new \StructType\GetAirlinesRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getVerticals operation/method
 */
if ($get->getVerticals(new \StructType\GetVerticalsRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSubscriberAccount operation/method
 */
if ($get->getSubscriberAccount(new \StructType\GetSubscriberAccountRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getEvoucherInventory operation/method
 */
if ($get->getEvoucherInventory(new \StructType\GetEvoucherInventoryRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLocalNumberRegions operation/method
 */
if ($get->getLocalNumberRegions(new \StructType\GetLocalNumberRegionsRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getScratchCardBatches operation/method
 */
if ($get->getScratchCardBatches(new \StructType\GetScratchCardBatchesRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCallSummaryReport operation/method
 */
if ($get->getCallSummaryReport(new \StructType\GetCallSummaryReportRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getPrepaidCallHistory operation/method
 */
if ($get->getPrepaidCallHistory(new \StructType\GetPrepaidCallHistoryRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDataSpeeds operation/method
 */
if ($get->getDataSpeeds(new \StructType\GetDataSpeedsRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getVoucherDenominations operation/method
 */
if ($get->getVoucherDenominations(new \StructType\GetVoucherDenominationsRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getPrepaidPlans operation/method
 */
if ($get->getPrepaidPlans(new \StructType\GetPrepaidPlansRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSubscriberBaseReport operation/method
 */
if ($get->getSubscriberBaseReport(new \StructType\GetSubscriberBaseReportRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDevices operation/method
 */
if ($get->getDevices(new \StructType\GetDevicesRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDataBundles operation/method
 */
if ($get->getDataBundles(new \StructType\GetDataBundlesRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDemoAndTrialBundles operation/method
 */
if ($get->getDemoAndTrialBundles(new \StructType\GetDemoAndTrialBundlesRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getBurstDeviceBundles operation/method
 */
if ($get->getBurstDeviceBundles(new \StructType\GetBurstDeviceBundlesRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getTransactionHistoryReport operation/method
 */
if ($get->getTransactionHistoryReport(new \StructType\GetTransactionHistoryReportRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getAccountTransitionReport operation/method
 */
if ($get->getAccountTransitionReport(new \StructType\AccountTransitionReportRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getRealTimeCallDataReport operation/method
 */
if ($get->getRealTimeCallDataReport(new \StructType\GetRealTimeCallDataReportRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getBurstBroadcastCoverageAreas operation/method
 */
if ($get->getBurstBroadcastCoverageAreas(new \StructType\GetBurstBroadcastCoverageAreasRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSBDBundles operation/method
 */
if ($get->getSBDBundles(new \StructType\GetSBDBundlesRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSubscriberOrgDetail operation/method
 */
if ($get->getSubscriberOrgDetail(new \StructType\SubscriberOrgDetailReqImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLanguages operation/method
 */
if ($get->getLanguages(new \StructType\GetLanguagesRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getManufacturers operation/method
 */
if ($get->getManufacturers(new \StructType\GetManufacturersRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getBulkActionRequestReport operation/method
 */
if ($get->getBulkActionRequestReport(new \StructType\GetBulkActionReportRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getCommitmentPeriods operation/method
 */
if ($get->getCommitmentPeriods(new \StructType\GetCommitmentPeriodsRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getBundle operation/method
 */
if ($get->getBundle(new \StructType\GetBundleRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getRudicsGroups operation/method
 */
if ($get->getRudicsGroups(new \StructType\GetRudicsGroupsRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSystemStatus operation/method
 */
if ($get->getSystemStatus(new \StructType\AuthenticatedIwsRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getM2MBundles operation/method
 */
if ($get->getM2MBundles(new \StructType\GetM2MBundlesRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getModel operation/method
 */
if ($get->getModel(new \StructType\GetModelRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getResourceInventoryReport operation/method
 */
if ($get->getResourceInventoryReport(new \StructType\GetResourceInventoryReportRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getVCSBundles operation/method
 */
if ($get->getVCSBundles(new \StructType\GetVCSBundlesRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getServicePlan operation/method
 */
if ($get->getServicePlan(new \StructType\GetServicePlanRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSubscriberOrganizations operation/method
 */
if ($get->getSubscriberOrganizations(new \StructType\GetSubscriberOrgsRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getAccountPoolingGroups operation/method
 */
if ($get->getAccountPoolingGroups(new \StructType\GetAccountPoolingGroupsRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getServicePlans operation/method
 */
if ($get->getServicePlans(new \StructType\GetServicePlansRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getVoiceBundles operation/method
 */
if ($get->getVoiceBundles(new \StructType\GetVoiceBundlesRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getProgrammableButtons operation/method
 */
if ($get->getProgrammableButtons(new \StructType\GetProgrammableButtonsRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getScratchCardActivationStatus operation/method
 */
if ($get->getScratchCardActivationStatus(new \StructType\SearchScratchCardActivationStatusRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getScratchCards operation/method
 */
if ($get->getScratchCards(new \StructType\GetScratchCardsRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getLanguageChoices operation/method
 */
if ($get->getLanguageChoices(new \StructType\GetLanguageChoicesRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getPromoBundles operation/method
 */
if ($get->getPromoBundles(new \StructType\GetPromoBundlesRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getSubmarkets operation/method
 */
if ($get->getSubmarkets(new \StructType\GetSubmarketsRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getDemoAndTrialCounts operation/method
 */
if ($get->getDemoAndTrialCounts(new \StructType\GetDemoAndTrialCountsRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getProvisioningFailureReport operation/method
 */
if ($get->getProvisioningFailureReport(new \StructType\GetProvisioningFailureReportRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getAccountPoolingGroup operation/method
 */
if ($get->getAccountPoolingGroup(new \StructType\GetAccountPoolingGroupRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for getBurstSubscriptionNames operation/method
 */
if ($get->getBurstSubscriptionNames(new \StructType\GetBurstSubscriptionNamesRequestImpl()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Samples for Sbd ServiceType
 */
$sbd = new \ServiceType\Sbd($options);
/**
 * Sample call for sbdMOQueueReport operation/method
 */
if ($sbd->sbdMOQueueReport(new \StructType\SbdMOQueueReportRequestImpl()) !== false) {
    print_r($sbd->getResult());
} else {
    print_r($sbd->getLastError());
}
/**
 * Sample call for sbdDeletePendingDownloads operation/method
 */
if ($sbd->sbdDeletePendingDownloads(new \StructType\SbdDeletePendingDownloadsRequestImpl()) !== false) {
    print_r($sbd->getResult());
} else {
    print_r($sbd->getLastError());
}
/**
 * Sample call for sbdImeiSearch operation/method
 */
if ($sbd->sbdImeiSearch(new \StructType\SbdImeiSearchRequestImpl()) !== false) {
    print_r($sbd->getResult());
} else {
    print_r($sbd->getLastError());
}
/**
 * Sample call for sbdDestinationSearchReplace operation/method
 */
if ($sbd->sbdDestinationSearchReplace(new \StructType\DeliveryDestinationSearchAndReplaceRequestImpl()) !== false) {
    print_r($sbd->getResult());
} else {
    print_r($sbd->getLastError());
}
/**
 * Sample call for sbdMOQueuePurge operation/method
 */
if ($sbd->sbdMOQueuePurge(new \StructType\SbdMOQueuePurgeRequestImpl()) !== false) {
    print_r($sbd->getResult());
} else {
    print_r($sbd->getLastError());
}
/**
 * Samples for Validate ServiceType
 */
$validate = new \ServiceType\Validate($options);
/**
 * Sample call for validateDeviceString operation/method
 */
if ($validate->validateDeviceString(new \StructType\ValidateDeviceStringRequestImpl()) !== false) {
    print_r($validate->getResult());
} else {
    print_r($validate->getLastError());
}
/**
 * Samples for Create ServiceType
 */
$create = new \ServiceType\Create($options);
/**
 * Sample call for createSubscriberOrganization operation/method
 */
if ($create->createSubscriberOrganization(new \StructType\CreateSubscriberOrgRequestImpl()) !== false) {
    print_r($create->getResult());
} else {
    print_r($create->getLastError());
}
/**
 * Sample call for createUserProfile operation/method
 */
if ($create->createUserProfile(new \StructType\CreateUserProfileRequestImpl()) !== false) {
    print_r($create->getResult());
} else {
    print_r($create->getLastError());
}
/**
 * Samples for Refund ServiceType
 */
$refund = new \ServiceType\Refund($options);
/**
 * Sample call for refundPrepaidVoucher operation/method
 */
if ($refund->refundPrepaidVoucher(new \StructType\RefundPrepaidVoucherRequestImpl()) !== false) {
    print_r($refund->getResult());
} else {
    print_r($refund->getLastError());
}
/**
 * Samples for Subscribe ServiceType
 */
$subscribe = new \ServiceType\Subscribe($options);
/**
 * Sample call for subscribeBurstService operation/method
 */
if ($subscribe->subscribeBurstService(new \StructType\SubscribeBurstServiceRequestImpl()) !== false) {
    print_r($subscribe->getResult());
} else {
    print_r($subscribe->getLastError());
}
/**
 * Samples for Authenticated ServiceType
 */
$authenticated = new \ServiceType\Authenticated($options);
/**
 * Sample call for authenticatedPing operation/method
 */
if ($authenticated->authenticatedPing(new \StructType\AuthenticatedIwsRequestImpl()) !== false) {
    print_r($authenticated->getResult());
} else {
    print_r($authenticated->getLastError());
}
/**
 * Samples for Restricted ServiceType
 */
$restricted = new \ServiceType\Restricted($options);
/**
 * Sample call for restrictedSimSwap operation/method
 */
if ($restricted->restrictedSimSwap(new \StructType\RestrictedSimSwapRequestImpl()) !== false) {
    print_r($restricted->getResult());
} else {
    print_r($restricted->getLastError());
}
/**
 * Samples for User ServiceType
 */
$user = new \ServiceType\User($options);
/**
 * Sample call for userAuthenticate operation/method
 */
if ($user->userAuthenticate(new \StructType\UserAuthenticateRequestImpl()) !== false) {
    print_r($user->getResult());
} else {
    print_r($user->getLastError());
}
/**
 * Samples for Account ServiceType
 */
$account = new \ServiceType\Account($options);
/**
 * Sample call for accountUpdate operation/method
 */
if ($account->accountUpdate(new \StructType\AccountUpdateRequestImpl()) !== false) {
    print_r($account->getResult());
} else {
    print_r($account->getLastError());
}
/**
 * Sample call for accountSearch operation/method
 */
if ($account->accountSearch(new \StructType\AccountSearchRequestImpl()) !== false) {
    print_r($account->getResult());
} else {
    print_r($account->getLastError());
}
/**
 * Sample call for accountUpdateDevices operation/method
 */
if ($account->accountUpdateDevices(new \StructType\AccountUpdateDevicesRequestImpl()) !== false) {
    print_r($account->getResult());
} else {
    print_r($account->getLastError());
}
/**
 * Samples for Update ServiceType
 */
$update = new \ServiceType\Update($options);
/**
 * Sample call for updatePTTSubOrgStatus operation/method
 */
if ($update->updatePTTSubOrgStatus(new \StructType\UpdatePTTSubOrgStatusRequestImpl()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateEmailNotification operation/method
 */
if ($update->updateEmailNotification(new \StructType\UpdateEmailNotificationRequestImpl()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateUserProfile operation/method
 */
if ($update->updateUserProfile(new \StructType\UpdateUserProfileRequestImpl()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Sample call for updateSubscriberOrganization operation/method
 */
if ($update->updateSubscriberOrganization(new \StructType\UpdateSubscriberOrgRequestImpl()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Samples for Reset ServiceType
 */
$reset = new \ServiceType\Reset($options);
/**
 * Sample call for resetUserPassword operation/method
 */
if ($reset->resetUserPassword(new \StructType\ResetUserPasswordRequestImpl()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Sample call for resetTelephonyVMPin operation/method
 */
if ($reset->resetTelephonyVMPin(new \StructType\ResetTelephonyVMPinRequestImpl()) !== false) {
    print_r($reset->getResult());
} else {
    print_r($reset->getLastError());
}
/**
 * Samples for Ping ServiceType
 */
$ping = new \ServiceType\Ping($options);
/**
 * Sample call for ping operation/method
 */
if ($ping->ping() !== false) {
    print_r($ping->getResult());
} else {
    print_r($ping->getLastError());
}
/**
 * Samples for Load ServiceType
 */
$load = new \ServiceType\Load($options);
/**
 * Sample call for loadIMEI operation/method
 */
if ($load->loadIMEI(new \StructType\LoadIMEIRequestImpl()) !== false) {
    print_r($load->getResult());
} else {
    print_r($load->getLastError());
}
/**
 * Samples for Recharge ServiceType
 */
$recharge = new \ServiceType\Recharge($options);
/**
 * Sample call for rechargePrepaidAccount operation/method
 */
if ($recharge->rechargePrepaidAccount(new \StructType\RechargePrepaidAccountRequestImpl()) !== false) {
    print_r($recharge->getResult());
} else {
    print_r($recharge->getLastError());
}
/**
 * Samples for Search ServiceType
 */
$search = new \ServiceType\Search($options);
/**
 * Sample call for searchDeviceUsage operation/method
 */
if ($search->searchDeviceUsage(new \StructType\GetDeviceUsageReportRequestImpl()) !== false) {
    print_r($search->getResult());
} else {
    print_r($search->getLastError());
}
/**
 * Sample call for searchVoucherOrder operation/method
 */
if ($search->searchVoucherOrder(new \StructType\SearchVoucherInventoryRequestImpl()) !== false) {
    print_r($search->getResult());
} else {
    print_r($search->getLastError());
}
/**
 * Sample call for searchSimLock operation/method
 */
if ($search->searchSimLock(new \StructType\SearchSimLockRequestImpl()) !== false) {
    print_r($search->getResult());
} else {
    print_r($search->getLastError());
}
/**
 * Samples for Set ServiceType
 */
$set = new \ServiceType\Set($options);
/**
 * Sample call for setSubscriberAccountStatus operation/method
 */
if ($set->setSubscriberAccountStatus(new \StructType\AccountStatusChangeRequestImpl()) !== false) {
    print_r($set->getResult());
} else {
    print_r($set->getLastError());
}
/**
 * Samples for Find ServiceType
 */
$find = new \ServiceType\Find($options);
/**
 * Sample call for findServiceProviderProfile operation/method
 */
if ($find->findServiceProviderProfile(new \StructType\SearchSPProfileRequestImpl()) !== false) {
    print_r($find->getResult());
} else {
    print_r($find->getLastError());
}
/**
 * Sample call for findUserProfiles operation/method
 */
if ($find->findUserProfiles(new \StructType\FindUserProfilesRequestImpl()) !== false) {
    print_r($find->getResult());
} else {
    print_r($find->getLastError());
}
/**
 * Samples for Deactivate ServiceType
 */
$deactivate = new \ServiceType\Deactivate($options);
/**
 * Sample call for deactivateTelephonyScratchCard operation/method
 */
if ($deactivate->deactivateTelephonyScratchCard(new \StructType\DeactivateTelephonyScratchCardRequestImpl()) !== false) {
    print_r($deactivate->getResult());
} else {
    print_r($deactivate->getLastError());
}
/**
 * Samples for Revoke ServiceType
 */
$revoke = new \ServiceType\Revoke($options);
/**
 * Sample call for revokeRole operation/method
 */
if ($revoke->revokeRole(new \StructType\RevokeRoleRequestImpl()) !== false) {
    print_r($revoke->getResult());
} else {
    print_r($revoke->getLastError());
}
/**
 * Samples for Bulk ServiceType
 */
$bulk = new \ServiceType\Bulk($options);
/**
 * Sample call for bulkAccountUpdate operation/method
 */
if ($bulk->bulkAccountUpdate(new \StructType\BulkAccountUpdateRequestImpl()) !== false) {
    print_r($bulk->getResult());
} else {
    print_r($bulk->getLastError());
}
/**
 * Sample call for bulkActionSearch operation/method
 */
if ($bulk->bulkActionSearch(new \StructType\BulkActionSearchRequestImpl()) !== false) {
    print_r($bulk->getResult());
} else {
    print_r($bulk->getLastError());
}
/**
 * Samples for Delete ServiceType
 */
$delete = new \ServiceType\Delete($options);
/**
 * Sample call for deletePrepaidAccount operation/method
 */
if ($delete->deletePrepaidAccount(new \StructType\DeletePrepaidAccountRequestImpl()) !== false) {
    print_r($delete->getResult());
} else {
    print_r($delete->getLastError());
}
/**
 * Samples for Associate ServiceType
 */
$associate = new \ServiceType\Associate($options);
/**
 * Sample call for associateSimToImeiDevice operation/method
 */
if ($associate->associateSimToImeiDevice(new \StructType\AssociateSimToImeiRequestImpl()) !== false) {
    print_r($associate->getResult());
} else {
    print_r($associate->getLastError());
}
/**
 * Samples for Device ServiceType
 */
$device = new \ServiceType\Device($options);
/**
 * Sample call for deviceTransferOwner operation/method
 */
if ($device->deviceTransferOwner(new \StructType\DeviceTransferOwnerRequestImpl()) !== false) {
    print_r($device->getResult());
} else {
    print_r($device->getLastError());
}
/**
 * Samples for Send ServiceType
 */
$send = new \ServiceType\Send($options);
/**
 * Sample call for sendMessageToDevice operation/method
 */
if ($send->sendMessageToDevice(new \StructType\SendMessageToDeviceRequestImpl()) !== false) {
    print_r($send->getResult());
} else {
    print_r($send->getLastError());
}
/**
 * Samples for Mm ServiceType
 */
$mm = new \ServiceType\Mm($options);
/**
 * Sample call for m2mImeiSearch operation/method
 */
if ($mm->m2mImeiSearch(new \StructType\M2MImeiSearchRequestImpl()) !== false) {
    print_r($mm->getResult());
} else {
    print_r($mm->getLastError());
}
/**
 * Samples for Change ServiceType
 */
$change = new \ServiceType\Change($options);
/**
 * Sample call for changeUserProfileStatus operation/method
 */
if ($change->changeUserProfileStatus(new \StructType\ChangeUserProfileStatusRequestImpl()) !== false) {
    print_r($change->getResult());
} else {
    print_r($change->getLastError());
}
/**
 * Samples for Unlock ServiceType
 */
$unlock = new \ServiceType\Unlock($options);
/**
 * Sample call for unlockUser operation/method
 */
if ($unlock->unlockUser(new \StructType\UserUnlockRequestImpl()) !== false) {
    print_r($unlock->getResult());
} else {
    print_r($unlock->getLastError());
}
/**
 * Samples for Unsubscribe ServiceType
 */
$unsubscribe = new \ServiceType\Unsubscribe($options);
/**
 * Sample call for unsubscribeBurstService operation/method
 */
if ($unsubscribe->unsubscribeBurstService(new \StructType\UnsubscribeBurstServiceRequestImpl()) !== false) {
    print_r($unsubscribe->getResult());
} else {
    print_r($unsubscribe->getLastError());
}
/**
 * Samples for Grant ServiceType
 */
$grant = new \ServiceType\Grant($options);
/**
 * Sample call for grantRole operation/method
 */
if ($grant->grantRole(new \StructType\GrantRoleRequestImpl()) !== false) {
    print_r($grant->getResult());
} else {
    print_r($grant->getLastError());
}
